package com.huaxia.hx_sell_commission.config.desensitization;

import com.huaxia.hx_sell_commission.enums.SensitiveTypeEnum;
import com.huaxia.hx_sell_commission.utils.DesensitizedUtils;
import com.huaxia.hx_sell_commission.utils.StringUtils;
import org.springframework.format.Formatter;

import java.text.ParseException;
import java.util.Locale;

public class DesensitizedFormatter implements Formatter<String> {

    private SensitiveTypeEnum typeEnum;

    public SensitiveTypeEnum getTypeEnum() {
        return typeEnum;
    }

    public void setTypeEnum(SensitiveTypeEnum typeEnum) {
        this.typeEnum = typeEnum;
    }

    @Override
    public String parse(String valueStr, Locale locale) throws ParseException {
        if (StringUtils.isNotBlank(valueStr)) {
            switch (typeEnum) {
                case ID_CARD:
                    valueStr = DesensitizedUtils.idCardNum(valueStr);
                    break;
                default:
            }
        }
        return valueStr;
    }

    @Override
    public String print(String s, Locale locale) {
        return s;
    }

}
