package com.huaxia.hx_sell_commission.config.sso;

import com.cfld.sso.client.servlet.*;
import lombok.extern.log4j.Log4j;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.security.Principal;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author YanChengLong
 * @date 2019/7/9
 * @desc 重写 CheckLoginBean 方法
 */
@Log4j
public class CheckLoginBeanConfig {

    public static final int SCCESSED = 1;
    public static final int CROSS_DOMAIN_REDIRECT = 2;
    public static final int IVALID_COOKIE = 3;
    public static final int ACCESS_DENY = 4;
    public static final int LOGOUT = 5;
    public static final int PASS = 6;
    public static final int FORWARD = 7;
    private Object[] currentDomain = new Object[2];
    private ConfigUtilConfig configUtil = new ConfigUtilConfig();


    public CheckLoginBeanConfig() {
    }

    public ConfigUtilConfig getConfigUtil() {
        return this.configUtil;
    }

    public void setConfigUtil(ConfigUtilConfig configUtil) {
        if (configUtil != null) {
            this.configUtil = configUtil;
        }

    }

    protected void init() {
        this.getConfigUtil().loadConfig();
    }

    protected int processLogin(HttpServletRequest request, HttpServletResponse response, boolean saveHeader) throws IOException {
        this.init();
        int returnValue = 3;
        String requestURL = request.getRequestURL().toString();
        CookiesUtil cookiesUtil = new CookiesUtil(request, response);
        int fiterFlag = this.judgeFile(requestURL);
        String queryStr;
        String gotoUrl;
        String action;
        String challengeNumber;
        String queryString;
        if (fiterFlag == 0) {
            queryStr = request.getHeader("Referer");
            gotoUrl = this.getLocalDomainName(requestURL);
            action = gotoUrl.substring(gotoUrl.indexOf(46) + 1);
            int flag;
            String message;
            if (queryStr != null && queryStr.length() > 0 && !queryStr.contains(action)) {
                Map domainMap;
                Matcher matcher;
                Pattern pattern;
                for (flag = 0; flag < SsoClientUtils.DOMAIN_LIST.size(); ++flag) {
                    domainMap = (Map) SsoClientUtils.DOMAIN_LIST.get(flag);
                    pattern = (Pattern) domainMap.get("regex");
                    matcher = pattern.matcher(queryStr);
                    if (matcher.find()) {
                        StringBuffer sb = new StringBuffer("");
                        sb.append(domainMap.get("crossdomainUrl"));
                        sb.append("?");
                        sb.append("ReturnUrl=");
                        sb.append(URLTool.encodeURL(requestURL));
                        sb.append("&");
                        sb.append("ReturnHost=");
                        sb.append(URLTool.encodeURL(this.getLocalDomainName(requestURL)));
                        response.sendRedirect(sb.toString());
                        return 2;
                    }
                }

                for (flag = 0; flag < SsoClientUtils.DOMAIN_LIST.size(); ++flag) {
                    domainMap = (Map) SsoClientUtils.DOMAIN_LIST.get(flag);
                    pattern = (Pattern) domainMap.get("regex");
                    matcher = pattern.matcher(requestURL);
                    if (matcher.find()) {
                        message = domainMap.get("loginUrl").toString();
                        message = message + "?reason=enhancedSecurity&RetutnUrl=" + URLTool.encodeURL(requestURL);
                        response.sendRedirect(message);
                        return 4;
                    }
                }

                response.sendError(403);
                return 4;
            }

            flag = 0;

            try {
                flag = cookiesUtil.cookiesIsHave();
            } catch (Exception var17) {
                log.error(var17);
            }

            String url;
            if (flag != 0 && flag != 2 && flag != 4) {
                if (flag == 1) {
                    cookiesUtil.setFilterCookies();
                    if (cookiesUtil.getIsNologin() == 0) {
                        if (!saveHeader) {
                            request.setAttribute("loginid", cookiesUtil.getHashMap().get("logonUserID"));
                            challengeNumber = "<script type=\"text/javascript\">var wd_sso_menuInfo='" + cookiesUtil.getOriginalTokenSysStr() + "';" + " var wd_sso_sessionidname='" + SsoClientUtils.SESSIONID_NAME + "'; var wd_sso_passwordExpireDays=" + cookiesUtil.getHashMap().get("passwordExpireDays") + "; var realname='" + cookiesUtil.getOriginalTokenReaStr() + "';</script>";
                            request.setAttribute("wd_sso_menuInfo", challengeNumber);
                        } else {
                            challengeNumber = "<script type=\"text/javascript\">var wd_sso_menuInfo='" + cookiesUtil.getOriginalTokenSysStr() + "';" + " var wd_sso_sessionidname='" + SsoClientUtils.SESSIONID_NAME + "'; var wd_sso_passwordExpireDays=" + cookiesUtil.getHashMap().get("passwordExpireDays") + "; var realname='" + cookiesUtil.getOriginalTokenReaStr() + "';</script>";
                            Map<String, Principal> map = ((SSOHttpServletRequest) request).getPrincipalMap();
                            map.put("loginid", new SSOPrincipal((String) cookiesUtil.getHashMap().get("logonUserID")));
                            map.put("wd_sso_menuInfo", new SSOPrincipal(challengeNumber));
                        }
                    }

                    return 1;
                }

                if (flag == 3) {
                    challengeNumber = NumberTools.getClientRandem(256);
                    queryString = request.getQueryString();
                    if (queryString != null && !"".equals(queryString)) {
                        queryString = "?" + queryString;
                    } else {
                        queryString = "";
                    }

                    url = URLTool.encodeURL(requestURL + queryString);
                    message = "您没有访问该系统的权限";
                    String tempUrl = this.getDomain(requestURL).get("loginUrl") + "?challengeNumber=" + challengeNumber + "&flag=3&systemCode=" + SsoClientUtils.SYSTEM_CODE + "&RetutnUrl=" + url + "&message=" + URLTool.encodeURL(message);
                    response.sendRedirect(tempUrl);
                    returnValue = 4;
                }
            } else {
                challengeNumber = NumberTools.getClientRandem(256);
                queryString = request.getQueryString();
                if (queryString != null && !"".equals(queryString)) {
                    queryString = "?" + queryString;
                } else {
                    queryString = "";
                }

                url = URLTool.encodeURL(requestURL + queryString);
                message = this.getDomain(requestURL).get("loginUrl") + "?challengeNumber=" + challengeNumber + "&flag=3&systemCode=" + SsoClientUtils.SYSTEM_CODE + "&RetutnUrl=" + url;
                response.sendRedirect(message);
                returnValue = 3;
            }
        } else if (fiterFlag == 1) {
            queryStr = request.getQueryString();
            if (request.getSession(false) != null) {
                request.getSession().invalidate();
            }

            if (queryStr != null && queryStr.length() > 0) {
                gotoUrl = null;
                action = null;
                String[] queryArr = queryStr.split("&");
                int i = 0;

                while (true) {
                    if (i >= queryArr.length) {
                        if (action != null && !"exit".equals(action)) {
                            challengeNumber = gotoUrl != null && gotoUrl.length() != 0 ? gotoUrl : this.getDomain(requestURL).get("loginUrl").toString();
                            response.sendRedirect(challengeNumber);
                            break;
                        }

                        cookiesUtil.deleteCookies("AuthUser_AuthMAC");
                        cookiesUtil.deleteCookies("AuthUser_AuthNum");
                        cookiesUtil.deleteCookies("AuthUser_AuthToken");
                        challengeNumber = gotoUrl != null && gotoUrl.length() != 0 ? gotoUrl : request.getHeader("referer");
                        queryString = "http://" + this.getDomain(requestURL).get("myHost") + "/wd_sso_logout?action=exitall&url=" + URLTool.encodeURL(challengeNumber);
                        response.sendRedirect(queryString);
                        break;
                    }

                    String[] queryItem = queryArr[i].split("=");
                    if (queryItem.length == 2 && "action".equals(queryItem[0])) {
                        action = queryItem[1];
                    } else if (queryItem.length == 2 && "url".equals(queryItem[0])) {
                        gotoUrl = queryItem[1];
                    }

                    ++i;
                }
            } else {
                cookiesUtil.deleteCookies("AuthUser_AuthMAC");
                cookiesUtil.deleteCookies("AuthUser_AuthNum");
                cookiesUtil.deleteCookies("AuthUser_AuthToken");
                gotoUrl = this.getDomain(requestURL).get("loginUrl").toString();
                response.sendRedirect(gotoUrl);
            }

            returnValue = 5;
        } else if (fiterFlag == 3) {
            returnValue = 7;
        } else {
            returnValue = 6;
        }

        return returnValue;
    }

    private int judgeFile(String url) {
        if (SsoClientUtils.SSO_FILTER_FORWARDEXT.matcher(url).matches()) {
            return SsoClientUtils.SSO_FILTER_CONTENTEXT.matcher(url).matches() ? 1 : 3;
        } else if (SsoClientUtils.SSO_FILTER_EXT.matcher(url).matches()) {
            return SsoClientUtils.SSO_FILTER_CONTENTEXT.matcher(url).matches() ? 1 : 2;
        } else {
            return 0;
        }
    }

    private Map getDomain(String requestURL) {
        String domain = this.getLocalDomainName(requestURL);
        if (domain.equals(this.currentDomain[0])) {
            return (Map) this.currentDomain[1];
        } else {
            for (int i = 0; i < SsoClientUtils.DOMAIN_LIST.size(); ++i) {
                Map map = (Map) SsoClientUtils.DOMAIN_LIST.get(i);
                Pattern pattern = (Pattern) map.get("regex");
                Matcher matcher = pattern.matcher(domain);
                if (matcher.matches()) {
                    this.currentDomain[0] = domain;
                    this.currentDomain[1] = map;
                    return map;
                }
            }

            return new HashMap(2);
        }
    }

    private String getLocalDomainName(String requestURL) {
        String tempDomain = requestURL;
        int startIndex = requestURL.indexOf("//");
        if (startIndex >= 0) {
            tempDomain = requestURL.substring(startIndex + 2);
        }

        int endIndex = tempDomain.indexOf(47);
        if (endIndex > 0) {
            tempDomain = tempDomain.substring(0, endIndex);
        }

        return tempDomain.split(":|[?]", 2)[0];
    }

    protected int localModelFilter(HttpServletRequest request, HttpServletResponse response, boolean saveHeader) throws IOException {
        //int returnValue = false;
        String logon_page = SsoClientUtils.LOGON_URL;
        HttpSession session = request.getSession();
        String requestURL = request.getRequestURL().toString();
        if (this.judgeFile(requestURL) == 2) {
            return 6;
        } else if (this.judgeFile(requestURL) == 3) {
            return 7;
        } else {
            String request_uri = request.getRequestURI();
            String ctxPath = request.getContextPath();
            String uri = request_uri.substring(ctxPath.length());
            if (uri.indexOf("?") > 0) {
                uri = uri.substring(0, uri.indexOf("?"));
            }

            byte returnValue;
            if (logon_page.equals(uri)) {
                returnValue = 6;
            } else if (session != null && session.getAttribute("CFLD_SSO_UserName") != null && !session.getAttribute("CFLD_SSO_UserName").toString().equals("")) {
                if (!saveHeader) {
                    request.setAttribute("loginid", session.getAttribute("CFLD_SSO_UserName").toString());
                    request.setAttribute("wd_sso_menuInfo", (Object) null);
                } else {
                    Map<String, Principal> map = ((SSOHttpServletRequest) request).getPrincipalMap();
                    map.put("loginid", new SSOPrincipal(session.getAttribute("CFLD_SSO_UserName").toString()));
                    map.put("wd_sso_menuInfo", new SSOPrincipal((String) null));
                }

                returnValue = 1;
            } else {
                returnValue = 3;
            }

            return returnValue;
        }
    }
}
