package com.huaxia.hx_sell_commission.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.sql.Connection;
import java.sql.DriverManager;

@RestController
@RequestMapping("/balancing")
@Api(tags = "负载均衡连接数据库")
@Slf4j
public class Balancing {

    @Value("${spring.datasource.db1.driver-class-name}")
    private String className;

    @Value("${spring.datasource.db1.jdbc-url}")
    private String url;

    @Value("${spring.datasource.db1.username}")
    private String userName;

    @Value("${spring.datasource.db1.password}")
    private String password;

    @GetMapping(value = "/health", produces = "text/plain")
    @ApiOperation(value = "负载均衡连接数据库")
    public String health() {

        System.out.println(className + "," + url + "," + userName + "," + password );
        try{
            Class.forName(className);
            Connection connection = DriverManager.getConnection(url,userName,password);
        }catch(Exception e){
            e.printStackTrace();
            return "500NO";
        }
        return "200OK";

    }
}
