package com.huaxia.hx_sell_commission.controller;

import cn.hutool.poi.excel.ExcelUtil;
import cn.hutool.poi.excel.ExcelWriter;
import com.alibaba.fastjson.JSONObject;
import com.huaxia.hx_sell_commission.constant.Constants;
import com.huaxia.hx_sell_commission.domain.ExamineBill;
import com.huaxia.hx_sell_commission.domain.ExamineReportDetails;
import com.huaxia.hx_sell_commission.domain.SettlebillPaydetails;
import com.huaxia.hx_sell_commission.domain.SettlebillThirdbill;
import com.huaxia.hx_sell_commission.service.ExamineBillService;
import com.huaxia.hx_sell_commission.service.IPaymenttempService;
import com.huaxia.hx_sell_commission.service.SettlebillService;
import com.huaxia.hx_sell_commission.utils.AjaxResult;
import com.huaxia.hx_sell_commission.utils.MoneyUtils;
import com.huaxia.hx_sell_commission.vo.ExamineBillVo;
import com.huaxia.hx_sell_commission.vo.ExcelExamineBill;
import com.huaxia.hx_sell_commission.vo.TradeVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.math.BigDecimal;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/Report")
@Api(tags = "新增的报表相关接口")
@Slf4j
public class ReportController {


    /**
     * 核算单接口
     */
    @Autowired
    private ExamineBillService examineBillService;


    /**
     * 核算单接口
     */
    @Autowired
    private IPaymenttempService iPaymenttempService;

    @PostMapping("/PackageExamineBillDetailsShow")
    @ApiOperation(value = "计算核算单统计视图数据")
    public AjaxResult PackageExamineBillDetailsShow(@RequestBody ExamineBillVo examineBillVo) {
        log.info("\n 计算核算单统计视图数据[/Report/PackageExamineBillDetailsShow]请求参数：{}", JSONObject.toJSON(examineBillVo));
        List<ExcelExamineBill> examineBillList = iPaymenttempService.examineBillDetailsShow(examineBillVo);
        return AjaxResult.success("核算单统计视图数据", examineBillList);
    }


        @PostMapping("/ExamineBillDetailsShow")
        @ApiOperation(value = "核算单统计视图数据")
        public AjaxResult ExamineBillDetailsShow(@RequestBody ExamineBillVo examineBillVo) {
            log.info("\n 核算单统计视图数据[/Report/PackageExamineBillDetailsShow]请求参数：{}", JSONObject.toJSON(examineBillVo));
            List<ExcelExamineBill> examineBillList = iPaymenttempService.examineBillDetailsFind(examineBillVo);
            return AjaxResult.success("核算单统计视图数据", examineBillList);
        }
 /*
        @PostMapping("/ExamineBillDetailsShowNew")
        @ApiOperation(value = "核算单统计视图数据")
        public AjaxResult ExamineBillDetailsShowNew(@RequestBody ExamineBillVo examineBillVo) {
            log.info("\n 核算单统计视图数据[/Report/PackageExamineBillDetailsShow]请求参数：{}", JSONObject.toJSON(examineBillVo));
            List<ExcelExamineBill> examineBillList = iPaymenttempService.examineBillDetailsNew(examineBillVo);
            return AjaxResult.success("核算单统计视图数据", examineBillList);
        }



    @PostMapping("/examineBillUserSummaryExportNew")
    @ApiOperation(value = "核算单列表人员核发汇总报表导出")
    public AjaxResult examineBillUserSummaryExportNew(@RequestBody ExamineBillVo examineBillVo, HttpServletResponse response) {
        log.info("\n 核算单列表人员核发汇总报表导出[/examineBill/examineBillUserSummaryExportNew]请求参数：{}", JSONObject.toJSON(examineBillVo));
        AjaxResult res = new AjaxResult();
        try {
            String dateString = new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());
            String fileName =   "核算单核发表" + "-" + dateString ;
            response.reset();
            try {
                fileName = URLEncoder.encode(fileName, "UTF-8");
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
            response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".xlsx");
            ServletOutputStream out = response.getOutputStream();
            examineBillService.examineBillShowUserSummary(examineBillVo,out);
        } catch (IOException e) {
            e.printStackTrace();
        }
        log.info("result params : {}" , JSONObject.toJSON(res));
        return res;
    }


    @PostMapping("/examineBillSummaryExportNew")
    @ApiOperation(value = "核算单统计试图报表导出")
    public AjaxResult examineBillSummaryExportNew(@RequestBody ExamineBillVo examineBillVo, HttpServletResponse response){
        log.info("\n 核算单统计试图报表导出[/examineBill/examineBillSummaryExportNew]请求参数：{}", JSONObject.toJSON(examineBillVo));
        AjaxResult res = new AjaxResult();
        try {
            String dateString = new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());
            String fileName =   "核算单统计表" + "-" + dateString ;
            response.reset();
            try {
                fileName = URLEncoder.encode(fileName, "UTF-8");
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
            response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".xlsx");
            ServletOutputStream out = response.getOutputStream();
            examineBillService.examineBillShowSummary(examineBillVo,out);
        } catch (IOException e) {
            e.printStackTrace();
        }
        log.info("result params : {}" , JSONObject.toJSON(res));
        return res;
        //List<ExcelExamineBill> examineBillList = examineBillService.examineBillShowSummary(examineBillVo,out);
        //return AjaxResult.success("核算单列表展示", examineBillList);
    }

     */

}
