package com.huaxia.hx_sell_commission.controller;

import cn.hutool.poi.excel.ExcelUtil;
import cn.hutool.poi.excel.ExcelWriter;
import com.alibaba.fastjson.JSONObject;
import com.huaxia.hx_sell_commission.constant.Constants;
import com.huaxia.hx_sell_commission.domain.SettlebillPaydetails;
import com.huaxia.hx_sell_commission.domain.SettlebillThirdbill;
import com.huaxia.hx_sell_commission.service.SettlebillService;
import com.huaxia.hx_sell_commission.utils.AjaxResult;
import com.huaxia.hx_sell_commission.utils.MoneyUtils;
import com.huaxia.hx_sell_commission.vo.TradeVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/workflow")
@Api(tags = "工作流对接处理类")
@Slf4j
public class WorkflowController {


    @Autowired
    private SettlebillService settlebillService;

    @PostMapping("/updateThirdAndSettle")
    @ApiOperation(value = "修改结算单和审核单据")
    public AjaxResult updateThirdAndSettle(@RequestBody SettlebillThirdbill settlebillThirdbill) {
        log.info("\n 修改结算单和审核单据[/workflow/updateThirdAndSettle]请求参数：{}", JSONObject.toJSON(settlebillThirdbill));
        AjaxResult ajaxResult = settlebillService.updateThirdAndSettle(settlebillThirdbill);
        log.info("\n 修改结算单和审核单据[/workflow/updateThirdAndSettle]返回参数：{}", JSONObject.toJSON(null));
        return ajaxResult;
    }

    @GetMapping("/approvalShow")
    @ApiOperation(value = "结算单审批展示")
    public AjaxResult approvalShow(@RequestParam String businesskey) {
        log.info("\n结算单审批展示[/workflow/approvalShow]请求参数：{}", JSONObject.toJSON(businesskey));
        Map<String, Object> settlebillPaydetails = settlebillService.approvalShow(businesskey);
        log.info("\n 结算单审批展示[/workflow/approvalShow]返回参数：{}", JSONObject.toJSON(settlebillPaydetails));
        return AjaxResult.success("结算单审批展示成功", settlebillPaydetails);
    }

}
