package com.huaxia.hx_sell_commission.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;


/**
 * 核算单交易佣金列对象 examinebill_payment
 * 
 * @author shilei
 * @date 2020-11-23
 */
@Data
public class ExaminebillPayment
{
    private static final long serialVersionUID = 1L;

    /** 核算单ID */
    @Excel(name = "核算单ID")
    @ApiModelProperty(value = "核算单ID")
    private String examineid;

    /** 交易ID */
    @Excel(name = "交易ID")
    @ApiModelProperty(value = "交易ID")
    private String tradeguid;

    /** 佣金明细ID */
    @Excel(name = "佣金明细ID")
    @ApiModelProperty(value = "佣金明细ID")
    private String payid;

    /** 100：有效  200 失效 */
    @Excel(name = "100：有效  200 失效")
    @ApiModelProperty(value = "100：有效  200 失效")
    private Long status;

    /** 状态变更时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "状态变更时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "状态变更时间")
    private Date updatedate;

    /** 状态变更原因 */
    @Excel(name = "状态变更原因")
    @ApiModelProperty(value = "状态变更原因")
    private String updatereason;


    //==========表中没有=====

    /** 核算单名称 */
    @Excel(name = "核算单名称")
    @ApiModelProperty(value = "核算单名称")
    private String examineName;


}
