package com.huaxia.hx_sell_commission.domain;

import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;


/**
 * 对象 paymentdetails_log
 * 
 * @author shilei
 * @date 2020-11-20
 */
@Data
public class PaymentdetailsLog
{
    private static final long serialVersionUID = 1L;

    /** 佣金明细ID */
    @Excel(name = "佣金明细ID")
    @ApiModelProperty(value = "佣金明细ID")
    private String payid;

    /** 佣金方案ID */
    @Excel(name = "佣金方案ID")
    @ApiModelProperty(value = "佣金方案ID")
    private String planid;

    /** 交易ID */
    @Excel(name = "交易ID")
    @ApiModelProperty(value = "交易ID")
    private String tradeguid;

    /** 1 团购费 2 代理费  */
    @Excel(name = "1 团购费 2 代理费 ")
    @ApiModelProperty(value = "1 团购费 2 代理费 ")
    private Long plantype;

    /** 支付节点ID */
    @Excel(name = "支付节点ID")
    @ApiModelProperty(value = "支付节点ID")
    private String nodeid;

    /** 支付节点名称 */
    @Excel(name = "支付节点名称")
    @ApiModelProperty(value = "支付节点名称")
    private String nodename;

    /** 类别ID */
    @Excel(name = "类别ID")
    @ApiModelProperty(value = "类别ID")
    private String usertypeid;

    /** 类别名称 */
    @Excel(name = "类别名称")
    @ApiModelProperty(value = "类别名称")
    private String usertypename;

    /** 岗位 */
    @Excel(name = "岗位")
    @ApiModelProperty(value = "岗位")
    private String jobname;

    /** 人员 */
    @Excel(name = "人员")
    @ApiModelProperty(value = "人员")
    private String user;

    /** 人员Id */
    @Excel(name = "人员Id")
    @ApiModelProperty(value = "人员Id")
    private String userid;

    /** 支付总金额 */
    @Excel(name = "支付总金额")
    @ApiModelProperty(value = "支付总金额")
    private BigDecimal paytotal;

    /** 支付批次 10 首批 20 末批 */
    @Excel(name = "支付批次 10 首批 20 末批")
    @ApiModelProperty(value = "支付批次 10 首批 20 末批")
    private Long paybatch;

    /** 支付金额 */
    @Excel(name = "支付金额")
    @ApiModelProperty(value = "支付金额")
    private BigDecimal payable;

    /** 100：有效  200 失效 */
    @Excel(name = "100：有效  200 失效")
    @ApiModelProperty(value = "100：有效  200 失效")
    private Integer status;

    /** 状态变更时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "状态变更时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "状态变更时间")
    private Date updatedate;

    /** 状态变更原因 */
    @Excel(name = "状态变更原因")
    @ApiModelProperty(value = "状态变更原因")
    private String updatereason;

    @ApiModelProperty(value = "101：已生成，未发起核算，102：已生成，已发起核算")
    private Long statusDetail;

    @ApiModelProperty(value = "支付总金额比例")
    private BigDecimal payTotalRatio;

    @ApiModelProperty(value = "首/末批支付金额比例")
    private BigDecimal payableRatio;

}
