package com.huaxia.hx_sell_commission.domain;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NonNull;
import org.springframework.data.annotation.Transient;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;

/**
 * 对象 paymenttemp
 * 
 * @author shilei
 * @date 2020-11-16
 */
@Data
public class Paymenttemp
{

    /*
     *  @Null    被注释的元素必须为 null
        @NotNull     被注释的元素必须不为 null
        @AssertTrue  被注释的元素必须为 true
        @AssertFalse     被注释的元素必须为 false
        @Min(value)  被注释的元素必须是一个数字，其值必须大于等于指定的最小值
        @Max(value)  被注释的元素必须是一个数字，其值必须小于等于指定的最大值
        @DecimalMin(value)   被注释的元素必须是一个数字，其值必须大于等于指定的最小值
        @DecimalMax(value)   被注释的元素必须是一个数字，其值必须小于等于指定的最大值
        @Size(max, min)  被注释的元素的大小必须在指定的范围内
        @Digits (integer, fraction)  被注释的元素必须是一个数字，其值必须在可接受的范围内
        @Past    被注释的元素必须是一个过去的日期
        @Future  被注释的元素必须是一个将来的日期

     *
     *
     * message属性  验证失败提示的信息
     *
     */

    private static final long serialVersionUID = 1L;

    private String tempid;

    @Excel(name = "tempname")
    @ApiModelProperty(value = "模板名称")
    @NotNull(message="模板名称不能为空")
    private String tempname;

    /** 公司ID */
    @Excel(name = "公司ID")
    @ApiModelProperty(value = "公司ID")
    @NotNull(message="公司ID不能为空")
    private String companyguid;

    /** 公司 */
    @Excel(name = "公司")
    @ApiModelProperty(value = "公司")
    @NotNull(message="公司不能为空")
    private String companyname;

    /** 项目ID */
    @Excel(name = "项目ID")
    @ApiModelProperty(value = "项目ID")
    @NotNull(message="项目ID不能为空")
    private String hxprojectid;

    /** 项目 */
    @Excel(name = "项目")
    @ApiModelProperty(value = "项目")
    @NotNull(message="项目不能为空")
    private String hxprojectname;

    /** 1 团购费 2 代理费 */
    @Excel(name = "1 团购费 2 代理费")
    @ApiModelProperty(value = "模板类型：1 团购费 2 代理费")
    @NotNull(message="模板类型不能为空")
    private Long plantype;

    /** 当前状态 10 草稿 20 禁用 30 启用 */
    @Excel(name = "当前状态 10 草稿 20 禁用 30 启用")
    @ApiModelProperty(value = "当前状态 10 草稿 20 禁用 30 启用")
    private Long status;

    /** 当前状态 0 停用 1 正常 */
    @Excel(name = "当前状态 0 停用 1 正常")
    @ApiModelProperty(value = "当前状态 0 停用 1 正常")
    private Long stopUsing;

    /** 备注说明 */
    @Excel(name = "备注说明")
    @ApiModelProperty(value = "备注说明")
    private String remarks;

    /** 岗位分配标准 */
    @Excel(name = "岗位分配标准")
    @ApiModelProperty(value = "岗位分配标准")
//    @Min(value = 0, message = "报备人分配比例不能为空")
    private BigDecimal fixedratio;

    private BigDecimal nopay;

    /** 佣金包占可支配收入比例 */
    @Excel(name = "佣金包占可支配收入比例")
    @ApiModelProperty(value = "佣金包占可支配收入比例")
    private BigDecimal paymentpack;

    /** 税金比例：
             */
    @Excel(name = "税金比例")
    @ApiModelProperty(value = "税金比例：")
    private BigDecimal taxes;

    /** 1 系统抓取 2 固定金额 */
    @Excel(name = "1 系统抓取 2 固定金额")
    @ApiModelProperty(value = "1 系统抓取 2 固定金额(团购服务费) 3签约金额比例 4固定金额(拓客代理费)")
    private Long tokerfeetype;

    @ApiModelProperty(value = "佣金_拓客费用金额")
    private BigDecimal tokerfee;

    /** 服务费结算标准 */
    @Excel(name = "服务费结算标准")
    @ApiModelProperty(value = "服务费结算标准")
    private String serviceFeeSettlementStandard;

    @ApiModelProperty(value = "佣金_自销管理费比例")
    private BigDecimal manageratio;

    @ApiModelProperty(value = "佣金_支配收入比例")
    private BigDecimal controlratio;

    /** 1 比例 2 固定金额 */
    @Excel(name = "1 比例 2 固定金额")
    @ApiModelProperty(value = "1 比例 2 固定金额")
    private Long agencyfeetype;

    @ApiModelProperty(value = "代理费用金额")
    private BigDecimal agencyFee;

    @ApiModelProperty(value = "1 比例 2 固定金额")
    private Long jfbondtype;

    /** 交房保证金数值 */
    @Excel(name = "交房保证金数值")
    @ApiModelProperty(value = "交房保证金数值")
    private BigDecimal jfbond;

    @ApiModelProperty(value = "交房保证金是否扣除（0否,1是）")
    private Integer jfbondIsDeduct;

    private String createuserid;

    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date createdate;

    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date updatedate;

    private String updateuserid;

    // *******************以下字段不关联数据库***************************

    @ApiModelProperty(value = "附件集合")
    private List<PaymenttempFile> tempFiles;

    @ApiModelProperty(value = "支付节点集合")
    private List<PaymenttempNode> nodes;

    @ApiModelProperty(value = "分配人员集合")
    private List<PaymenttempDistribution> distributions;

    @ApiModelProperty(value = "创建开始时间")
    private Date startDate;

    @ApiModelProperty(value = "创建结束时间")
    private Date endDate;

    @ApiModelProperty(value = "状态范围")
    private List<Long> statusRange;

    @ApiModelProperty(value = "拓客费用")
    private BigDecimal tkAmount;

    @ApiModelProperty(value = "方案代理费用金额")
    private BigDecimal agencyAmount;

    @ApiModelProperty(value = "佣金_自销管理费费用")
    private BigDecimal manageAmount;

    @ApiModelProperty(value = "佣金_税金金额")
    private BigDecimal taxesAmount;

    @ApiModelProperty(value = "佣金_可支配收入占第三方拓客费")
    private BigDecimal controlAmount;

    @ApiModelProperty(value = "佣金_佣金包占可支配费用")
    private BigDecimal paymentpackAmount;

    @ApiModelProperty(value = "交易集合")
    private List<Trade> trades;

    @ApiModelProperty(value = "项目ID集合")
    private List<String> hxprojectids;

    @ApiModelProperty(value = "用户名")
    private String userName;

    /* 按钮权限 */
    @ApiModelProperty(value = "按钮权限列表")
    private List<String> button;

    @ApiModelProperty(value = "项目ID集合")
    private List<String> projectIds;

    @ApiModelProperty(value = "代理费用比例")
    private BigDecimal agencyFeeRatio;

    @ApiModelProperty(value = "团购费用比例")
    private BigDecimal tokerFeeRatio;

    private String tgtempid;
    private String dlftempid;

    private int appendStatus;
    private int appendType;
    @ApiModelProperty(value = "是否扣减【1 ：是，0：否 】")
    private Long isdeuct;

    @ApiModelProperty(value = "扣减方式：【1 固定扣减 、2 自定义扣减】")
    private Long deucttype;

    @ApiModelProperty(value = "扣减金额")
    private BigDecimal deuctVal;
}
