package com.huaxia.hx_sell_commission.domain;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import lombok.Data;


/**
 * 佣金方案详情对象 plan
 * 
 * @author shilei
 * @date 2020-11-18
 */
@Data
public class Plan
{
    private static final long serialVersionUID = 1L;

    /** 佣金方案ID */
    @ApiModelProperty(value = "佣金方案ID")
    private String planid;

    /** 交易ID */
    @ApiModelProperty(value = "交易ID")
    private String tradeguid;

    /** 团购费模板ID */
    @Excel(name = "团购费模板ID")
    @ApiModelProperty(value = "团购费模板ID")
    private String tgtempid;

    /** 代理费模板ID */
    @Excel(name = "代理费模板ID")
    @ApiModelProperty(value = "代理费模板ID")
    private String dlftempid;

    /** 状态 */
    @Excel(name = "状态")
    @ApiModelProperty(value = "状态(10草稿，20已生成未发起，30已生成发起，40作废，50退房)")
    private Long status;

    /** 创建人 */
    @Excel(name = "创建人")
    @ApiModelProperty(value = "创建人")
    private String createuser;

    /** 创建人ID */
    @Excel(name = "创建人ID")
    @ApiModelProperty(value = "创建人ID")
    private String createuserid;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "创建时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createdate;

    @ApiModelProperty(value = "更新人")
    private String updateUser;

    @ApiModelProperty(value = "更新人ID")
    private String updateUserID;

    @JsonFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty(value = "更新时间")
    private Date updateDate;

    private int appendStatus;
    private int appendType;

    @ApiModelProperty(value = "服务费扣减金额")
    private BigDecimal tgdeuctval;

    @ApiModelProperty(value = "接待费扣减金额")
    private BigDecimal dlfdeuctval;

    @ApiModelProperty(value = "服务费扣减说明")
    private String tgdeuctexplan;

    @ApiModelProperty(value = "接待费扣减说明")
    private String dlfdeuctexplan;
}
