package com.huaxia.hx_sell_commission.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;


/**
 * 佣金方案_支付节点对象 plan_paynode_log
 * 
 * @author shilei
 * @date 2020-11-20
 */
@Data
public class PlanPaynodeLog
{
    private static final long serialVersionUID = 1L;

    private String planid;

    private String tradeguid;

    private BigDecimal paytotal;

    /** 报备/接待(固定分配金额)通用字段 */
    @Excel(name = "报备/接待(固定分配金额)通用字段")
    @ApiModelProperty(value = "报备/接待(固定分配金额)通用字段")
    private BigDecimal fixfee;

    private BigDecimal nopay;

    /** 1 团购费 2 代理费 */
    @Excel(name = "1 团购费 2 代理费")
    @ApiModelProperty(value = "1 团购费 2 代理费")
    private Long plantype;

    /** 支付节点ID */
    @Excel(name = "支付节点ID")
    @ApiModelProperty(value = "支付节点ID")
    private String nodeid;

    /** 支付节点名称 */
    @Excel(name = "支付节点名称")
    @ApiModelProperty(value = "支付节点名称")
    private String nodename;

    @JsonFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty(value = "更新时间")
    private Date createDate;

    @ApiModelProperty(value = "固定分配金额可编辑（1是，0否）")
    private Integer fixFeeEdit;

    @ApiModelProperty(value = "人员ID")
    private String userId;

    @ApiModelProperty(value = "人员")
    private String user;

    @ApiModelProperty(value = "支付节点比例")
    private BigDecimal payRatio;

    @ApiModelProperty(value = "接待、报备人分配比例")
    private BigDecimal fixFeeRatio;

    @ApiModelProperty(value = "不予结算比例")
    private BigDecimal noPayRatio;

}
