package com.huaxia.hx_sell_commission.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;


/**
 * 后台人员结算方案明细对象 planbalance_log
 * 
 * @author shilei
 * @date 2020-11-20
 */
@Data
public class PlanbalanceLog
{
    private static final long serialVersionUID = 1L;

    /** 佣金方案ID */
    @Excel(name = "佣金方案ID")
    @ApiModelProperty(value = "佣金方案ID")
    private String planid;

    /** 交易ID */
    @Excel(name = "交易ID")
    @ApiModelProperty(value = "交易ID")
    private String tradeguid;

    /** 支付节点ID */
    @Excel(name = "支付节点ID")
    @ApiModelProperty(value = "支付节点ID")
    private String nodeid;

    /** 类别ID */
    @Excel(name = "类别ID")
    @ApiModelProperty(value = "类别ID")
    private String usertypeid;

    /** 类别名称 */
    @Excel(name = "类别名称")
    @ApiModelProperty(value = "类别名称")
    private String usertypename;

    /** 岗位 */
    @Excel(name = "岗位")
    @ApiModelProperty(value = "岗位")
    private String jobname;

    /** 人员 */
    @Excel(name = "人员")
    @ApiModelProperty(value = "人员")
    private String user;

    /** 人员Id */
    @Excel(name = "人员Id")
    @ApiModelProperty(value = "人员Id")
    private String userid;

    /** 支付总金额 */
    @Excel(name = "支付总金额")
    @ApiModelProperty(value = "支付总金额")
    private BigDecimal paytotal;

    /** 首批支付金额 */
    @Excel(name = "首批支付金额")
    @ApiModelProperty(value = "首批支付金额")
    private BigDecimal firstpay;

    /** 末批支付金额 */
    @Excel(name = "末批支付金额")
    @ApiModelProperty(value = "末批支付金额")
    private BigDecimal lastpay;

    /** 排序 */
    @Excel(name = "排序")
    @ApiModelProperty(value = "排序")
    private Long sort;

    @ApiModelProperty(value = "1 团购费 2 代理费")
    private Long planType;

    @ApiModelProperty(value = "首批支付金额可编辑（1是，0否）")
    private Long firstEdit;

    @ApiModelProperty(value = "末批支付金额可编辑（1是，0否）")
    private Long lastEdit;

    @JsonFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty(value = "更新时间")
    private Date createDate;

    @ApiModelProperty(value = "支付总金额比例")
    private BigDecimal payRatio;

    @ApiModelProperty(value = "首批支付金额比例")
    private BigDecimal firstPayRatio;

    @ApiModelProperty(value = "末批支付金额比例")
    private BigDecimal lastPayRatio;

}
