package com.huaxia.hx_sell_commission.domain;

import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;


/**
 * 佣金方案费用信息对象 planfee
 * 
 * @author shilei
 * @date 2020-11-18
 */
@Data
public class Planfee
{
    private static final long serialVersionUID = 1L;

    private String planid;

    /** 交易ID */
    @Excel(name = "交易ID")
    @ApiModelProperty(value = "交易ID")
    private String tradeguid;

    /** 团购费佣金手动 */
    @Excel(name = "团购费佣金手动")
    @ApiModelProperty(value = "团购费佣金手动")
    private BigDecimal tgfee;

    /** 团购费佣金调整说明 */
    @Excel(name = "团购费佣金调整说明")
    @ApiModelProperty(value = "团购费佣金调整说明")
    private String tgremarks;

    /** 代理费佣金手动 */
    @Excel(name = "代理费佣金手动")
    @ApiModelProperty(value = "代理费佣金手动")
    private BigDecimal agentfee;

    /** 代理费佣金调整说明 */
    @Excel(name = "代理费佣金调整说明")
    @ApiModelProperty(value = "代理费佣金调整说明")
    private String agentremarks;

    /** 更新人 */
    @Excel(name = "更新人")
    @ApiModelProperty(value = "更新人")
    private String createuser;

    /** 更新时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "更新时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "更新时间")
    private Date createdate;

    /** 更新人Id */
    @Excel(name = "更新人Id")
    @ApiModelProperty(value = "更新人Id")
    private String createuserid;


}
