package com.huaxia.hx_sell_commission.domain;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import lombok.Data;


/**
 * 结算单对象 settlebill
 * 
 * @author shilei
 * @date 2020-11-30
 */
@Data
public class Settlebill
{
    private static final long serialVersionUID = 1L;

    /** 结算单ID */
    private String settleid;

    /** 结算单名称 */
    @Excel(name = "结算单名称")
    @ApiModelProperty(value = "结算单名称")
    private String settlename;

    /** 公司ID */
    @Excel(name = "公司ID")
    @ApiModelProperty(value = "公司ID")
    private String companyguid;

    /** 公司 */
    @Excel(name = "公司")
    @ApiModelProperty(value = "公司")
    private String companyname;

    /** 项目ID */
    @Excel(name = "项目ID")
    @ApiModelProperty(value = "项目ID")
    private String hxprojectid;

    /** 项目 */
    @Excel(name = "项目")
    @ApiModelProperty(value = "项目")
    private String hxprojectname;

    /** 单据状态 */
    @Excel(name = "单据状态")
    @ApiModelProperty(value = "单据状态")
    private Long status;

    /** 流程状态 */
    @Excel(name = "流程状态")
    @ApiModelProperty(value = "流程状态")
    private Long flowstatus;

    /** 最后更新时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "最后更新时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "最后更新时间")
    private Date updatedate;

    /** 创建人 */
    @Excel(name = "创建人")
    @ApiModelProperty(value = "创建人")
    private String create;

    /** 创建人ID */
    @Excel(name = "创建人ID")
    @ApiModelProperty(value = "创建人ID")
    private String createid;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "创建时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createdate;

    /** 人力共享流程编号 */
    @Excel(name = "人力共享流程编号")
    @ApiModelProperty(value = "人力共享流程编号")
    private String thirdNO;

    /** 共享状态 */
    @Excel(name = "共享状态")
    @ApiModelProperty(value = "共享状态")
    private Long thirdStatus;

    /** 共享状态同步时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "共享状态同步时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "共享状态同步时间")
    private Date thirdUpdateDate;

}
