package com.huaxia.hx_sell_commission.domain;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import lombok.Data;


/**
 * 结算单人员结算明细对象 settlebill_paydetails
 * 
 * @author shilei
 * @date 2020-11-30
 */
@Data
public class SettlebillPaydetails
{
    private static final long serialVersionUID = 1L;

    /** 结算单ID */
    @Excel(name = "结算单ID")
    @ApiModelProperty(value = "结算单ID")
    private String settleid;

    /** 类别ID */
    @Excel(name = "类别ID")
    @ApiModelProperty(value = "类别ID")
    private String usertypeid;

    /** 类别名称 */
    @Excel(name = "类别名称")
    @ApiModelProperty(value = "类别名称")
    private String usertypename;

    /** 岗位 */
    @Excel(name = "岗位")
    @ApiModelProperty(value = "岗位")
    private String jobname;

    /** 人员 */
    @Excel(name = "人员")
    @ApiModelProperty(value = "人员")
    private String user;

    /** 人员Id */
    @Excel(name = "人员Id")
    @ApiModelProperty(value = "人员Id")
    private String userid;

    /** 支付总金额 */
    @Excel(name = "支付总金额")
    @ApiModelProperty(value = "支付总金额")
    private BigDecimal total;

    /** 扣款金额 */
    @Excel(name = "扣款金额")
    @ApiModelProperty(value = "扣款金额")
    private BigDecimal takeoff;

    /** 结算总金额 */
    @Excel(name = "结算总金额")
    @ApiModelProperty(value = "结算总金额")
    private BigDecimal pay;

    /** 银行名 */
    @Excel(name = "银行名")
    @ApiModelProperty(value = "银行名")
    private String bankname;

    /** 银行卡号 */
    @Excel(name = "银行卡号")
    @ApiModelProperty(value = "银行卡号")
    private String bankno;


    /** 人力共享流程编号 */
    @ApiModelProperty(value = "人力共享流程编号")
    private String thirdno;

    /** 公司 */
    @ApiModelProperty(value = "公司")
    private String companyName;

    /** 项目 */
    @ApiModelProperty(value = "项目")
    private String hxProjectName;

    /** 创建人 */
    @ApiModelProperty(value = "创建人")
    private String createName;

    /** 创建时间 */
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date createDate;


    //=============表中没有=====================
    /** 身份证号 */
    @ApiModelProperty(value = "身份证号")
    private String idCard;

    /** 手机号 */
    @ApiModelProperty(value = "手机号")
    private String mobile;

    /** 员工ID */
    @ApiModelProperty(value = "员工ID")
    private String nationalId;

    /** 员工状态 */
    @ApiModelProperty(value = "员工状态")
    private String dataStatus;

    /** 结算单名称 */
    @ApiModelProperty(value = "结算单名称")
    private String settlename;

    /** 公司id*/
    @ApiModelProperty(value = "公司id")
    private String companyGuid;

    /** 项目id */
    @ApiModelProperty(value = "项目id")
    private String hxProjectId;

    /** 单据状态 */
    @Excel(name = "单据状态")
    @ApiModelProperty(value = "单据状态")
    private Long status;


}
