package com.huaxia.hx_sell_commission.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;


/**
 * 结算单审核单据对象 settlebill_thirdbill
 * 
 * @author shilei
 * @date 2020-11-30
 */
@Data
public class SettlebillThirdbill
{
    private static final long serialVersionUID = 1L;

    /** 结算单ID */
    @Excel(name = "结算单ID")
    @ApiModelProperty(value = "结算单ID")
    private String settleid;

    /** 流程状态 */
    @Excel(name = "流程状态")
    @ApiModelProperty(value = "流程状态")
    private Long flowstatus;

    /** 流程状态变更时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "流程状态变更时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "流程状态变更时间")
    private Date flowupdatedate;

    /** 人力共享流程编号 */
    @Excel(name = "人力共享流程编号")
    @ApiModelProperty(value = "人力共享流程编号")
    private String thirdno;

    /** 共享状态 */
    @Excel(name = "共享状态")
    @ApiModelProperty(value = "共享状态")
    private Long thirdstatus;

    /** 共享状态同步时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "共享状态同步时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "共享状态同步时间")
    private Date thirdupdatedate;

    /** 创建人ID */
    @Excel(name = "创建人ID")
    @ApiModelProperty(value = "创建人ID")
    private String createid;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "创建时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createdate;

    /** 审批通过时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "审批通过时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "审批通过时间")
    private Date approvaldate;

    /** 创建人 */
    @Excel(name = "创建人")
    @ApiModelProperty(value = "创建人")
    private String create;

    /** 工作流程参数 */
    @Excel(name = "工作流程参数")
    @ApiModelProperty(value = "工作流程参数")
    private String businesskey;


    //========表中没有===========
    /** 最后更新时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "最后更新时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "最后更新时间")
    private Date updatedate;

    @Excel(name = "流程状态")
    @ApiModelProperty(value = "流程状态")
    private String flowstatusChinese;

    /** 单据状态 */
    @Excel(name = "单据状态")
    @ApiModelProperty(value = "单据状态")
    private Long status;

    /** 共享状态 */
    @Excel(name = "共享状态String类型")
    @ApiModelProperty(value = "共享状态String类型")
    private String thirdstatusChinese;

//    STATUS_D(2L, "待审核"),
//    STATUS_S(3L, "审核中"),
//    STATUS_Y(1L, "通过"),
//    STATUS_N(0L, "驳回"),
//    STATUS_Z(-1L, "终止"),
//    STATUS_C(-2L, "撤回");


//    待审核
//    审批中
//    驳回
//    已审核
//    撤回
//
//  工作流现有的状态

    public Long getFlowstatus() {
        if(flowstatusChinese != null && !flowstatusChinese.equals("")){
            if(flowstatusChinese.equals("待审核")){
                return 2L;
            }
            if(flowstatusChinese.equals("终止")){
                return -1L;
            }
            if(flowstatusChinese.equals("已审核")){
                return 1L;
            }
            if(flowstatusChinese.equals("审批中")){
                return 3L;
            }
            if(flowstatusChinese.equals("撤回")){
                return -2L;
            }
            if(flowstatusChinese.equals("驳回")){
                return 0L;
            }
        }
        return flowstatus;
    }

//    V - 数据已保存  601
//    S - 已提交     602
//    I -  审批中    603
//    A - 审批通过   604
//    D - 审批拒绝   605


    public Long getThirdstatus() {
        if(thirdstatusChinese != null && !thirdstatusChinese.equals("")){
            if(thirdstatusChinese.equals("V")){
                return 601L;
            }
            if(thirdstatusChinese.equals("S")){
                return 602L;
            }
            if(thirdstatusChinese.equals("I")){
                return 603L;
            }
            if(thirdstatusChinese.equals("A")){
                return 604L;
            }
            if(thirdstatusChinese.equals("D")){
                return 605L;
            }
        }
        return thirdstatus;
    }
}
