package com.huaxia.hx_sell_commission.domain;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import lombok.Data;


/**
 * 结算单交易佣金列对象 settlebill_trade
 * 
 * @author shilei
 * @date 2020-11-30
 */
@Data
public class SettlebillTrade
{
    private static final long serialVersionUID = 1L;

    /** 结算单ID */
    @Excel(name = "结算单ID")
    @ApiModelProperty(value = "结算单ID")
    private String settleid;

    /** 核算单ID */
    @Excel(name = "核算单ID")
    @ApiModelProperty(value = "核算单ID")
    private String examineid;

    /** 交易ID */
    @Excel(name = "交易ID")
    @ApiModelProperty(value = "交易ID")
    private String tradeguid;

    /** 佣金明细ID */
    @Excel(name = "佣金明细ID")
    @ApiModelProperty(value = "佣金明细ID")
    private String payid;

    /** 100：有效  200 失效 */
    @Excel(name = "100：有效  200 失效")
    @ApiModelProperty(value = "100：有效  200 失效")
    private Long status;

    /** 状态变更时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "状态变更时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "状态变更时间")
    private Date updatedate;

    /** 状态变更原因 */
    @Excel(name = "状态变更原因")
    @ApiModelProperty(value = "状态变更原因")
    private String updatereason;


}
