package com.huaxia.hx_sell_commission.domain;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import lombok.Data;


/**
 * 对象 trade
 * 
 * @author shilei
 * @date 2020-11-18
 */
@Data
public class Trade
{
    private static final long serialVersionUID = 1L;

    /** 交易ID */
    @ApiModelProperty(value = "交易ID")
    private String tradeguid;

    /** 合同ID */
    @Excel(name = "合同ID")
    @ApiModelProperty(value = "合同ID")
    private String contractguid;

    /** 认购金额 */
    @Excel(name = "认购金额")
    @ApiModelProperty(value = "认购金额")
    private BigDecimal cjtotal;

    @Excel(name = "拓客费用")
    @ApiModelProperty(value = "拓客费用")
    private BigDecimal tkAmount;

    /** 签约金额 */
    @Excel(name = "签约金额")
    @ApiModelProperty(value = "签约金额")
    private BigDecimal rmbhttotal;

    /** 认购时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "认购时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "认购时间")
    private Date orderQsdate;

    /** 签约时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "签约时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "签约时间")
    private Date contractQsdate;

    /** 项目ID */
    @Excel(name = "项目ID")
    @ApiModelProperty(value = "项目ID")
    private String projguid;

    /** 项目名称 */
    @Excel(name = "项目名称")
    @ApiModelProperty(value = "项目名称")
    private String projname;

    /** 楼栋ID */
    @Excel(name = "楼栋ID")
    @ApiModelProperty(value = "楼栋ID")
    private String bldguid;

    /** 楼栋 */
    @Excel(name = "楼栋")
    @ApiModelProperty(value = "楼栋")
    private String bldname;

    /** 房源ID */
    @Excel(name = "房源ID")
    @ApiModelProperty(value = "房源ID")
    private String roomguid;

    /** 房间名称 */
    @Excel(name = "房间名称")
    @ApiModelProperty(value = "房间名称")
    private String roominfo;

    /** 产品类型 */
    @Excel(name = "产品类型")
    @ApiModelProperty(value = "产品类型")
    private String productname;

    /** 业务类型 */
    @Excel(name = "业务类型")
    @ApiModelProperty(value = "业务类型")
    private String businesstype;

    /** 交易状态 */
    @Excel(name = "交易状态")
    @ApiModelProperty(value = "交易状态")
    private String tradestatus;

    /** 成交报备人ID */
    @Excel(name = "成交报备人ID")
    @ApiModelProperty(value = "成交报备人ID")
    private String referid;

    /** 成交报备人 */
    @Excel(name = "成交报备人")
    @ApiModelProperty(value = "成交报备人")
    private String refer;

    /** 报备人团队ID */
    @Excel(name = "报备人团队ID")
    @ApiModelProperty(value = "报备人团队ID")
    private String referteamguid;

    /** 报备人团队 */
    @Excel(name = "报备人团队")
    @ApiModelProperty(value = "报备人团队")
    private String referteam;

    /** 报备人公司ID */
    @Excel(name = "报备人公司ID")
    @ApiModelProperty(value = "报备人公司ID")
    private String referagentid;

    /** 报备人公司 */
    @Excel(name = "报备人公司")
    @ApiModelProperty(value = "报备人公司")
    private String referagentname;

    /** 成交接待人ID */
    @Excel(name = "成交接待人ID")
    @ApiModelProperty(value = "成交接待人ID")
    private String ywyid;

    /** 成交接待人 */
    @Excel(name = "成交接待人")
    @ApiModelProperty(value = "成交接待人")
    private String ywy;

    /** 接待人团队ID */
    @Excel(name = "接待人团队ID")
    @ApiModelProperty(value = "接待人团队ID")
    private String ywyteamguid;

    /** 接待人团队 */
    @Excel(name = "接待人团队")
    @ApiModelProperty(value = "接待人团队")
    private String ywyteamname;

    /** 接待人公司ID */
    @Excel(name = "接待人公司ID")
    @ApiModelProperty(value = "接待人公司ID")
    private String ywyagentid;

    /** 接待人公司 */
    @Excel(name = "接待人公司")
    @ApiModelProperty(value = "接待人公司")
    private String ywyagentname;

    /** 关闭时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "关闭时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "关闭时间")
    private Date closedate;

    /** 关闭原因 */
    @Excel(name = "关闭原因")
    @ApiModelProperty(value = "关闭原因")
    private String closereason;

    /** 交易类型 */
    @Excel(name = "交易类型")
    @ApiModelProperty(value = "交易类型")
    private String cjType;

    @ApiModelProperty(value = "成交报备人岗位名称")
    private String referJobName;

    @ApiModelProperty(value = "成交接待人岗位名称")
    private String ywyJobName;

    @ApiModelProperty(value = "项目ID")
    private String hxProjectId;

}
