package com.huaxia.hx_sell_commission.domain.csm;

import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 对象 csm_s_jobs
 * 
 * @author shilei
 * @date 2020-11-16
 */
@Data
public class CsmSJobs
{
    private static final long serialVersionUID = 1L;

    private String id;

    /** 组织机构ID */
    @Excel(name = "组织机构ID")
    @ApiModelProperty(value = "组织机构ID")
    private String orgid;

    /** 岗位名称 */
    @Excel(name = "岗位名称")
    @ApiModelProperty(value = "岗位名称")
    private String jobname;

    /** 岗位类型：-1为通用岗位 */
    @Excel(name = "岗位类型：-1为通用岗位")
    @ApiModelProperty(value = "岗位类型：-1为通用岗位")
    private String generaltype;

    /** 角色类型（字典表ID 集团；公司；项目） */
    @Excel(name = "角色类型", readConverterExp = "字=典表ID,集=团；公司；项目")
    @ApiModelProperty(value = "角色类型")
    private String jobdesc;

    /** 状态（1：启用；0：禁用） */
    @Excel(name = "状态", readConverterExp = "1=：启用；0：禁用")
    @ApiModelProperty(value = "状态")
    private Integer status;

    /** 此属性针对于非通用岗位
            1管理岗位
            2普通岗位 */
    @Excel(name = "此属性针对于非通用岗位")
    @ApiModelProperty(value = "此属性针对于非通用岗位 1管理岗位 2普通岗位")
    private Long jobfunction;

    /** 父级岗位 */
    @Excel(name = "父级岗位")
    @ApiModelProperty(value = "父级岗位")
    private String parentjobid;

    private Long jobtype;

    /** 排序号 */
    @Excel(name = "排序号")
    @ApiModelProperty(value = "排序号")
    private Long listindex;

    /** 3 集团
            2 项目
            1 公司 */
    @Excel(name = "3 集团")
    @ApiModelProperty(value = "3 集团 2 项目 1 公司")
    private Long hierarchy;

    /** 属性：1 内部岗位， 2 外部岗位 */
    @Excel(name = "属性：1 内部岗位， 2 外部岗位")
    @ApiModelProperty(value = "属性：1 内部岗位， 2 外部岗位")
    private Long attribute;

    private Integer mobileinterface;


}
