package com.huaxia.hx_sell_commission.domain.csm;

import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * 组织机构对象 csm_s_organization
 * 
 * @author shilei
 * @date 2020-11-16
 */
@Data
public class CsmSOrganization
{
    private static final long serialVersionUID = 1L;

    private String id;

    /** 组织机构代码 */
    @Excel(name = "组织机构代码")
    @ApiModelProperty(value = "组织机构代码")
    private String orgcode;

    /** 组织机构名称 */
    @Excel(name = "组织机构名称")
    @ApiModelProperty(value = "组织机构名称")
    private String orgname;

    /** 简称 */
    @Excel(name = "简称")
    @ApiModelProperty(value = "简称")
    private String shortname;

    /** 业态（字典表ID），如果选择的分类是公司，则显示此业态。 */
    @Excel(name = "业态", readConverterExp = "字=典表ID")
    @ApiModelProperty(value = "业态")
    private String tradeid;

    /** 组织机构分类（1：公司；2：部门；3：团队） */
    @Excel(name = "组织机构分类", readConverterExp = "1=：公司；2：部门；3：团队")
    @ApiModelProperty(value = "组织机构分类")
    private Long category;

    /** 排序 */
    @Excel(name = "排序")
    @ApiModelProperty(value = "排序")
    private Long listindex;

    /** 全路径 */
    @Excel(name = "全路径")
    @ApiModelProperty(value = "全路径")
    private String fullpath;

    /** 层级 */
    @Excel(name = "层级")
    @ApiModelProperty(value = "层级")
    private Long level;

    /** 父ID */
    @Excel(name = "父ID")
    @ApiModelProperty(value = "父ID")
    private String pid;

    /** 状态（1：启用；0：禁用） */
    @Excel(name = "状态", readConverterExp = "1=：启用；0：禁用")
    @ApiModelProperty(value = "状态")
    private Integer status;

    /** 组织机构类型
            0 部门
            1 项目部
            2 展厅
            3 公司
            4 团队
            -----以前类型-----
            0 其他
            1 售楼处
            2 展厅
            3 销售团队
            4 销售小组 */
    @Excel(name = "组织机构类型")
    @ApiModelProperty(value = "组织机构类型 0 部门 1 项目部 2 展厅 3 公司 4 团队 " +
            "-----以前类型----- 0 其他 1 售楼处 2 展厅 3 销售团队 4 销售小组")
    private String orgtype;

    /** 销售状态 SaleStatus 1 可卖，0 不可卖
            针对售楼处和展厅的业务 */
    @Excel(name = "销售状态")
    @ApiModelProperty(value = "销售状态 SaleStatus 1 可卖，0 不可卖 针对售楼处和展厅的业务")
    private String salestatus;

    /** 自销状态 	SelfStatus 1 自销，0代理，2分销
            针对团队的业务 */
    @Excel(name = "自销状态")
    @ApiModelProperty(value = "自销状态 	SelfStatus 1 自销，0代理，2分销 针对团队的业务")
    private Long selfstatus;

    private String salemodelid;

    private String teampropertiesid;

    private String appremark;

    private Long issaleorg;

    private String managejobsid;

    private String porgmjobsid;

    private String isliushou;

    private String areaname;

    // ***********************非数据库字段*************************
    @ApiModelProperty(value = "营销项目对象")
    private List<CsmSProject> project;

    @ApiModelProperty(value = "项目集合，逗号分隔")
    private String projectIds;

}
