package com.huaxia.hx_sell_commission.domain.csm;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * 营销项目对象 csm_s_project
 * 
 * @author shilei
 * @date 2020-11-16
 */
@Data
public class CsmSProject
{
    private static final long serialVersionUID = 1L;

    private String id;

    /** 	父级项目ID */
    @Excel(name = "	父级项目ID")
    @ApiModelProperty(value = "	父级项目ID")
    private String pid;

    /** 项目编号 */
    @Excel(name = "项目编号")
    @ApiModelProperty(value = "项目编号")
    private String projectno;

    /** 项目名称 */
    @Excel(name = "项目名称")
    @ApiModelProperty(value = "项目名称")
    private String projectname;

    /** 项目名称简称 */
    @Excel(name = "项目名称简称")
    @ApiModelProperty(value = "项目名称简称")
    private String projectnamesimple;

    /** 项目类型 1 自销 2代理 */
    @Excel(name = "项目类型 1 自销 2代理")
    @ApiModelProperty(value = "项目类型 1 自销 2代理")
    private String projecttype;

    /** 项目状态 1在售 2待售 3热销 4售罄 */
    @Excel(name = "项目状态 1在售 2待售 3热销 4售罄")
    @ApiModelProperty(value = "项目状态 1在售 2待售 3热销 4售罄")
    private String projectstatus;

    /** 项目简介 */
    @Excel(name = "项目简介")
    @ApiModelProperty(value = "项目简介")
    private String projectinfo;

    /** 经度 */
    @Excel(name = "经度")
    @ApiModelProperty(value = "经度")
    private String rayX;

    /** 纬度 */
    @Excel(name = "纬度")
    @ApiModelProperty(value = "纬度")
    private String rayY;

    /** 序号 */
    @Excel(name = "序号")
    @ApiModelProperty(value = "序号")
    private Long listindex;

    /** 是否启用 */
    @Excel(name = "是否启用")
    @ApiModelProperty(value = "是否启用")
    private Long isenabled;

    /** 是否删除 0: 未删除
            1: 已删除 */
    @Excel(name = "是否删除")
    @ApiModelProperty(value = "是否删除 0: 未删除 1: 已删除")
    private Long isdel;

    /** 层级 */
    @Excel(name = "层级")
    @ApiModelProperty(value = "层级")
    private Long levels;

    /** 是否叶子 */
    @Excel(name = "是否叶子")
    @ApiModelProperty(value = "是否叶子")
    private Long isend;

    /** 	销售开始时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "	销售开始时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "	销售开始时间")
    private Date bgnsaledate;

    /** 销售结束时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "销售结束时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "销售结束时间")
    private Date endsaledate;

    private String buname;

    private String buguid;

    /** 归属组织 */
    @Excel(name = "归属组织")
    @ApiModelProperty(value = "归属组织")
    private String orgid;

    /** 流程状态
            1已保存
            2审批中
            3已审批 */
    @Excel(name = "流程状态")
    @ApiModelProperty(value = "流程状态 1已保存 2审批中 3已审批")
    private Long flowstates;

    private String address;

    private String procharge;

    private String proadmin;

    // ***********************非数据库字段*************************
    @ApiModelProperty(value = "项目分期对象")
    private List<CsmSMyproject> myproject;


}
