package com.huaxia.hx_sell_commission.domain.csm;

import com.huaxia.hx_sell_commission.enums.SensitiveTypeEnum;
import com.huaxia.hx_sell_commission.utils.annotation.Desensitized;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * 对象 csm_s_user
 * 
 * @author shilei
 * @date 2020-11-16
 */
@Data
public class CsmSUser
{
    private static final long serialVersionUID = 1L;

    private String id;

    /** 系统登录名	 */
    @Excel(name = "系统登录名")
    @ApiModelProperty(value = "系统登录名")
    private String username;

    /** 密码 */
    @Excel(name = "密码")
    @ApiModelProperty(value = "密码")
    private String password;

    /** 工号 */
    @Excel(name = "工号")
    @ApiModelProperty(value = "工号")
    private String employeecode;

    /** 	姓名 */
    @Excel(name = "	姓名")
    @ApiModelProperty(value = "	姓名")
    private String employeename;

    /** 性别（1：男；2：女） */
    @Excel(name = "性别", readConverterExp = "1=：男；2：女")
    @ApiModelProperty(value = "性别")
    private Long gender;

    /** 办公电话 */
    @Excel(name = "办公电话")
    @ApiModelProperty(value = "办公电话")
    private String officetel;

    /** 移动电话 */
    @Excel(name = "移动电话")
    @ApiModelProperty(value = "移动电话")
    private String mobile;

    /** 	岗位ID */
    @Excel(name = "	岗位ID")
    @ApiModelProperty(value = "	岗位ID")
    private String jobid;

    /** 岗位名称 */
    @Excel(name = "岗位名称")
    @ApiModelProperty(value = "岗位名称")
    private String jobname;

    /** 部门ID */
    @Excel(name = "部门ID")
    @ApiModelProperty(value = "部门ID")
    private String unitid;

    /** 部门名称 */
    @Excel(name = "部门名称")
    @ApiModelProperty(value = "部门名称")
    private String unitname;

    /** 公司ID */
    @Excel(name = "公司ID")
    @ApiModelProperty(value = "公司ID")
    private String companyid;

    /** 司名称 */
    @Excel(name = "司名称")
    @ApiModelProperty(value = "司名称")
    private String companyname;

    /** 电子邮箱 */
    @Excel(name = "电子邮箱")
    @ApiModelProperty(value = "电子邮箱")
    private String officemail;

    /** 邮编 */
    @Excel(name = "邮编")
    @ApiModelProperty(value = "邮编")
    private String postcode;

    /** 地址 */
    @Excel(name = "地址")
    @ApiModelProperty(value = "地址")
    private String address;

    /** 0代理公司 
            1自销
            2内部
            3渠道 */
    @Excel(name = "0代理公司")
    @ApiModelProperty(value = "0代理公司  1自销 2内部 3渠道")
    private Long employeestatus;

    /** 状态（1：启用；0：禁用） */
    @Excel(name = "状态", readConverterExp = "1=：启用；0：禁用")
    @ApiModelProperty(value = "状态")
    private Integer status;

    /** 是否为部门负责人 */
    @Excel(name = "是否为部门负责人")
    @ApiModelProperty(value = "是否为部门负责人")
    private Integer isunitleader;

    private String creator;

    private String updator;

    private Long importstatus;

    @ApiModelProperty(value = "证件号码")
    @Desensitized(type = SensitiveTypeEnum.ID_CARD)
    private String idcard;

    private String education;

    private Long workyears;

    private String cardimg;

    private Date passwordmodifedt;

    private Date createTime;

    private Date updateTime;

    private Long isblacklist;

    private String orgName;


}
