package com.huaxia.hx_sell_commission.enums;

/**
 * Description: 按钮权限枚举类
 *
 * @author shilei
 * @date 2020/11/27
 */
public class ButtonEnum {

    /**
     * 佣金方案列表按钮权限
     */
    public enum PlanBtn {
        ADD_BTN("btn_add", "生成方案"),
        UPDATE_BTN("btn_update", "编辑"),
        INVALID_BTN("btn_invalid", "作废"),
        DEL_BTN("btn_del", "删除"),
        VIEW_BTN("btn_view", "查看"),
        ENABLE_BTN("btn_enable", "启用"),
        DISABLE_BTN("btn_disable", "禁用"),
        RECEDE_HOUSE_ACCOUNTS_BTN("btn_recede_house_accounts", "退房结算"),
        STOP_USING_BTN("btn_stop_using", "停用"),
        Append_Temp_BTN("append_temp", "追加");
        private final String code;
        private final String info;

        PlanBtn(String code, String info) {
            this.code = code;
            this.info = info;
        }

        public String getCode()
        {
            return code;
        }

        public String getInfo()
        {
            return info;
        }
    }


    /**
     * 核算单草稿按钮权限
     */
    public enum ExaminellBtn {
        UPDATE_BTN("btn_update", "编辑"),
        INVALID_BTN("btn_invalid", "作废"),
        VIEW_BTN("btn_view", "查看");

        private final String code;
        private final String info;

        ExaminellBtn(String code, String info) {
            this.code = code;
            this.info = info;
        }

        public String getCode()
        {
            return code;
        }

        public String getInfo()
        {
            return info;
        }
    }

}
