package com.huaxia.hx_sell_commission.enums;

/**
 * Description: 核算枚举类
 *
 * @author shilei
 * @date 2020/11/27
 */
public class ExamineEnum {

    /**
     * ExamineBill表状态
     */
    public enum ExamineBillStatus {
        STATUS_CG(201, "草稿"),
        STATUS_WX(206, "无效"),
        STATUS_ZF(202, "作废"),
        STATUS_DSH(203, "待审核"),
        STATUS_PASS(204, "通过"),
        STATUS_BH(205, "驳回");



        private final Integer code;
        private final String info;

        ExamineBillStatus(Integer code, String info) {
            this.code = code;
            this.info = info;
        }

        public Integer getCode()
        {
            return code;
        }

        public String getInfo()
        {
            return info;
        }
    }

    /**
     * ExamineBill_Payment表状态
     */
    public enum PaymentStatus {
        STATUS_Y(100L, "有效"),
        STATUS_N(200L, "失效");

        private final Long code;
        private final String info;

        PaymentStatus(Long code, String info) {
            this.code = code;
            this.info = info;
        }

        public Long getCode()
        {
            return code;
        }

        public String getInfo()
        {
            return info;
        }
    }

}
