package com.huaxia.hx_sell_commission.enums;

/**
 * Description: 佣金方案枚举类
 *
 * @author shilei
 * @date 2020/11/27
 */
public class PlanEnum {

    /**
     * Plan表状态
     */
    public enum PlanStatus {
        STATUS_CG(10L, "草稿"),
        STATUS_WFQ(20L, "已生成"),
        STATUS_ZF(40L, "作废"),
        STATUS_TF(50L, "退房");

        private final Long code;
        private final String info;

        PlanStatus(Long code, String info) {
            this.code = code;
            this.info = info;
        }

        public Long getCode()
        {
            return code;
        }

        public String getInfo()
        {
            return info;
        }
    }

    /**
     *  PaymentDetails表状态
     */
    public enum PaymentDetailsStatus {
        STATUS_Y(100, "有效"),
        STATUS_N(200, "失效");

        private final Integer code;
        private final String info;

        PaymentDetailsStatus(Integer code, String info) {
            this.code = code;
            this.info = info;
        }

        public Integer getCode()
        {
            return code;
        }

        public String getInfo()
        {
            return info;
        }
    }

    /**
     *  PaymentDetails表详细状态
     */
    public enum PaymentDetailsStatusDetail {
        STATUS_101(101L, "方案草稿"),
        STATUS_102(102L, "方案生成"),
        STATUS_103(103L, "方案作废"),
        STATUS_104(104L, "退房"),
        STATUS_201(201L, "核算草稿"),
        STATUS_202(202L, "核算作废"),
        STATUS_203(203L, "核算待审核"),
        STATUS_204(204L, "核算通过"),
        STATUS_205(205L, "核算驳回"),
        STATUS_300(300L, "草稿"),
        STATUS_301(301L, "已结算"),
        STATUS_ZF(302L, "作废"),
        STATUS_DSH(303L, "待审核"),
        STATUS_PASS(304L, "通过"),
        STATUS_BH(305L, "驳回"),
        STATUS_WX(306L, "无效"),
        STATUS_CH(307L, "撤回");
        private final Long code;
        private final String info;

        PaymentDetailsStatusDetail(Long code, String info) {
            this.code = code;
            this.info = info;
        }

        public Long getCode()
        {
            return code;
        }

        public String getInfo()
        {
            return info;
        }
    }

    /**
     *  PaymentDetails表支付批次
     */
    public enum PaymentDetailsPayBatch {
        PAY_FIRST(10L, "首批"),
        PAY_LAST(20L, "末批");

        private final Long code;
        private final String info;

        PaymentDetailsPayBatch(Long code, String info) {
            this.code = code;
            this.info = info;
        }

        public Long getCode()
        {
            return code;
        }

        public String getInfo()
        {
            return info;
        }
    }


    public enum PlanAppendStatus {
        NoAppend(0, "未追加"),
        AppendIng(1, "追加中"),
        AppendEnd(2, "追加完成");

        private final int code;
        private final String info;

        PlanAppendStatus(int code, String info) {
            this.code = code;
            this.info = info;
        }

        public int getCode()
        {
            return code;
        }

        public String getInfo()
        {
            return info;
        }
    }
}
