package com.huaxia.hx_sell_commission.enums;

/**
 * 描述:
 * 结算枚举类
 * @author: zcj
 * @Date: 2020/12/4
 */
public class SettleEnum {
    /**
     * SettleBill表状态
     */
    public enum SettleBillStatus {
        STATUS_CG(300L, "草稿"),
        STATUS_ZF(302L, "作废"),
        STATUS_DSH(303L, "待审核"),
        STATUS_PASS(304L, "通过"),
        STATUS_BH(305L, "驳回"),
        STATUS_WX(306L, "无效"),
        STATUS_CH(307L, "撤回"),
        STATUS_SHC(308L, "审核中"),
        STATUS_DEL(999L, "已删除");

        private final Long code;
        private final String info;

        SettleBillStatus(Long code, String info) {
            this.code = code;
            this.info = info;
        }

        public Long getCode() {
            return code;
        }

        public String getInfo() {
            return info;
        }
    }

    /**
     * SettleBill_Trade表状态
     */
    public enum TradeStatus {
        STATUS_Y(100L, "有效"),
        STATUS_N(200L, "失效");

        private final Long code;
        private final String info;

        TradeStatus(Long code, String info) {
            this.code = code;
            this.info = info;
        }

        public Long getCode() {
            return code;
        }

        public String getInfo()
        {
            return info;
        }
    }

    /**
     * SettleBill_ThirdBill表状态
     */
    public enum ThirdStatus {
        STATUS_D(2L, "待审核"),
        STATUS_S(3L, "审核中"),
        STATUS_Y(1L, "通过"),
        STATUS_N(0L, "驳回"),
        STATUS_Z(-1L, "终止"),
        STATUS_C(-2L, "撤回");

        private final Long code;
        private final String info;

        ThirdStatus(Long code, String info) {
            this.code = code;
            this.info = info;
        }

        public Long getCode() {
            return code;
        }

        public String getInfo()
        {
            return info;
        }
    }

    //    V - 数据已保存  601
    //    S - 已提交     602
    //    I -  审批中    603
    //    A - 审批通过   604
    //    D - 审批拒绝   605

    /**
     * SettleBill_ThirdBill表状态
     */
    public enum ThirdStatusLong {
        STATUS_D(601L, "数据已保存"),
        STATUS_S(602L, "已提交"),
        STATUS_Y(603L, "审批中"),
        STATUS_N(604L, "审批通过"),
        STATUS_Z(605L, "审批拒绝");

        private final Long code;
        private final String info;

        ThirdStatusLong(Long code, String info) {
            this.code = code;
            this.info = info;
        }

        public Long getCode() {
            return code;
        }

        public String getInfo()
        {
            return info;
        }
    }
}
