package com.huaxia.hx_sell_commission.exception;

import com.huaxia.hx_sell_commission.utils.AjaxResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

import java.util.HashMap;
import java.util.Map;

/**
 * Title: GlobalExceptionHandler
 * Description:
 *
 * @author shilei
 * @date 2020/11/10
 */
@RestControllerAdvice  //定义为切面拦截所有
@Slf4j
public class GlobalExceptionHandler {

//    @ExceptionHandler(RuntimeException.class)
//    public Map<String, Object> exceptionHandler(final RuntimeException ex) {
//        log.error(ex.getMessage());
//        Map<String, Object> result=new HashMap<String, Object>();
//        result.put("code","500");
//        if(ex.getMessage().length() > 100){
//            result.put("msg", "操作失败");
//        }else{
//            result.put("msg", ex.getMessage());
//        }
//        return result;
//    }

    @ExceptionHandler(CustomException.class)
    public Map<String, Object> customExceptionHandler(CustomException ex) {
        log.error(ex.getMessage());
        Map<String, Object> result=new HashMap<String, Object>();
        result.put("code", "500");
        if(ex.getMessage().length() > 100){
            result.put("msg", "操作失败");
        }else{
            result.put("msg", ex.getMessage());
        }
        return result;
    }

    @ExceptionHandler(IllegalArgumentException.class)
    public AjaxResult handleExceptionIllegalArgument(IllegalArgumentException e) {
        log.error(e.getMessage());
        return AjaxResult.error(e.getMessage());
    }

}
