package com.huaxia.hx_sell_commission.filter;

import cn.hutool.core.util.StrUtil;
import com.huaxia.hx_sell_commission.config.SysConfig;
import com.huaxia.hx_sell_commission.constant.Constants;
import lombok.extern.slf4j.Slf4j;

import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.concurrent.TimeUnit;

/**
 * @Desc 第三方调用接口鉴权
 * @Author shilei
 * @Date 2020/12/23
 */
@Slf4j
public class ThirdAuthenticationFilter implements Filter {

    @Override
    public void init(FilterConfig filterConfig) throws ServletException {

    }

    @Override
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain)
            throws IOException, ServletException {
        HttpServletRequest request = (HttpServletRequest) servletRequest;
        HttpServletResponse response = (HttpServletResponse) servletResponse;
        String token = request.getHeader(Constants.REQUEST_TOKEN);
        if(StrUtil.isNotBlank(token) && SysConfig.getSecretKey().equals(token)){
            filterChain.doFilter(request, response);
        }else{
            log.error("\n第三方鉴权失败，token：{}", token);
            response.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, "鉴权失败！");
        }
    }

    @Override
    public void destroy() {

    }

}
