package com.huaxia.hx_sell_commission.mapper.db1;

import com.huaxia.hx_sell_commission.domain.ExamineBill;
import com.huaxia.hx_sell_commission.vo.ExamineBillVo;
import com.huaxia.hx_sell_commission.vo.ExcelExamineBillSummaryVo;

import java.util.List;

/**
 * Mapper接口
 * 
 * @author qjcui
 * @date 2020-11-24
 */
public interface ExamineBillMapper {

    /**
     * 新增核算单
     *
     * @param examineBill 核算单
     * @return 结果
     */
    public int insertExaminebill(ExamineBill examineBill);

    /**
     * 修改状态
     * @param examineBill
     * @return
     */
    int updateExamineBill(ExamineBill examineBill);

    /**
     * 核算单展示
     * @param examineBillVo
     * @return
     */
    List<ExamineBill> examineBillShow(ExamineBillVo examineBillVo);


    /**
     * 查询核算单
     *
     * @param examineId 核算单ID
     * @return 核算单
     */
    public ExamineBill selectExaminebillById(String examineId);

    /**
     * 查询核算单列表
     *
     * @param examinebill 核算单
     * @return 核算单集合
     */
    public List<ExamineBill> selectExaminebillList(ExamineBill examinebill);


    /**
     * 修改核算单
     *
     * @param examinebill 核算单
     * @return 结果
     */
    public int updateExaminebill(ExamineBill examinebill);

    /**
     * 删除核算单
     *
     * @param examineid 核算单ID
     * @return 结果
     */
    public int deleteExaminebillById(String examineid);

    /**
     * 批量删除核算单
     *
     * @param examineids 需要删除的数据ID
     * @return 结果
     */
    public int deleteExaminebillByIds(String[] examineids);

    /**
     * 核算单添加去重
     * @param examineBill
     * @return
     */
    List<ExamineBill> selectExaminebill(ExamineBill examineBill);


    /**
     * 查结算单中核算单
     * @param examineBillVo
     * @return
     */
    List<ExamineBill> examineBillShow1(ExamineBillVo examineBillVo);

    /**
     * 根据核算单id查看核算单人员核发汇总
     * @param examineBillVo
     * @return
     */
    List<ExcelExamineBillSummaryVo> selectUserSummaryShow(ExamineBillVo examineBillVo);

    List<ExcelExamineBillSummaryVo> selectUserSummaryShowByWhere(ExamineBillVo examineBillVo);

    /**
     * 查看核算单的统计视图数据生成状态
     * @param examineBillVo
     * @return
     */
    ExamineBill examineBillShowReportstatus(ExamineBillVo examineBillVo);

}
