package com.huaxia.hx_sell_commission.mapper.db1;

import com.huaxia.hx_sell_commission.domain.ExamineBill;
import com.huaxia.hx_sell_commission.domain.ExaminebillPayment;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 核算单交易佣金列Mapper接口
 * 
 * @author shilei
 * @date 2020-11-23
 */
public interface ExaminebillPaymentMapper 
{

    /**
     * 新增核算单交易佣金列
     * 
     * @param examineBillPaymentList 核算单交易佣金列
     * @return 结果
     */
    public int insertExaminebillPayment(@Param("examineBillPaymentList") List<ExaminebillPayment> examineBillPaymentList);


    /**
     * 修改核算单交易佣金列
     *
     * @param examinebillPayment 核算单交易佣金列
     * @return 结果
     */
    public int updateExaminebillPayment(ExaminebillPayment examinebillPayment);






    /**
     * 查询核算单交易佣金列
     *
     * @param examineid 核算单交易佣金列ID
     * @return 核算单交易佣金列
     */
    public ExaminebillPayment selectExaminebillPaymentById(String examineid);

    /**
     * 查询核算单交易佣金列列表
     *
     * @param examinebillPayment 核算单交易佣金列
     * @return 核算单交易佣金列集合
     */
    public List<ExaminebillPayment> selectExaminebillPaymentList(ExaminebillPayment examinebillPayment);

    /**
     * 删除核算单交易佣金列
     *
     * @param examineid 核算单交易佣金列ID
     * @return 结果
     */
    public int deleteExaminebillPaymentById(String examineid);

    /**
     * 批量删除核算单交易佣金列
     *
     * @param examineids 需要删除的数据ID
     * @return 结果
     */
    public int deleteExaminebillPaymentByIds(String[] examineids);


    /**
     * 将方案中的首付改为不可编辑
     * @param examineBill
     */
    void updatePlanBalanceStatus1(ExamineBill examineBill);

    /**
     * 将方案中的首付改为可编辑
     * @param examineBill
     */
    void updatePlanBalanceStatus1Reverse(ExamineBill examineBill);

    /**
     * 将方案中的尾付改为不可编辑
     * @param examineBill
     */
    void updatePlanBalanceStatus2(ExamineBill examineBill);

    /**
     * 将方案中的尾付改为可编辑
     * @param examineBill
     */
    void updatePlanBalanceStatus2Reverse(ExamineBill examineBill);

    /**
     *  节点中的固定分配金额不可编辑
     * @param examineId
     */
    void updatePlanBalanceStatus3(@Param("examineId") String examineId);

    /**
     *  节点中的固定分配金额可编辑
     * @param examineId
     */
    void updatePlanBalanceStatus3Reverse(@Param("examineId") String examineId);

    /**
     * 根据核算单id和交易id修改关系表
     * @param examinebillPayment
     * @return
     */
    int updateStatusByExamineIdAndTradeguid(ExaminebillPayment examinebillPayment);
}
