package com.huaxia.hx_sell_commission.mapper.db1;

import com.huaxia.hx_sell_commission.domain.ExamineBill;
import com.huaxia.hx_sell_commission.domain.ExaminebillPayment;
import com.huaxia.hx_sell_commission.domain.ExaminebillTrade;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 核算单交易列Mapper接口
 * 
 * @author shilei
 * @date 2020-11-23
 */
public interface ExaminebillTradeMapper 
{

    /**
     * 新增核算单交易列
     * 
     * @param examineBillTradeList 核算单交易列
     * @return 结果
     */
    public int insertExaminebillTrade(@Param("examineBillTradeList") List<ExaminebillTrade> examineBillTradeList);


    /**
     * 查询核算单交易列
     *
     * @param examineid 核算单交易列ID
     * @return 核算单交易列
     */
    public ExaminebillTrade selectExaminebillTradeById(String examineid);

    /**
     * 查询核算单交易列列表
     *
     * @param examinebillTrade 核算单交易列
     * @return 核算单交易列集合
     */
    public List<String> selectExaminebillTradeList(ExamineBill examineBill);

    /**
     * 查询核算单交易列列表
     *
     * @param tradeguid
     * @return 核算单交易列集合
     */
    public List<ExaminebillTrade> selectExaminebillTradeListByTradeguid(String tradeguid);

    /**
     * 修改核算单交易列
     *
     * @param examinebillTrade 核算单交易列
     * @return 结果
     */
    public int updateExaminebillTrade(ExaminebillTrade examinebillTrade);

    /**
     * 删除核算单交易列
     *
     * @param examineid 核算单交易列ID
     * @return 结果
     */
    public int deleteExaminebillTradeById(String examineid);

    /**
     * 批量删除核算单交易列
     *
     * @param examineids 需要删除的数据ID
     * @return 结果
     */
    public int deleteExaminebillTradeByIds(String[] examineids);

    /**
     * 根据核算单id查佣金明细id
     * @param examineid
     */
    List<ExaminebillPayment> selectPayIdsById(@Param("examineid") String examineid);

    /**
     * 根据核算单id和交易id删除
     * @param examinebillPayment
     * @return
     */
    int deleteByExamineIdAndTradeguid(ExaminebillPayment examinebillPayment);
}
