package com.huaxia.hx_sell_commission.mapper.db1;

import java.math.BigDecimal;
import java.util.List;

import com.huaxia.hx_sell_commission.domain.*;
import com.huaxia.hx_sell_commission.vo.ExamineBillVo;
import com.huaxia.hx_sell_commission.vo.PaymentdetailsVo;
import com.huaxia.hx_sell_commission.vo.SettleBillVo;
import com.huaxia.hx_sell_commission.vo.TradeVo;
import org.apache.ibatis.annotations.Param;

/**
 * Mapper接口
 * 
 * @author shilei
 * @date 2020-11-20
 */
public interface PaymentdetailsMapper 
{
    /**
     * 查询
     * 
     * @param payid ID
     * @return 
     */
    public Paymentdetails selectPaymentdetailsById(String payid);

    /**
     * 查询列表
     * 
     * @param paymentdetails 
     * @return 集合
     */
    public List<Paymentdetails> selectPaymentdetailsList(Paymentdetails paymentdetails);

    /**
     * 查询列表
     *
     * @param paymentdetails
     * @return 集合
     */
    public List<Paymentdetails> selectPaymentdetailsList2(Paymentdetails paymentdetails);

    int deletePaymentdetailsList2(Paymentdetails paymentdetails);

    /**
     * 新增
     * 
     * @param paymentdetails 
     * @return 结果
     */
    public int insertPaymentdetails(Paymentdetails paymentdetails);

    /**
     * 修改
     * 
     * @param paymentdetails 
     * @return 结果
     */
    public int updatePaymentdetails(Paymentdetails paymentdetails);

    /**
     * 修改
     *
     * @param paymentdetails
     * @return 结果
     */
    public int updatePaymentdetails2(Paymentdetails paymentdetails);

    /**
     * 修改
     *
     * @param paymentdetails
     * @return 结果
     */
    public int updatePaymentdetails4(Paymentdetails paymentdetails);

    /**
     * 修改
     *
     * @param paymentdetails
     * @return 结果
     */
    public int updatePaymentdetails3(PaymentdetailsVo paymentdetails);

    /**
     * 删除
     * 
     * @param payid ID
     * @return 结果
     */
    public int deletePaymentdetailsById(String payid);

    /**
     * 删除
     *
     * @param paymentdetails
     * @return 结果
     */
    public int deletePaymentdetails(Paymentdetails paymentdetails);

    /**
     * 批量删除
     * 
     * @param payids 需要删除的数据ID
     * @return 结果
     */
    public int deletePaymentdetailsByIds(String[] payids);

    /**
     * 根据ids查数据
     * @param payId
     * @return
     */
    List<Paymentdetails> selectPaymentdetailsByIds(@Param("payId") List<String> payId);

    /**
     * 根据交易id查佣金详情
     * @param tradeIds
     * @return
     */
    List<TradeVo> selectPaymentdetailsByTradeIds(@Param("tradeIds") List<String> tradeIds);

    /**
     * 根据佣金明细查
     * @param examineBill
     * @return
     */
    List<TradeVo> selectPaymenttempAllByPayId(ExamineBill examineBill);

    /**
     * 根据核算表id查看详情
     * @param examineBillVo
     * @return
     */
    List<TradeVo> examineBillDetailsShow(ExamineBillVo examineBillVo);

    /**
     * 根据佣金明细id集合修改状态--改为草稿
     * @param payId
     * @return
     */
    int updatePaymentdetailsStatusByPayIds(@Param("payId") List<String> payId, @Param("status") Long status);

    /**
     * 根据单一的核算单id修改状态
     * @param examineBill
     * @return
     */
    int updateStatus(ExamineBill examineBill);


    /**
     * 批量新增详情表
     * @return
     */
    int insertPaymentdetailsList(@Param("paymentdetailsList") List<Paymentdetails> paymentdetailsList);

    /**
     * 根据交易明细id查明细集合
     * @param payids
     * @return
     */
    List<Paymentdetails> selectPaymentdetailsByPayIds(@Param("payids") List<String> payids);

    /**
     * 修改详情表状态
     * @param status, settleids
     */
    int updateStatusBySettleId(@Param("settleids") String settleids, @Param("status") Long status);



    /**
     * 通过流程id改状态
     * @param settlebillThirdbill1
     */
     int updatePaymentdetailsByBusinesskey(SettlebillThirdbill settlebillThirdbill1);

    /**
     * 根据核算单id查交易==导出
     * @param examineBillVo
     * @return
     */
    List<TradeVo> workTradeByExamineBillId(ExamineBillVo examineBillVo);

    /**
     * 根据核算单id和结算单id修改状态
     * @param settleBillVo
     * @return
     */
    int updateSettleStatus(SettleBillVo settleBillVo);

    /**
     * 根据核算单id和交易id修改详情状态
     * @param examinebillPayment
     * @return
     */
    int updateStatusByExamineIdAndTradeguid(ExaminebillPayment examinebillPayment);

    /**
     * 查询模板人员类别比例之和
     *
     * @param tempid 模板ID
     * @param userTypeId 人员类别ID
     * @return
     */
    BigDecimal selectUserTypePayRatioSum(@Param("tempid") String tempid, @Param("userTypeId") String userTypeId);

    BigDecimal selectPayTotalRatioSum(@Param("ExamineID") String ExamineID, @Param("userTypeId") String userTypeId, @Param("PlanType") int PlanType, @Param("TradeGUID") String TradeGUID);

    /**
     * 根据核算单id查询交易id和方案类型
     * @param examineBillVo
     * @return
     */
    List<TradeGuidPlanType> selectTradeGuidPlanTypeByExamineId(ExamineBillVo examineBillVo);

    ExamineBillNodeTotal getNodeSumMoneyTotal(@Param("examineId") String examineId, @Param("tradeGuid") String tradeGuid);
}
