package com.huaxia.hx_sell_commission.mapper.db1;

import java.util.List;
import com.huaxia.hx_sell_commission.domain.Paynode;

/**
 * 系统初始数据Mapper接口
 * 
 * @author shilei
 * @date 2020-11-16
 */
public interface PaynodeMapper 
{
    /**
     * 查询系统初始数据
     * 
     * @param paynodeid 系统初始数据ID
     * @return 系统初始数据
     */
    public Paynode selectPaynodeById(String paynodeid);

    /**
     * 查询系统初始数据列表
     * 
     * @param paynode 系统初始数据
     * @return 系统初始数据集合
     */
    public List<Paynode> selectPaynodeList(Paynode paynode);

    /**
     * 新增系统初始数据
     * 
     * @param paynode 系统初始数据
     * @return 结果
     */
    public int insertPaynode(Paynode paynode);

    /**
     * 修改系统初始数据
     * 
     * @param paynode 系统初始数据
     * @return 结果
     */
    public int updatePaynode(Paynode paynode);

    /**
     * 删除系统初始数据
     * 
     * @param paynodeid 系统初始数据ID
     * @return 结果
     */
    public int deletePaynodeById(String paynodeid);

    /**
     * 批量删除系统初始数据
     * 
     * @param paynodeids 需要删除的数据ID
     * @return 结果
     */
    public int deletePaynodeByIds(String[] paynodeids);
}
