package com.huaxia.hx_sell_commission.mapper.db1;

import java.util.List;

import com.huaxia.hx_sell_commission.domain.ExamineBill;
import com.huaxia.hx_sell_commission.domain.Plan;
import com.huaxia.hx_sell_commission.vo.PlanVo;
import com.huaxia.hx_sell_commission.vo.TradeVo;

/**
 * 佣金方案详情Mapper接口
 * 
 * @author shilei
 * @date 2020-11-18
 */
public interface PlanMapper 
{
    /**
     * 查询佣金方案详情
     * 
     * @param planid 佣金方案详情ID
     * @return 佣金方案详情
     */
    public Plan selectPlanById(String planid);

    /**
     * 查询佣金方案详情列表
     * 
     * @param plan 佣金方案详情
     * @return 佣金方案详情集合
     */
    public List<Plan> selectPlanList(Plan plan);

    /**
     * 查询佣金方案详情列表
     *
     * @param plan 佣金方案详情
     * @return 佣金方案详情集合
     */
    public List<PlanVo> selectPlanListByStatus(Plan plan);

    /**
     * 根据模板ID查询方案列表
     *
     * @param plan 佣金方案详情
     * @return 佣金方案详情集合
     */
    public List<Plan> selectPlanListById(Plan plan);

    /**
     * 新增佣金方案详情
     * 
     * @param plan 佣金方案详情
     * @return 结果
     */
    public int insertPlan(Plan plan);

    /**
     * 修改佣金方案详情
     * 
     * @param plan 佣金方案详情
     * @return 结果
     */
    public int updatePlan(Plan plan);

    /**
     * 删除佣金方案详情
     * 
     * @param planid 佣金方案详情ID
     * @return 结果
     */
    public int deletePlanById(String planid);

    /**
     * 删除佣金方案
     *
     * @param plan
     * @return 结果
     */
    public int updatePlanByTradeguid(Plan plan);

    /**
     * 批量删除佣金方案详情
     * 
     * @param planids 需要删除的数据ID
     * @return 结果
     */
    public int deletePlanByIds(String[] planids);

    /**
     * 修改佣金方案详情
     *
     * @param plan 佣金方案详情
     * @return 结果
     */
    public int updatePlanAppend(Plan plan2);

//    /**
//     * 核算单修改状态--待核算（已生成，已发起核算）等
//     * @param examineBill
//     */
//    void updateStatus(ExamineBill examineBill);



}
