package com.huaxia.hx_sell_commission.mapper.db1;

import java.util.HashMap;
import java.util.List;
import com.huaxia.hx_sell_commission.domain.PlanPaynode;

/**
 * 佣金方案_支付节点Mapper接口
 * 
 * @author shilei
 * @date 2020-11-18
 */
public interface PlanPaynodeMapper 
{
    /**
     * 查询佣金方案_支付节点
     * 
     * @param planid 佣金方案_支付节点ID
     * @return 佣金方案_支付节点
     */
    public PlanPaynode selectPlanPaynodeById(String planid);

    /**
     * 查询佣金方案_支付节点列表
     * 
     * @param planPaynode 佣金方案_支付节点
     * @return 佣金方案_支付节点集合
     */
    public List<PlanPaynode> selectPlanPaynodeList(PlanPaynode planPaynode);

    /**
     * 新增佣金方案_支付节点
     * 
     * @param planPaynode 佣金方案_支付节点
     * @return 结果
     */
    public int insertPlanPaynode(PlanPaynode planPaynode);

    /**
     * 修改佣金方案_支付节点
     * 
     * @param planPaynode 佣金方案_支付节点
     * @return 结果
     */
    public int updatePlanPaynode(PlanPaynode planPaynode);

    /**
     * 删除佣金方案_支付节点
     * 
     * @param planid 佣金方案_支付节点ID
     * @return 结果
     */
    public int deletePlanPaynodeById(String planid);

    /**
     * 批量删除佣金方案_支付节点
     * 
     * @param planids 需要删除的数据ID
     * @return 结果
     */
    public int deletePlanPaynodeByIds(String[] planids);


    /**
     * 删除佣金方案_支付节点
     *
     * @param planid 佣金方案
     * @return 结果
     */
    public int deletePlanPaynodeByIdAndPlayType(HashMap<String,Object> data);
}
