package com.huaxia.hx_sell_commission.mapper.db1;

import java.util.List;
import com.huaxia.hx_sell_commission.domain.PlanbalanceLog;

/**
 * 后台人员结算方案明细Mapper接口
 * 
 * @author shilei
 * @date 2020-11-20
 */
public interface PlanbalanceLogMapper 
{
    /**
     * 查询后台人员结算方案明细
     * 
     * @param planid 后台人员结算方案明细ID
     * @return 后台人员结算方案明细
     */
    public PlanbalanceLog selectPlanbalanceLogById(String planid);

    /**
     * 查询后台人员结算方案明细列表
     * 
     * @param planbalanceLog 后台人员结算方案明细
     * @return 后台人员结算方案明细集合
     */
    public List<PlanbalanceLog> selectPlanbalanceLogList(PlanbalanceLog planbalanceLog);

    /**
     * 新增后台人员结算方案明细
     * 
     * @param planbalanceLog 后台人员结算方案明细
     * @return 结果
     */
    public int insertPlanbalanceLog(PlanbalanceLog planbalanceLog);

    /**
     * 修改后台人员结算方案明细
     * 
     * @param planbalanceLog 后台人员结算方案明细
     * @return 结果
     */
    public int updatePlanbalanceLog(PlanbalanceLog planbalanceLog);

    /**
     * 删除后台人员结算方案明细
     * 
     * @param planid 后台人员结算方案明细ID
     * @return 结果
     */
    public int deletePlanbalanceLogById(String planid);

    /**
     * 批量删除后台人员结算方案明细
     * 
     * @param planids 需要删除的数据ID
     * @return 结果
     */
    public int deletePlanbalanceLogByIds(String[] planids);
}
