package com.huaxia.hx_sell_commission.mapper.db1;

import java.util.List;
import com.huaxia.hx_sell_commission.domain.Planbalance;

/**
 * 后台人员结算方案明细Mapper接口
 * 
 * @author shilei
 * @date 2020-11-18
 */
public interface PlanbalanceMapper 
{
    /**
     * 查询后台人员结算方案明细
     * 
     * @param planid 后台人员结算方案明细ID
     * @return 后台人员结算方案明细
     */
    public Planbalance selectPlanbalanceById(String planid);

    /**
     * 查询后台人员结算方案明细列表
     * 
     * @param planbalance 后台人员结算方案明细
     * @return 后台人员结算方案明细集合
     */
    public List<Planbalance> selectPlanbalanceList(Planbalance planbalance);

    /**
     * 新增后台人员结算方案明细
     * 
     * @param planbalance 后台人员结算方案明细
     * @return 结果
     */
    public int insertPlanbalance(Planbalance planbalance);

    /**
     * 修改后台人员结算方案明细
     * 
     * @param planbalance 后台人员结算方案明细
     * @return 结果
     */
    public int updatePlanbalance(Planbalance planbalance);

    /**
     * 删除后台人员结算方案明细
     * 
     * @param planid 后台人员结算方案明细ID
     * @return 结果
     */
    public int deletePlanbalanceById(String planid);

    /**
     * 删除后台人员结算方案明细
     *
     * @param planbalance
     * @return 结果
     */
    public int deletePlanbalanceByIdAndType(Planbalance planbalance);

    /**
     * 批量删除后台人员结算方案明细
     * 
     * @param planids 需要删除的数据ID
     * @return 结果
     */
    public int deletePlanbalanceByIds(String[] planids);
}
