package com.huaxia.hx_sell_commission.mapper.db1;

import java.util.List;
import com.huaxia.hx_sell_commission.domain.PlanfeeLog;

/**
 * 佣金方案费用信息Mapper接口
 * 
 * @author shilei
 * @date 2020-11-20
 */
public interface PlanfeeLogMapper 
{
    /**
     * 查询佣金方案费用信息
     * 
     * @param planid 佣金方案费用信息ID
     * @return 佣金方案费用信息
     */
    public PlanfeeLog selectPlanfeeLogById(String planid);

    /**
     * 查询佣金方案费用信息列表
     * 
     * @param planfeeLog 佣金方案费用信息
     * @return 佣金方案费用信息集合
     */
    public List<PlanfeeLog> selectPlanfeeLogList(PlanfeeLog planfeeLog);

    /**
     * 新增佣金方案费用信息
     * 
     * @param planfeeLog 佣金方案费用信息
     * @return 结果
     */
    public int insertPlanfeeLog(PlanfeeLog planfeeLog);

    /**
     * 修改佣金方案费用信息
     * 
     * @param planfeeLog 佣金方案费用信息
     * @return 结果
     */
    public int updatePlanfeeLog(PlanfeeLog planfeeLog);

    /**
     * 删除佣金方案费用信息
     * 
     * @param planid 佣金方案费用信息ID
     * @return 结果
     */
    public int deletePlanfeeLogById(String planid);

    /**
     * 批量删除佣金方案费用信息
     * 
     * @param planids 需要删除的数据ID
     * @return 结果
     */
    public int deletePlanfeeLogByIds(String[] planids);
}
