package com.huaxia.hx_sell_commission.mapper.db1;

import java.util.List;
import com.huaxia.hx_sell_commission.domain.Planfee;

/**
 * 佣金方案费用信息Mapper接口
 * 
 * @author shilei
 * @date 2020-11-18
 */
public interface PlanfeeMapper 
{
    /**
     * 查询佣金方案费用信息
     * 
     * @param planid 佣金方案费用信息ID
     * @return 佣金方案费用信息
     */
    public Planfee selectPlanfeeById(String planid);

    /**
     * 查询佣金方案费用信息列表
     * 
     * @param planfee 佣金方案费用信息
     * @return 佣金方案费用信息集合
     */
    public List<Planfee> selectPlanfeeList(Planfee planfee);

    /**
     * 新增佣金方案费用信息
     * 
     * @param planfee 佣金方案费用信息
     * @return 结果
     */
    public int insertPlanfee(Planfee planfee);

    /**
     * 修改佣金方案费用信息
     * 
     * @param planfee 佣金方案费用信息
     * @return 结果
     */
    public int updatePlanfee(Planfee planfee);

    /**
     * 删除佣金方案费用信息
     * 
     * @param planid 佣金方案费用信息ID
     * @return 结果
     */
    public int deletePlanfeeById(String planid);

    /**
     * 批量删除佣金方案费用信息
     * 
     * @param planids 需要删除的数据ID
     * @return 结果
     */
    public int deletePlanfeeByIds(String[] planids);
}
