package com.huaxia.hx_sell_commission.mapper.db1;

import java.util.List;

import com.huaxia.hx_sell_commission.domain.ExaminebillTrade;
import com.huaxia.hx_sell_commission.domain.Settlebill;
import com.huaxia.hx_sell_commission.domain.SettlebillExaminebill;
import com.huaxia.hx_sell_commission.vo.SettleBillVo;
import com.huaxia.hx_sell_commission.vo.TradeVo;
import org.apache.ibatis.annotations.Param;

/**
 * 结算单中的核算单Mapper接口
 * 
 * @author shilei
 * @date 2020-11-30
 */
public interface SettlebillExaminebillMapper 
{

    /**
     * 结算单管理
     * @param settleBillVo
     * @return
     */
    public List<SettleBillVo> settleBillShow(@Param("settleBillVo") SettleBillVo settleBillVo);
    /**
     * 查询结算单中核算单
     * @param settleBillVo
     * @return
     */
    public List<SettleBillVo> settlebillDetails(@Param("settleBillVo") SettleBillVo settleBillVo);

    /**
     * 选择交易条目-查看核算单
     * @param settleBillVo
     * @return
     */
    public List<TradeVo> examineBillShow2(SettleBillVo settleBillVo);

    /**
     * 根据payid获得核算单的交易
     * @param payid
     * @return
     */
    public SettleBillVo selectexaminebilltradebypayid(String payid);

    /**
     * 选择交易条目
     * @return
     */
    public List<SettleBillVo> settlebillTradeShow(@Param("settleBillVo") SettleBillVo settleBillVo);

    /**
     * 编辑结算单回显
     * @return
     */
    public List<SettleBillVo> settleBillPayDetailsShow(@Param("settleBillVo") SettleBillVo settleBillVo);

    /**
     * 查询结算单是否存在
     * @return
     */
    public Settlebill selectSettlebillByName(@Param("settleBillVo") SettleBillVo settleBillVo);

    /**
     * 查询结算单ID查询结算单
     * @param settleBillVo
     * @return
     */
    public SettleBillVo selectSettlebillByID(@Param("settleBillVo") SettleBillVo settleBillVo);

    /**
     * 新增结算单中的核算单
     * 
     * @param settlebillExaminebillList 结算单中的核算单
     * @return 结果
     */
    public int insertSettlebillExaminebill(@Param("settlebillExaminebillList")List<SettlebillExaminebill> settlebillExaminebillList);

    /**
     * 修改结算单中的核算单
     * 
     * @param settlebillExaminebill 结算单中的核算单
     * @return 结果
     */
    public int updateSettlebillExaminebill(SettlebillExaminebill settlebillExaminebill);

    /**
     * 删除结算单中的核算单
     * 
     * @param settleid 结算单中的核算单ID
     * @return 结果
     */
    public int deleteSettlebillExaminebillById(String settleid);

    /**
     * 查询结算单中核算单
     * @param settleid
     * @return
     */
    List<String> findExamineBillBySettleid(String settleid);
}
