package com.huaxia.hx_sell_commission.mapper.db1;

import java.util.List;
import com.huaxia.hx_sell_commission.domain.Settlebill;
import com.huaxia.hx_sell_commission.domain.SettlebillThirdbill;
import com.huaxia.hx_sell_commission.vo.SettleBillVo;
import org.apache.ibatis.annotations.Param;

/**
 * 结算单Mapper接口
 * 
 * @author shilei
 * @date 2020-11-30
 */
public interface SettlebillMapper {
    /**
     * 查询结算单
     * 
     * @param settleid 结算单ID
     * @return 结算单
     */
    public Settlebill selectSettlebillById(String settleid);

    /**
     * 查询结算单列表
     * 
     * @param settlebill 结算单
     * @return 结算单集合
     */
    public List<Settlebill> selectSettlebillList(Settlebill settlebill);

    /**
     * 新增结算单
     * 
     * @param settlebill 结算单
     * @return 结果
     */
    public int insertSettlebill(Settlebill settlebill);

    /**
     * 修改结算单
     * 
     * @param settleBillVo 结算单
     * @return 结果
     */
    public int updateSettlebill(SettleBillVo settleBillVo);

    /**
     * 根据结算单ID修改小状态
     * @return
     */
    public int PaymentDetailsupdateStatus(@Param("settleBillVo") SettleBillVo settleBillVo);

    /**
     * 修改结算单单据状态
     *
     * @param settlebill 结算单
     * @return 结果
     */
    public int updateSettlebillStatus(Settlebill settlebill);

    /**
     * 修改结算单流程状态
     *
     * @param settlebill 结算单
     * @return 结果
     */
    public int updateSettlebillFlowStatus(Settlebill settlebill);

    /**
     * 删除结算单
     * 
     * @param settleid 结算单ID
     * @return 结果
     */
    public int deleteSettlebillById(String settleid);

    /**
     * 批量删除结算单
     * 
     * @param settleids 需要删除的数据ID
     * @return 结果
     */
    public int deleteSettlebillByIds(String[] settleids);

    /**
     * 根据结算单审核单据的流程参数修改结算单的状态
     * @param settlebillThirdbill
     * @return
     */
    int updateThirdAndSettle(SettlebillThirdbill settlebillThirdbill);

    /**
     * 删除结算单和核算单的关系表
     * @param settleBillVo
     * @return
     */
    int deleteEmail(SettleBillVo settleBillVo);

    /**
     * 通过流程id查数据
     * @param thirdno
     * @return
     */
    Settlebill selectSettlebillByThirdno(String thirdno);
}
