package com.huaxia.hx_sell_commission.mapper.db1;

import java.util.List;
import com.huaxia.hx_sell_commission.domain.SettlebillPaydetails;
import com.huaxia.hx_sell_commission.vo.SettlebillPaydetailsVo;
import org.apache.ibatis.annotations.Param;

/**
 * 结算单人员结算明细Mapper接口
 * 
 * @author shilei
 * @date 2020-11-30
 */
public interface SettlebillPaydetailsMapper 
{
    /**
     * 查询结算单人员结算明细
     * 
     * @param settleid 结算单人员结算明细ID
     * @return 结算单人员结算明细
     */
    public SettlebillPaydetails selectSettlebillPaydetailsById(String settleid);

    /**
     * 查询结算单人员结算明细列表
     * 
     * @param settlebillPaydetails 结算单人员结算明细
     * @return 结算单人员结算明细集合
     */
    public List<SettlebillPaydetails> selectSettlebillPaydetailsList(SettlebillPaydetails settlebillPaydetails);

    /**
     * 查询结算单人员结算明细列表
     *
     * @param settlebillPaydetails 结算单人员结算明细
     * @return 结算单人员结算明细集合
     */
    public List<SettlebillPaydetailsVo> SettlebillPaydetailsList(SettlebillPaydetailsVo settlebillPaydetails);

    /**
     * 新增结算单人员结算明细0
     * 
     * @param settlebillPaydetails 结算单人员结算明细
     * @return 结果
     */
    public int insertSettlebillPaydetails(SettlebillPaydetails settlebillPaydetails);

    /**
     * 修改结算单人员结算明细
     * 
     * @param settlebillPaydetails 结算单人员结算明细
     * @return 结果
     */
    public int updateSettlebillPaydetails(SettlebillPaydetailsVo settlebillPaydetails);

    /**
     * 删除结算单人员结算明细
     * 
     * @param settleid 结算单人员结算明细ID
     * @return 结果
     */
    public int deleteSettlebillPaydetailsById(String settleid);

    /**
     * 批量删除结算单人员结算明细
     * 
     * @param settleids 需要删除的数据ID
     * @return 结果
     */
    public int deleteSettlebillPaydetailsByIds(String[] settleids);

    /**
     * 结算单审核展示---工作流
     * @param businesskey
     * @return
     */
    List<SettlebillPaydetails> approvalShow(@Param("businesskey") String businesskey);

    /**
     * 批量添加
     * @param settlebillPaydetailsArrayList
     * @return
     */
    int insertSettlebillPaydetailsList(@Param("settlebillPaydetailsArrayList") List<SettlebillPaydetails> settlebillPaydetailsArrayList);
}
