package com.huaxia.hx_sell_commission.mapper.db1;

import java.util.List;
import com.huaxia.hx_sell_commission.domain.SettlebillThirdbill;

/**
 * 结算单审核单据Mapper接口
 * 
 * @author shilei
 * @date 2020-11-30
 */
public interface SettlebillThirdbillMapper 
{
    /**
     * 查询结算单审核单据
     * 
     * @param settleid 结算单审核单据ID
     * @return 结算单审核单据
     */
    public SettlebillThirdbill selectSettlebillThirdbillById(String settleid);

    /**
     * 根据流程参数查询
     * @param businesskey
     * @return
     */
    public List<SettlebillThirdbill> selectSettlebillThirdbillBybusinesskey(String businesskey);
    /**
     * 查询结算单审核单据列表
     * 
     * @param settlebillThirdbill 结算单审核单据
     * @return 结算单审核单据集合
     */
    public List<SettlebillThirdbill> selectSettlebillThirdbillList(SettlebillThirdbill settlebillThirdbill);

    /**
     * 新增结算单审核单据
     * 
     * @param settlebillThirdbill 结算单审核单据
     * @return 结果
     */
    public int insertSettlebillThirdbill(SettlebillThirdbill settlebillThirdbill);

    /**
     * 修改结算单审核单据
     * 
     * @param settlebillThirdbill 结算单审核单据
     * @return 结果
     */
    public int updateSettlebillThirdbill(SettlebillThirdbill settlebillThirdbill);

    /**
     * 删除结算单审核单据
     * 
     * @param settleid 结算单审核单据ID
     * @return 结果
     */
    public int deleteSettlebillThirdbillById(String settleid);

    /**
     * 批量删除结算单审核单据
     * 
     * @param settleids 需要删除的数据ID
     * @return 结果
     */
    public int deleteSettlebillThirdbillByIds(String[] settleids);

    /**
     * 根据流程参数查询
     * @param settleid
     * @return
     */
    List<SettlebillThirdbill> selectSettlebillThirdbillBysettleBillId(String settleid);
}
