package com.huaxia.hx_sell_commission.mapper.db1;

import java.util.List;
import com.huaxia.hx_sell_commission.domain.SettlebillTrade;
import org.apache.ibatis.annotations.Param;

/**
 * 结算单交易佣金列Mapper接口
 * 
 * @author shilei
 * @date 2020-11-30
 */
public interface SettlebillTradeMapper 
{
    /**
     * 查询结算单交易佣金列
     * 
     * @param payid 结算单交易佣金列ID
     * @return 结算单交易佣金列
     */
    public List<SettlebillTrade> selectSettlebillTradeById(String payid);

    /**
     * 查询结算单交易佣金列列表
     * 
     * @param settlebillTrade 结算单交易佣金列
     * @return 结算单交易佣金列集合
     */
    public List<SettlebillTrade> selectSettlebillTradeList(SettlebillTrade settlebillTrade);

    /**
     * 新增结算单交易佣金列
     * 
     * @param settlebillTrade 结算单交易佣金列
     * @return 结果
     */
    public int insertSettlebillTrade(SettlebillTrade settlebillTrade);

    /**
     * 修改结算单交易佣金列
     * 
     * @param settlebillTrade 结算单交易佣金列
     * @return 结果
     */
    public int updateSettlebillTrade(SettlebillTrade settlebillTrade);

    /**
     * 删除结算单交易佣金列
     * 
     * @param settleid 结算单交易佣金列ID
     * @return 结果
     */
    public int deleteSettlebillTradeById(String settleid);

    /**
     * 批量删除结算单交易佣金列
     * 
     * @param settleids 需要删除的数据ID
     * @return 结果
     */
    public int deleteSettlebillTradeByIds(String[] settleids);


    public int insertSettlebillTradeList(@Param("payIds") List<String> payids,String SettleID);
}
