package com.huaxia.hx_sell_commission.mapper.db1;

import java.util.List;

import com.huaxia.hx_sell_commission.domain.ExamineBill;
import com.huaxia.hx_sell_commission.domain.Trade;
import com.huaxia.hx_sell_commission.vo.ExamineBillVo;
import com.huaxia.hx_sell_commission.vo.TradeVo;
import org.apache.ibatis.annotations.Param;

/**
 * Mapper接口
 * 
 * @author shilei
 * @date 2020-11-18
 */
public interface TradeMapper 
{


    /**
     * 查询
     * 
     * @param tradeguid ID
     * @return 
     */
    public Trade selectTradeById(String tradeguid);

    /**
     * 查询列表
     * 
     * @param trade 
     * @return 集合
     */
    public List<Trade> selectTradeList(Trade trade);

    /**
     * 查询列表
     *
     * @param trade
     * @return 集合
     */
    public List<TradeVo> selectTradeAllList(TradeVo trade);

    /**
     * 查询调整佣金
     *
     * @param trade
     * @return 集合
     */
    public List<TradeVo> getRegulateBrokerage(TradeVo trade);
    public List<TradeVo> getRegulateBrokerage2(TradeVo trade);
    public List<TradeVo> getRegulateBrokerageAppend(TradeVo trade);

    /**
     * 佣金明细查看、预览
     *
     * @param trade
     * @return 集合
     */
    public List<TradeVo> getPlanDetails(TradeVo trade);

    /**
     * 新增
     * 
     * @param trade 
     * @return 结果
     */
    public int insertTrade(Trade trade);

    /**
     * 修改
     * 
     * @param trade 
     * @return 结果
     */
    public int updateTrade(Trade trade);

    /**
     * 删除
     * 
     * @param tradeguid ID
     * @return 结果
     */
    public int deleteTradeById(String tradeguid);

    /**
     * 批量删除
     * 
     * @param tradeguids 需要删除的数据ID
     * @return 结果
     */
    public int deleteTradeByIds(String[] tradeguids);

    /**
     * 根据交易id修改状态
     * @param tradeIds
     * @return
     */
    Integer updateStatusByTradeIds(@Param("tradeIds") List<String> tradeIds);

    /**
     * 核算单交易展示
     * @param trade
     * @return
     */
    List<TradeVo> examineTradeShow(TradeVo trade);

    /**
     * 根据核算单查看佣金明细
     * @param examineBillVo
     */
    List<TradeVo> examineBillDetailsByExamineId(ExamineBillVo examineBillVo);

    /**
     * 核算单选择条目
     * @param trade
     * @return
     */
    List<TradeVo> selectPaymentdetailsByTradeIds(TradeVo trade);

    /**
     * 退房结算展示
     * @param tradeguidList
     * @return
     */
    List<TradeVo> selectPaymentdetailsByTradeIdsShow(@Param("tradeguidList") List<String> tradeguidList);

    /**
     * 交易状态关闭
     * @param tradeIds
     */
    void updateTradeStatusByTradeIds(@Param("tradeguidList") List<String> tradeIds);

}
