package com.huaxia.hx_sell_commission.mapper.db2;

import com.huaxia.hx_sell_commission.domain.csm.CsmSMyproject;

import java.util.List;

/**
 * 明源项目分期Mapper接口
 * 
 * @author shilei
 * @date 2020-11-18
 */
public interface CsmSMyprojectMapper 
{
    /**
     * 查询明源项目分期
     * 
     * @param id 明源项目分期ID
     * @return 明源项目分期
     */
    public CsmSMyproject selectCsmSMyprojectById(String id);

    /**
     * 查询明源项目分期列表
     * 
     * @param csmSMyproject 明源项目分期
     * @return 明源项目分期集合
     */
    public List<CsmSMyproject> selectCsmSMyprojectList(CsmSMyproject csmSMyproject);

    /**
     * 新增明源项目分期
     * 
     * @param csmSMyproject 明源项目分期
     * @return 结果
     */
    public int insertCsmSMyproject(CsmSMyproject csmSMyproject);

    /**
     * 修改明源项目分期
     * 
     * @param csmSMyproject 明源项目分期
     * @return 结果
     */
    public int updateCsmSMyproject(CsmSMyproject csmSMyproject);

    /**
     * 删除明源项目分期
     * 
     * @param id 明源项目分期ID
     * @return 结果
     */
    public int deleteCsmSMyprojectById(String id);

    /**
     * 批量删除明源项目分期
     * 
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int deleteCsmSMyprojectByIds(String[] ids);

    /**
     * 根据项目ID查询用户项目分期列表
     *
     * @param projectId
     * @return 明源项目分期集合
     */
    public List<CsmSMyproject> projGUList(String projectId);

}
