package com.huaxia.hx_sell_commission.mapper.db2;

import com.huaxia.hx_sell_commission.domain.csm.CsmSOrgProject;

import java.util.List;

/**
 * 项目组织架构关联Mapper接口
 * 
 * @author shilei
 * @date 2020-11-16
 */
public interface CsmSOrgProjectMapper 
{
    /**
     * 查询项目组织架构关联
     * 
     * @param id 项目组织架构关联ID
     * @return 项目组织架构关联
     */
    public CsmSOrgProject selectCsmSOrgProjectById(String id);

    /**
     * 查询项目组织架构关联列表
     * 
     * @param csmSOrgProject 项目组织架构关联
     * @return 项目组织架构关联集合
     */
    public List<CsmSOrgProject> selectCsmSOrgProjectList(CsmSOrgProject csmSOrgProject);

    /**
     * 新增项目组织架构关联
     * 
     * @param csmSOrgProject 项目组织架构关联
     * @return 结果
     */
    public int insertCsmSOrgProject(CsmSOrgProject csmSOrgProject);

    /**
     * 修改项目组织架构关联
     * 
     * @param csmSOrgProject 项目组织架构关联
     * @return 结果
     */
    public int updateCsmSOrgProject(CsmSOrgProject csmSOrgProject);

    /**
     * 删除项目组织架构关联
     * 
     * @param id 项目组织架构关联ID
     * @return 结果
     */
    public int deleteCsmSOrgProjectById(String id);

    /**
     * 批量删除项目组织架构关联
     * 
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int deleteCsmSOrgProjectByIds(String[] ids);
}
