package com.huaxia.hx_sell_commission.mapper.db2;

import com.huaxia.hx_sell_commission.domain.csm.CsmSOrganization;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 组织机构Mapper接口
 * 
 * @author shilei
 * @date 2020-11-16
 */
public interface CsmSOrganizationMapper 
{
    /**
     * 查询组织机构
     * 
     * @param id 组织机构ID
     * @return 组织机构
     */
    public CsmSOrganization selectCsmSOrganizationById(String id);

    /**
     * 查询组织机构列表
     * 
     * @param csmSOrganization 组织机构
     * @return 组织机构集合
     */
    public List<CsmSOrganization> selectCsmSOrganizationList(CsmSOrganization csmSOrganization);

    /**
     * 新增组织机构
     * 
     * @param csmSOrganization 组织机构
     * @return 结果
     */
    public int insertCsmSOrganization(CsmSOrganization csmSOrganization);

    /**
     * 修改组织机构
     * 
     * @param csmSOrganization 组织机构
     * @return 结果
     */
    public int updateCsmSOrganization(CsmSOrganization csmSOrganization);

    /**
     * 删除组织机构
     * 
     * @param id 组织机构ID
     * @return 结果
     */
    public int deleteCsmSOrganizationById(String id);

    /**
     * 批量删除组织机构
     * 
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int deleteCsmSOrganizationByIds(String[] ids);

    /**
     * 查询用户分公司列表
     *
     * @param projectIds
     * @return List<CsmSOrganization>
     */
    public List<CsmSOrganization> userCompanyList(@Param("projectIds") List<String> projectIds, @Param("examineId") String examineId);

    /**
     * 查询用户分公司项目列表
     *
     * @param projectIds
     * @return List<CsmSOrganization>
     */
    public List<CsmSOrganization> userTreeList(@Param("projectIds") List<String> projectIds);

}
