package com.huaxia.hx_sell_commission.mapper.db2;

import com.huaxia.hx_sell_commission.domain.csm.CsmSProjectBuild;

import java.util.List;

/**
 * 营销项目楼栋映射Mapper接口
 * 
 * @author shilei
 * @date 2020-11-18
 */
public interface CsmSProjectBuildMapper 
{
    /**
     * 查询营销项目楼栋映射
     * 
     * @param projectid 营销项目楼栋映射ID
     * @return 营销项目楼栋映射
     */
    public CsmSProjectBuild selectCsmSProjectBuildById(String projectid);

    /**
     * 查询营销项目楼栋映射列表
     * 
     * @param csmSProjectBuild 营销项目楼栋映射
     * @return 营销项目楼栋映射集合
     */
    public List<CsmSProjectBuild> selectCsmSProjectBuildList(CsmSProjectBuild csmSProjectBuild);

    /**
     * 新增营销项目楼栋映射
     * 
     * @param csmSProjectBuild 营销项目楼栋映射
     * @return 结果
     */
    public int insertCsmSProjectBuild(CsmSProjectBuild csmSProjectBuild);

    /**
     * 修改营销项目楼栋映射
     * 
     * @param csmSProjectBuild 营销项目楼栋映射
     * @return 结果
     */
    public int updateCsmSProjectBuild(CsmSProjectBuild csmSProjectBuild);

    /**
     * 删除营销项目楼栋映射
     * 
     * @param projectid 营销项目楼栋映射ID
     * @return 结果
     */
    public int deleteCsmSProjectBuildById(String projectid);

    /**
     * 批量删除营销项目楼栋映射
     * 
     * @param projectids 需要删除的数据ID
     * @return 结果
     */
    public int deleteCsmSProjectBuildByIds(String[] projectids);
}
