package com.huaxia.hx_sell_commission.mapper.db2;

import com.huaxia.hx_sell_commission.domain.csm.CsmSProject;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 营销项目Mapper接口
 * 
 * @author shilei
 * @date 2020-11-16
 */
public interface CsmSProjectMapper 
{
    /**
     * 查询营销项目
     * 
     * @param id 营销项目ID
     * @return 营销项目
     */
    public CsmSProject selectCsmSProjectById(String id);

    /**
     * 查询营销项目列表
     * 
     * @param csmSProject 营销项目
     * @return 营销项目集合
     */
    public List<CsmSProject> selectCsmSProjectList(CsmSProject csmSProject);

    /**
     * 新增营销项目
     * 
     * @param csmSProject 营销项目
     * @return 结果
     */
    public int insertCsmSProject(CsmSProject csmSProject);

    /**
     * 修改营销项目
     * 
     * @param csmSProject 营销项目
     * @return 结果
     */
    public int updateCsmSProject(CsmSProject csmSProject);

    /**
     * 删除营销项目
     * 
     * @param id 营销项目ID
     * @return 结果
     */
    public int deleteCsmSProjectById(String id);

    /**
     * 批量删除营销项目
     * 
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int deleteCsmSProjectByIds(String[] ids);

    /**
     * 根据公司ID查询营销项目列表
     *
     * @param projectIds
     * @return 营销项目集合
     */
    public List<CsmSProject> userProjectList(@Param("projectIds") List<String> projectIds, @Param("buguId") String buguId, @Param("examineId") String examineId);

    /**
     * 查询用户项目ID存储过程
     *
     * @param userName 用户名
     * @return 结果
     */
    public List<String> getProject(String userName);
}
