package com.huaxia.hx_sell_commission.mapper.db2;

import com.huaxia.hx_sell_commission.domain.csm.CsmSUserjobrel;

import java.util.List;

/**
 * 员工与岗位关系Mapper接口
 * 
 * @author shilei
 * @date 2020-11-16
 */
public interface CsmSUserjobrelMapper 
{
    /**
     * 查询员工与岗位关系
     * 
     * @param id 员工与岗位关系ID
     * @return 员工与岗位关系
     */
    public CsmSUserjobrel selectCsmSUserjobrelById(String id);

    /**
     * 查询员工与岗位关系列表
     * 
     * @param csmSUserjobrel 员工与岗位关系
     * @return 员工与岗位关系集合
     */
    public List<CsmSUserjobrel> selectCsmSUserjobrelList(CsmSUserjobrel csmSUserjobrel);

    /**
     * 新增员工与岗位关系
     * 
     * @param csmSUserjobrel 员工与岗位关系
     * @return 结果
     */
    public int insertCsmSUserjobrel(CsmSUserjobrel csmSUserjobrel);

    /**
     * 修改员工与岗位关系
     * 
     * @param csmSUserjobrel 员工与岗位关系
     * @return 结果
     */
    public int updateCsmSUserjobrel(CsmSUserjobrel csmSUserjobrel);

    /**
     * 删除员工与岗位关系
     * 
     * @param id 员工与岗位关系ID
     * @return 结果
     */
    public int deleteCsmSUserjobrelById(String id);

    /**
     * 批量删除员工与岗位关系
     * 
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int deleteCsmSUserjobrelByIds(String[] ids);
}
