package com.huaxia.hx_sell_commission.service;

import com.huaxia.hx_sell_commission.domain.ExamineBill;
import com.huaxia.hx_sell_commission.domain.ExamineReportDetails;
import com.huaxia.hx_sell_commission.domain.ExaminebillPayment;
import com.huaxia.hx_sell_commission.utils.AjaxResult;
import com.huaxia.hx_sell_commission.vo.ExamineBillVo;
import com.huaxia.hx_sell_commission.vo.ExcelExamineBill;
import com.huaxia.hx_sell_commission.vo.TradeVo;

import java.io.OutputStream;
import java.util.List;
import java.util.Map;

/**
 * Service接口--核算单
 *
 * @author qjcui
 * @date 2020-11-23
 */
public interface ExamineBillService {


    /**
     * 添加核算单
     * @param examineBill
     * @return
     */
    AjaxResult addExamineBill(ExamineBill examineBill);

    /**
     * 核算单状态修改
     * @param examineBill
     */
    AjaxResult updateExamineBill(ExamineBill examineBill);

    /**
     * 核算单展示
     * @param examineBillVo
     * @return
     */
    List<ExamineBill> examineBillShow(ExamineBillVo examineBillVo);


    /**
     * 修改核算单展示[交易回显]
     * @param examineBill
     * @return
     */
    Map<String, Object> selectTradeList(ExamineBill examineBill);

    /**
     * 修改核算单展示[佣金明细回显]
     * @param trade
     * @return
     */
    List<TradeVo> updateExamineBillDetailShow(TradeVo trade);

    /**
     * 修改核算单，核算交易关系表， 核算交易佣金明细关系表状态为无效
     */
    Integer updateExamineBillStatus(ExamineBill examineBill);

    /**
     * 核算单交易展示
     * @param trade
     * @return
     */
    List<TradeVo> examineTradeShow(TradeVo trade);

    /**
     * 判断是否为可编辑（登陆人是否与创建人一致）
     * @param examineid
     * @return
     */
    Integer isEditable(String examineid);

    /**
     * 核算单名称添加
     * @param examineBill
     * @return
     */
    AjaxResult addExamineBillName(ExamineBill examineBill);

    /**
     * 删除交易
     * @param examinebillPayment
     * @return
     */
    AjaxResult deleteTrade(ExaminebillPayment examinebillPayment);

    /**
     * 根据核算单id查看核算单人员核发汇总
     * @param examineBillVo
     * @return
     */
    Map<String, Object> examineBillUserSummaryShow(ExamineBillVo examineBillVo);

    /**
     * 核算单核发汇总导出
     * @param examineBillVo
     * @return
     */
    void examineBillSummaryExport(ExamineBillVo examineBillVo, OutputStream out);


    AjaxResult examineBillShowSummary(ExamineBillVo examineBillVo, OutputStream out);

    AjaxResult examineBillShowUserSummary(ExamineBillVo examineBillVo, OutputStream out);


}
