package com.huaxia.hx_sell_commission.service;

import com.huaxia.hx_sell_commission.domain.csm.*;
import com.huaxia.hx_sell_commission.vo.CsmSUserVo;

import java.util.List;
import java.util.Map;

/**
 * Service接口
 * 
 * @author shilei
 * @date 2020-11-16
 */
public interface ICsmSUserService 
{
    /**
     * 获取用户详细信息
     *
     * @return  CsmSUser
     */
    public CsmSUser selectCsmSUserByUserName();

    /**
     * 获取单点请求头数据
     *
     * @return  map
     */
    public Map<String, String> getloginInfo();

    /**
     * 查询用户菜单功能权限
     *
     * @return  List<CsmSMenus>
     */
    public Map<String, Object> selectUserMenuList();

    /**
     * 查询用户分公司列表
     *
     * @return  List<CsmSOrganization>
     */
    public List<CsmSOrganization> userCompanyList(String examineId);

    /**
     * 查询用户分公司项目列表
     *
     * @return  List<CsmSOrganization>
     */
    public List<CsmSOrganization> userTreeList();

    /**
     * 根据公司ID查询用户项目列表
     *
     * @return  List<CsmSProject>
     */
    public List<CsmSProject> userProjectList(String buguId, String examineId);

    /**
     * 根据项目ID查询用户项目分期列表
     *
     * @return  List<CsmSMyproject>
     */
    public List<CsmSMyproject> projGUList(String projectId);

    /**
     * 根据项目ID查询用户列表
     * @Param csmSUserVo
     * @return List<CsmSUser>
     */
    public List<CsmSUser> getUserByProjectId(CsmSUserVo csmSUserVo);

}
