package com.huaxia.hx_sell_commission.service;

import java.io.OutputStream;
import java.util.List;
import java.util.Map;

import com.huaxia.hx_sell_commission.domain.*;
import com.huaxia.hx_sell_commission.utils.AjaxResult;
import com.huaxia.hx_sell_commission.vo.ExamineBillVo;
import com.huaxia.hx_sell_commission.vo.ExcelExamineBill;
import com.huaxia.hx_sell_commission.vo.TradeVo;

/**
 * Service接口
 * 
 * @author shilei
 * @date 2020-11-16
 */
public interface IPaymenttempService 
{
    /**
     * 查询支付节点
     *
     * @return 
     */
    public AjaxResult selectPayNodeList();

    /**
     * 查询岗位类别集合
     *
     * @return
     */
    public AjaxResult selectUserTypeList();

    /**
     * 查询
     *
     * @param tempid ID
     * @return
     */
    public Paymenttemp selectPaymenttempAllById(String tempid);

    /**
     * 查询列表
     * 
     * @param paymenttemp 
     * @return 集合
     */
    public List<Paymenttemp> selectPaymenttempList(Paymenttemp paymenttemp, List<String> projectIds);

    /**
     * 根据交易ID查询方案模板列表
     *
     * @param tradeguId
     * @return 集合
     */
    public List<Paymenttemp> selectListByTradeguId(List<String> tradeguId);

    /**
     * 新增
     * 
     * @param paymenttemp 
     * @return 结果
     */
    public AjaxResult insertPaymenttemp(Paymenttemp paymenttemp);

    /**
     * 修改
     * 
     * @param paymenttemp 
     * @return 结果
     */
    public AjaxResult updatePaymenttemp(Paymenttemp paymenttemp);

    /**
     * 启用、停用接口
     *
     * @param paymenttemp
     * @return 结果
     */
    public int updateStatus(Paymenttemp paymenttemp);

    /**
     * 停用接口
     *
     * @param paymenttemp
     * @return 结果
     */
    int stopUsing(Paymenttemp paymenttemp);

    /**
     * 删除单个人员分配信息
     *
     * @param tempid 方案模板ID
     * @param userid 人员ID
     * @return 结果
     */
    public int deleteTempUser(String tempid, String userid);

    /**
     * 电商项目名称详细
     * @param yxGroupFeePlan
     */
    List<YxGroupFeePlan> selectProjectList(YxGroupFeePlan yxGroupFeePlan);

    /**
     * 根据交易id查明细
     * @param tradeIds
     * @return
     */
    List<TradeVo> selectPaymenttempAllByTradeId(List<String> tradeIds);

    /**
     * 提交
     * @param tradeIds
     * @return
     */
    int checkOutSubmit(List<String> tradeIds);

    /**
     * 根据详情id查
     * @param examineBill
     * @return
     */
    List<TradeVo> selectPaymenttempAllByPayId(ExamineBill examineBill);

    /**
     * 根据核算单id查看佣金明细表
     * @param examineBillVo
     * @return
     */
    List<ExcelExamineBill> examineBillDetailsShow(ExamineBillVo examineBillVo);

    /**
     * 是否跳转页面
     * @param tradeIds
     * @return
     */
    Integer jumpOrNo(List<String> tradeIds);

    /**
     * 核算单导出
     * @param examineBillVo
     * @return
     */
    AjaxResult examineBillExport(ExamineBillVo examineBillVo, OutputStream out);



    /**
     * 根据交易ID查询方案追加的模板列表
     *
     * @param tradeguId
     * @return 集合
     */
    public List<Paymenttemp> selectAppendListByTradeguId(String tradeguId);

    /**
     * 核算单统计视图数据
     * @param examineBillVo
     * @return
     */
    List<ExcelExamineBill> examineBillDetailsNew(ExamineBillVo examineBillVo);

    /**
     * 核算单统计视图数据examineBillDetailsFind
     *
     * @param examineBillVo
     * @return
     */
    List<ExcelExamineBill> examineBillDetailsFind(ExamineBillVo examineBillVo);
}

