package com.huaxia.hx_sell_commission.service;

import java.util.List;

import com.huaxia.hx_sell_commission.domain.*;
import com.huaxia.hx_sell_commission.utils.AjaxResult;
import com.huaxia.hx_sell_commission.vo.ExamineBillVo;
import com.huaxia.hx_sell_commission.vo.PlanVo;
import com.huaxia.hx_sell_commission.vo.TradeVo;

/**
 * 佣金方案Service接口
 * 
 * @author shilei
 * @date 2020-11-18
 */
public interface IPlanService 
{

    /**
     * 查询佣金方案管理列表
     * 
     * @param trade 佣金方案列表查询参数
     * @return 佣金方案列表
     */
    public List<TradeVo> selectTradeList(TradeVo trade);

    /**
     * 新增佣金方案-2.查询调整佣金
     *
     * @param tradeguidList 佣金方案查询参数
     * @return 佣金方案
     */
    public List<TradeVo> getRegulateBrokerage(List<String> tradeguidList);
    public List<TradeVo> getRegulateBrokerage2(List<String> tradeguidList, ExamineBillVo examineBillVo);
    public List<TradeVo> getRegulateBrokerage3(List<String> tradeguidList, ExamineBillVo examineBillVo);

    /**
     * 新增佣金方案-3.查询结算方案
     *
     * @param tradeguidList 佣金方案查询参数
     * @return 佣金方案
     */
    public List<TradeVo> getSettlePlan(List<String> tradeguidList);

    /**
     * 新增佣金方案-3.方案试算
     *
     * @param tradeVoList 佣金方案试算 参数
     * @return 佣金方案
     */
    public List<TradeVo> planCalculation(List<TradeVo> tradeVoList);

    /**
     * 佣金方案-查看、预览
     *
     * @param tradeguids 佣金方案查询参数
     * @return 佣金方案
     */
    public List<TradeVo> findPlanDetails(List<String> tradeguids);

    /**
     * 新增佣金方案-1.保存佣金方案模板
     * 
     * @param plan 佣金方案详情
     * @return 结果
     */
    public AjaxResult insertPlan(List<Plan> plan);

    /**
     * 新增佣金方案-2.保存调整佣金
     *
     * @param planfees
     * @return 结果
     */
    public AjaxResult insertPlanfee(List<Planfee> planfees);

    /**
     * 新增佣金方案-3.保存结算方案
     *
     * @param tradeVoList
     * @return 结果
     */
    public AjaxResult insertSettlePlan(List<TradeVo> tradeVoList);

    /**
     * 佣金方案-作废
     *
     * @param tradeguid
     * @return 结果
     */
    public AjaxResult delTradePlan(String tradeguid);

    /**
     * 佣金方案-提交
     *
     * @param planIds
     * @return 结果
     */
    public AjaxResult tradePlanSubmit(List<String> planIds);

    /**
     * 新增佣金方案-2.查询调整佣金
     *
     * @param tradeguidList 佣金方案查询参数
     * @return 佣金方案
     */
    public List<TradeVo> AppendgetRegulateBrokerage(List<String> tradeguidList);

    /**
     * 追加模板
     * @param plan
     * @return
     */
    public AjaxResult AppendTemp(Plan plan);

    public AjaxResult AppendinsertSettlePlan(List<TradeVo> tradeVoList);


    /**
     * 新增佣金方案-3.查询结算方案
     *
     * @param tradeguidList 佣金方案查询参数
     * @return 佣金方案
     */
    public List<TradeVo> AppendgetSettlePlan(List<String> tradeguidList);
}
