package com.huaxia.hx_sell_commission.service;

import com.huaxia.hx_sell_commission.domain.*;
import com.huaxia.hx_sell_commission.utils.AjaxResult;
import com.huaxia.hx_sell_commission.vo.ExamineBillVo;
import com.huaxia.hx_sell_commission.vo.SettleBillVo;
import com.huaxia.hx_sell_commission.vo.SettlebillPaydetailsVo;
import com.huaxia.hx_sell_commission.vo.TradeVo;

import java.util.List;
import java.util.Map;

/**
 * 结算单Service接口
 * 
 * @author zcj
 * @date 2020-12.2
 */
public interface SettlebillService {
    /**
     * 结算单管理
     * @param settleBillVo
     * @return
     */
    public List<SettleBillVo> settleBillShow(SettleBillVo settleBillVo);

    /**
     * 查询结算单中核算单
     * @param examineBillVo
     * @return
     */
    public List<ExamineBill> ExamineBilDetails(ExamineBillVo examineBillVo);

//    /**
//     * 查询结算单中核算单0
//     * @param settleBillVo
//     * @return
//     */
//    public List<SettleBillVo> settlebillDetails(SettleBillVo settleBillVo);

    /**
     * 选择交易条目-结算单人员结算明细
     * @return
     */
    public List<TradeVo> settlebillTradeShow(SettleBillVo settleBillVo);

    /**
     * 编辑结算单回显/查询结算单明细
     * @return
     */
    public List<SettlebillPaydetailsVo> settleBillPayDetailsShow(SettlebillPaydetailsVo settleBillVo);

    /**
     * 新增结算单回显
     * @return
     */
    public Map<String,Object> settleBillPayDetailsShow0(SettleBillVo settleBillVo);

    /**
     * 查询结算单是否存在并添加
     * @return
     */
    public AjaxResult settlebillexits(SettleBillVo settleBillVo);

    /**
     * 新增结算单
     *
     * @param settleBillVo 结算单
     * @return 结果
     */
    public AjaxResult insertSettlebill(SettleBillVo settleBillVo);

    /**
     * 新增结算单中交易
     *
     * @param settleBillVo 结算单
     * @return 结果
     */
    public AjaxResult insertSettlebillTrade(List<SettleBillVo> settleBillVo);

    /**
     * 新增结算单中明细
     *
     * @param settleBill 结算单
     * @return 结果
     */
    public AjaxResult insertSettlebillPayDetails(SettleBillVo settleBill);

    /**
     * 修改结算单单据状态
     *
     * @param settlebill 结算单
     * @return 结果
     */
    public int updateSettlebillStatus(Settlebill settlebill);

    /**
     * 修改结算单流程状态
     *
     * @param settlebill 结算单
     * @return 结果
     */
    public int updateSettlebillFlowStatus(Settlebill settlebill);

    /**
     * 修改结算单
     *
     * @param settleBillVo 结算单
     * @return 结果
     */
    public int updateSettlebill(SettleBillVo settleBillVo);

    /**
     * 删除结算单
     *
     * @param settleid 需要删除的结算单中的核算单ID
     * @return 结果
     */
    public AjaxResult deleteSettlebill(String settleid);

    /**
     * 删除结算单
     *
     * @param settleid 需要删除的结算单中的核算单ID
     * @return 结果
     */
    public AjaxResult deleteSettlebill2(String settleid);

    /**
     * 结算单审核页面--工作流
     * @param businesskey
     * @return
     */
    Map<String, Object> approvalShow(String businesskey);

    /**
     * 修改结算单和审核单据
     * @param settlebillThirdbill
     * @return
     */
    AjaxResult updateThirdAndSettle(SettlebillThirdbill settlebillThirdbill);

    /**
     * 删除结算单中的核算单
     * @param settleBillVo
     * @return
     */
    AjaxResult deleteEmail(SettleBillVo settleBillVo);
}
