package com.huaxia.hx_sell_commission.service.impl;

import cn.hutool.core.io.IoUtil;
import cn.hutool.core.io.resource.ClassPathResource;
import cn.hutool.core.util.StrUtil;
import cn.hutool.poi.excel.ExcelUtil;
import cn.hutool.poi.excel.ExcelWriter;
import cn.hutool.poi.excel.StyleSet;
import com.alibaba.fastjson.JSON;
import com.cfld.sso.client.servlet.SsoUserUtil;
import com.huaxia.hx_sell_commission.constant.Constants;
import com.huaxia.hx_sell_commission.controller.BaseController;
import com.huaxia.hx_sell_commission.domain.*;
import com.huaxia.hx_sell_commission.domain.csm.CsmSUser;
import com.huaxia.hx_sell_commission.enums.ButtonEnum;
import com.huaxia.hx_sell_commission.enums.ExamineEnum;
import com.huaxia.hx_sell_commission.enums.PlanEnum;
import com.huaxia.hx_sell_commission.exception.CustomException;
import com.huaxia.hx_sell_commission.mapper.db1.*;
import com.huaxia.hx_sell_commission.mapper.db2.CsmSProjectMapper;
import com.huaxia.hx_sell_commission.service.ExamineBillService;
import com.huaxia.hx_sell_commission.service.ICsmSUserService;
import com.huaxia.hx_sell_commission.utils.AjaxResult;
import com.huaxia.hx_sell_commission.utils.CollectorsUtil;
import com.huaxia.hx_sell_commission.utils.constant.SystemConstant;
import com.huaxia.hx_sell_commission.vo.*;
import org.apache.poi.hssf.usermodel.HSSFAnchor;
import org.apache.poi.hssf.util.HSSFColor;
import org.apache.poi.ss.usermodel.*;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.ss.util.RegionUtil;
import org.apache.poi.xssf.usermodel.*;
import org.slf4j.ILoggerFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.DigestUtils;
import sun.security.provider.MD5;

import javax.servlet.http.HttpServletRequest;
import javax.swing.filechooser.FileSystemView;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

import static java.util.stream.Collectors.groupingBy;


@Service
public class ExamineBillServiceImpl implements ExamineBillService {
    protected final Logger logger = LoggerFactory.getLogger(ExamineBillServiceImpl.class);
    @Autowired
    private ExamineBillMapper examinebillMapper;

    @Autowired
    private ICsmSUserService iCsmSUserService;

    @Autowired
    private PaymentdetailsMapper paymentdetailsMapper;


    @Autowired
    private ExamineBillMapper examineBillMapper;

    @Autowired
    private PaymentdetailsLogMapper paymentdetailsLogMapper;

    @Autowired
    private ExaminebillTradeMapper examinebillTradeMapper;

    @Autowired
    private ExaminebillPaymentMapper examinebillPaymentMapper;

    @Autowired
    private TradeMapper tradeMapper;

    @Autowired
    private PlanMapper planMapper;

    @Autowired
    private HttpServletRequest request;

    @Autowired
    private CsmSProjectMapper csmSProjectMapper;

    @Autowired
    private ExamineReportDetailsMapper examineReportDetailsMapper;
    /**
     * 添加核算单
     *
     * @param examineBill
     * @return
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public AjaxResult addExamineBill(ExamineBill examineBill) {

        //核算单号
        String ExamineID = examineBill.getExamineId() != null ? examineBill.getExamineId() : UUID.randomUUID().toString().replace("-", "");
        // 从缓存中获取 审核人
        String userName = SsoUserUtil.getCurrentUser(request);
        CsmSUser csmSUser = iCsmSUserService.selectCsmSUserByUserName();
        //获取到佣金明细ID
        List<Paymentdetails> paymentdetails1 = examineBill.getPaymentdetails();
        if(paymentdetails1 == null || paymentdetails1.size() == 0){
            return AjaxResult.success("请选择佣金明细", 500);
        }
        //当前时间
        Date now=new Date();
        List<PaymentdetailsLog> paymentdetailsLogList = new ArrayList<>();
        List<String> PayIds = new ArrayList<>();
        for (Paymentdetails paymentdetail : paymentdetails1) {
            PayIds.add(paymentdetail.getPayid());
            PaymentdetailsLog paymentdetailsLog = new PaymentdetailsLog();
            paymentdetailsLog.setJobname(paymentdetail.getJobname());
            paymentdetailsLog.setNodeid(paymentdetail.getNodeid());
            paymentdetailsLog.setNodename(paymentdetail.getNodename());
            paymentdetailsLog.setPayable(paymentdetail.getPayable());
            paymentdetailsLog.setPaybatch(paymentdetail.getPaybatch());
            paymentdetailsLog.setPayid(paymentdetail.getPayid());
            paymentdetailsLog.setPaytotal(paymentdetail.getPaytotal());
            paymentdetailsLog.setPlanid(paymentdetail.getPlanid());
            paymentdetailsLog.setPlantype(paymentdetail.getPlantype());
            paymentdetailsLog.setStatus(paymentdetail.getStatus());
            paymentdetailsLog.setTradeguid(paymentdetail.getTradeguid());
            paymentdetailsLog.setUpdatedate(now);
            paymentdetailsLog.setUpdatereason(paymentdetail.getUpdatereason());
            paymentdetailsLog.setUser(paymentdetail.getUser());
            paymentdetailsLog.setUserid(paymentdetail.getUserid());
            paymentdetailsLog.setUsertypeid(paymentdetail.getUsertypeid());
            paymentdetailsLog.setUsertypename(paymentdetail.getUsertypename());
            paymentdetailsLog.setStatusDetail(PlanEnum.PaymentDetailsStatusDetail.STATUS_201.getCode());
            paymentdetailsLogList.add(paymentdetailsLog);

        }
        List<Paymentdetails> paymentdetailsList = paymentdetailsMapper.selectPaymentdetailsByIds(PayIds);
        //校验数值
        for (int i = 0; i < paymentdetails1.size(); i++) {
            for (int i1 = 0; i1 < paymentdetailsList.size(); i1++) {
                if (paymentdetailsList.get(i1).getPayid().equals(paymentdetails1.get(i).getPayid())) {
                    if(!paymentdetailsList.get(i1).getStatusDetail().equals(paymentdetails1.get(i).getStatusDetail())){
                        return AjaxResult.success(paymentdetailsList.get(i1).getUser() + "状态已修改请刷新页面", 500);

                    }
                    if (paymentdetailsList.get(i1).getPaytotal().compareTo(paymentdetails1.get(i).getPaytotal()) == -1) {
                        return AjaxResult.success(paymentdetailsList.get(i1).getUser() + "支付总金额已修改请刷新页面", 500);
                    }
                    if(paymentdetailsList.get(i1).getPayable() != null){
                        if (paymentdetailsList.get(i1).getPayable().compareTo(paymentdetails1.get(i).getPayable()) == -1) {
                            return AjaxResult.success(paymentdetailsList.get(i1).getUser() + "支付首末金额已修改请刷新页面", 500);
                        }
                    }

                }
            }
        }
        //判断同一个人相加的值没有小于0的
        List<Paymentdetails> paymentdetailsList1 = paymentdetailsList;
        Map<String, BigDecimal> cancelAmountMap = paymentdetailsList1.stream()
                .collect(Collectors.groupingBy(Paymentdetails::getUserid,
                        CollectorsUtil.summingBigDecimal(pay -> pay.getPayable() == null ? pay.getPaytotal() : pay.getPayable())));
        for (Map.Entry<String, BigDecimal> stringBigDecimalEntry : cancelAmountMap.entrySet()) {
            if (stringBigDecimalEntry.getValue().compareTo(new BigDecimal(0)) == -1) {
                return AjaxResult.success("结算金额为负数", 500);
            }
        }

        //总价
        BigDecimal totalPrice = new BigDecimal(0L);
        //添加核算单交易列表
        List<ExaminebillTrade> examinebillTradeList = new ArrayList<>();
        //添加核算单交易佣金列表
        List<ExaminebillPayment> examinebillPaymentArrayList = new ArrayList<>();
        for (Paymentdetails paymentdetails : paymentdetailsList) {

            //佣金改变状态为已生成，未发起核算20L==后改
            paymentdetails.setStatusDetail(PlanEnum.PlanStatus.STATUS_WFQ.getCode());
            //合计总价
            if (paymentdetails.getPayable() == null) {
                totalPrice = totalPrice.add(paymentdetails.getPaytotal());
            } else {
                totalPrice = totalPrice.add(paymentdetails.getPayable());
            }
            //核算单交易
            ExaminebillTrade examinebillTrade = new ExaminebillTrade();
            examinebillTrade.setExamineid(ExamineID);
            examinebillTrade.setTradeguid(paymentdetails.getTradeguid());
            examinebillTrade.setPlanId(paymentdetails.getPlanid());
            examinebillTradeList.add(examinebillTrade);

            //核算单交易佣金
            ExaminebillPayment examinebillPayment = new ExaminebillPayment();
            examinebillPayment.setExamineid(ExamineID);
            examinebillPayment.setPayid(paymentdetails.getPayid());
            //状态需修正================修正0次
            examinebillPayment.setStatus(201L);
            examinebillPayment.setTradeguid(paymentdetails.getTradeguid());
            examinebillPayment.setUpdatereason("新增草稿");
            examinebillPayment.setUpdatedate(new Date());
            examinebillPaymentArrayList.add(examinebillPayment);
        }

        //添加审批单===后期修正根据登录人填写
        examineBill.setCreate(csmSUser != null ? csmSUser.getUsername() : "");
        examineBill.setCreateId(csmSUser!= null ? csmSUser.getId() : "");
        examineBill.setTotal(totalPrice);
        examineBill.setStatus(examineBill.getStatus());
        examineBill.setCreateDate(new Date());


        //判断是修改后添加还是首次添加--修改后添加根据id将状态改为失效和失效/明细详情状态改为已生成
        if (examineBill.getExamineId() != null && !examineBill.getExamineId().equals("")) {
            this.updateExamineBillStatus(examineBill);
        }
        //再把新的相关详情状态也改为待审核
        Long status = PlanEnum.PaymentDetailsStatusDetail.STATUS_201.getCode();
        paymentdetailsMapper.updatePaymentdetailsStatusByPayIds(PayIds, status);
        paymentdetailsLogMapper.insertPaymentdetailsLogList(paymentdetailsLogList);
        if (examineBill.getExamineId() != null && examineBill.getExamineId() != "") {
            examinebillMapper.updateExaminebill(examineBill);
        } else {
            examineBill.setExamineId(ExamineID);
            examineBill.setStatus(ExamineEnum.ExamineBillStatus.STATUS_CG.getCode());
            examinebillMapper.insertExaminebill(examineBill);
        }
        examinebillPaymentMapper.insertExaminebillPayment(examinebillPaymentArrayList);
        examinebillTradeMapper.insertExaminebillTrade(examinebillTradeList);


        return AjaxResult.success("核算单添加成功", ExamineID);
    }

    /**
     * 核算单状态修改
     *
     * @param examineBill
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public AjaxResult updateExamineBill(ExamineBill examineBill) {

        //获取登陆的用户
        CsmSUser csmSUser = iCsmSUserService.selectCsmSUserByUserName();
        if(examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_ZF.getCode().intValue()){
            ExamineBill examineBill1 = examinebillMapper.selectExaminebillById(examineBill.getExamineId());
            if(csmSUser == null || !examineBill1.getCreateId().equals(csmSUser.getId())){
                return  AjaxResult.success("您不是创建人，无法作废", 0);
            }
        }

        //提示值是不是改变
        List<Paymentdetails> paymentdetails1 = examineBill.getPaymentdetails();
        if(paymentdetails1 != null && paymentdetails1.size() > 0){
            List<String> PayIds = new ArrayList<>();
            for (Paymentdetails paymentdetail : paymentdetails1) {
                PayIds.add(paymentdetail.getPayid());
            }
            List<Paymentdetails> paymentdetailsList = paymentdetailsMapper.selectPaymentdetailsByIds(PayIds);
            //根据核算单id查状态
            if(examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_PASS.getCode().intValue() ||
                    examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_BH.getCode().intValue()){
                ExamineBill examineBill1 = examinebillMapper.selectExaminebillById(examineBill.getExamineId());
                if(examineBill1.getStatus().intValue() != ExamineEnum.ExamineBillStatus.STATUS_DSH.getCode().intValue()){
                    return AjaxResult.error(500,  "核算单状态已修改请刷新页面");
                }
            }
            for (int i = 0; i < paymentdetails1.size(); i++) {
                for (int i1 = 0; i1 < paymentdetailsList.size(); i1++) {
                    if (paymentdetailsList.get(i1).getPayid().equals(paymentdetails1.get(i).getPayid())) {
                        if(paymentdetails1.get(i1).getStatusDetail() != null){
                            if(!paymentdetailsList.get(i1).getStatusDetail().equals(paymentdetails1.get(i).getStatusDetail())){
                                if(!paymentdetailsList.get(i).getStatusDetail().equals(PlanEnum.PaymentDetailsStatusDetail.STATUS_201.getCode())){
                                    return AjaxResult.error(500,paymentdetailsList.get(i1).getUser() + "状态已修改请刷新页面");
                                }
                            }
                        }
                        if (paymentdetailsList.get(i1).getPaytotal().compareTo(paymentdetails1.get(i).getPaytotal()) == -1) {
                            return AjaxResult.error(500,paymentdetailsList.get(i1).getUser() + "支付总金额已修改请刷新页面");
                        }
                        if(paymentdetailsList.get(i1).getPayable() != null){
                            if (paymentdetailsList.get(i1).getPayable().compareTo(paymentdetails1.get(i).getPayable()) == -1) {
                                return AjaxResult.error(500,paymentdetailsList.get(i1).getUser() + "支付首末金额已修改请刷新页面");
                            }
                        }

                    }
                }
            }
        }
        ExaminebillPayment examinebillPayment = new ExaminebillPayment();
        examinebillPayment.setExamineid(examineBill.getExamineId());
        examinebillPayment.setUpdatedate(new Date());
        examinebillPayment.setStatus(examineBill.getStatus().longValue());
        if (examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_ZF.getCode().intValue()) {
            examinebillPayment.setStatus(ExamineEnum.ExamineBillStatus.STATUS_ZF.getCode().longValue());
            examinebillPayment.setUpdatereason("作废");
        } else if (examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_DSH.getCode().intValue()) {
            //首付改为不可编辑
            examinebillPaymentMapper.updatePlanBalanceStatus1(examineBill);
            //尾付改为不可编辑
            examinebillPaymentMapper.updatePlanBalanceStatus2(examineBill);
            //节点中的固定分配金额不可编辑
            examinebillPaymentMapper.updatePlanBalanceStatus3(examineBill.getExamineId());
            examinebillPayment.setUpdatereason("待审核");
        }else if(examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_BH.getCode().intValue()){
            //首付改为可编辑
            examinebillPaymentMapper.updatePlanBalanceStatus1Reverse(examineBill);
            //尾付改为可编辑
            examinebillPaymentMapper.updatePlanBalanceStatus2Reverse(examineBill);
            //节点中的固定分配金额可编辑
            examinebillPaymentMapper.updatePlanBalanceStatus3Reverse(examineBill.getExamineId());
            examinebillPayment.setUpdatereason("驳回");
        }else{
            examinebillPayment.setUpdatereason("通过");
//            examinebillMapper.updateExamineBill(examineBill);
        }
        examinebillPaymentMapper.updateExaminebillPayment(examinebillPayment);

        //作废将核算单的作废人人作废时间修改
        if (examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_ZF.getCode().intValue()) {
            examineBill.setCancel(csmSUser != null ? csmSUser.getUsername() : "");
            examineBill.setCancelId(csmSUser != null ? csmSUser.getId() : "");
            examineBill.setCancelDate(new Date());
        }

        //通过或者驳回将核算单的审核人审核时间修改
        if (examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_BH.getCode().intValue() || examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_PASS.getCode().intValue()) {
            examineBill.setApprove(csmSUser != null ? csmSUser.getUsername() : "");
            examineBill.setApproveId(csmSUser != null ? csmSUser.getId() : "");
            examineBill.setApproveDate(new Date());
        }
        //待审核将核算单的提交人提交时间修改
        if (examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_DSH.getCode().intValue()) {
            examineBill.setSubmitter(csmSUser != null ? csmSUser.getUsername() : "");
            examineBill.setSubmitterId(csmSUser!= null ? csmSUser.getId() : "");
            examineBill.setSubmitterDate(new Date());
        }

        //修改详情表状态
        if (examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_ZF.getCode().intValue()) {
            ExamineBill examineBill1 = new ExamineBill();
            examineBill1.setExamineId(examineBill.getExamineId());
            examineBill1.setStatus(Integer.parseInt(PlanEnum.PaymentDetailsStatusDetail.STATUS_102.getCode().toString()));
            paymentdetailsMapper.updateStatus(examineBill1);
        }else {
            paymentdetailsMapper.updateStatus(examineBill);
        }

//        planMapper.updateStatus(examineBill);
        examinebillMapper.updateExaminebill(examineBill);
        if (examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_ZF.getCode().intValue()) {
            return   AjaxResult.success("作废成功", examineBill.getCancelDate());
        }
        if (examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_PASS.getCode().intValue()) {
            return   AjaxResult.success("审核通过成功", examineBill.getCancelDate());
        }
        if (examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_BH.getCode().intValue()) {
            return   AjaxResult.success("审核驳回成功", examineBill.getCancelDate());
        }
        if (examineBill.getStatus().intValue() == ExamineEnum.ExamineBillStatus.STATUS_DSH.getCode().intValue()) {
            return   AjaxResult.success("提交成功", examineBill.getCancelDate());
        }
        return   AjaxResult.success("成功", examineBill.getCancelDate());
    }

    /**
     * 核算单展示
     *
     * @param examineBillVo
     * @return
     */
    @Override
    public List<ExamineBill> examineBillShow(ExamineBillVo examineBillVo) {
        CsmSUser csmSUser = iCsmSUserService.selectCsmSUserByUserName();
        examineBillVo.setUserName(csmSUser == null ? "maowei" : csmSUser.getUsername());
        // 查询项目列表
        List<String> projectIds = csmSProjectMapper.getProject(csmSUser == null ? "maowei" : csmSUser.getUsername());
        examineBillVo.setProjectIds(projectIds);
        List<ExamineBill> examineBillList = examinebillMapper.examineBillShow(examineBillVo);
        examineBillList.forEach(e ->{
            getButtonList(e, csmSUser);
        });
        return examineBillList;
    }

    /**
     * 查询按钮权限
     * @param t
     * @return
     */
    private ExamineBill getButtonList(ExamineBill t, CsmSUser csmSUser){
        List<String> button = new ArrayList<>();
        ExamineBill planVo = t;
        if(planVo == null){
            // 未生成状态
            button.add(ButtonEnum.PlanBtn.ADD_BTN.getCode());
        } else {
            if(ExamineEnum.ExamineBillStatus.STATUS_CG.getCode().intValue() ==  planVo.getStatus().intValue() ||
                    ExamineEnum.ExamineBillStatus.STATUS_BH.getCode().intValue() == planVo.getStatus().intValue()){ // 草稿
                if(planVo.getCreateId() != null && planVo.getCreateId().equals(csmSUser == null ? "8C7239DC-1DEF-44F7-8597-F70F8079439A" : csmSUser.getId())){
                    button.add(ButtonEnum.ExaminellBtn.UPDATE_BTN.getCode());
                    button.add(ButtonEnum.ExaminellBtn.INVALID_BTN.getCode());
                }
            }else{
                button.add(ButtonEnum.ExaminellBtn.VIEW_BTN.getCode());
            }
        }
        t.setButton(button);
        return t;
    }


    /**
     * 修改时核算单交易展示回显
     *
     * @param examineBill
     * @return
     */
    @Override
    public Map<String, Object> selectTradeList(ExamineBill examineBill) {
        List<String> tradeIds = examinebillTradeMapper.selectExaminebillTradeList(examineBill);
        ExamineBill examineBill1 = examineBillMapper.selectExaminebillById(examineBill.getExamineId());
        Map<String, Object> map = new HashMap<>();
        map.put("tradeIds", tradeIds);
        map.put("hxProjectId", examineBill1.getHxProjectId() == null ? "" : examineBill1.getHxProjectId());
        map.put("companyGuid", examineBill1.getCompanyGuid()== null ? "" : examineBill1.getCompanyGuid());
        return map;
    }

    /**
     * 修改核算单展示[佣金明细回显]
     *
     * @param trade
     * @return
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public List<TradeVo> updateExamineBillDetailShow(TradeVo trade) {


        List<TradeVo> planDetails = tradeMapper.getPlanDetails(trade);
        if (planDetails != null && planDetails.size() > 0) {
            planDetails.stream().forEach(t -> {
                PlanVo planVo = t.getPlanVo();
                if (planVo != null) {
                    List<PaymentdetailsVo> paymentdetails = planVo.getPaymentdetails();
                    List<ExaminebillPayment>  examinebillPayments = new ArrayList<>();
                    if(trade.getExamineid() != null){
                        examinebillPayments = examinebillTradeMapper.selectPayIdsById(trade.getExamineid());
                        planVo.setExamineName(examinebillPayments.get(0).getExamineName());
                        for (PaymentdetailsVo paymentdetail : paymentdetails) {
                            for (ExaminebillPayment examinebillPayment : examinebillPayments) {
                                if(examinebillPayment.getPayid() != null &&examinebillPayment.getPayid().equals(paymentdetail.getPayid())){
                                    paymentdetail.setIsChecked("1");
                                    continue;
                                }
                            }
                        }
                        paymentdetails.forEach(p -> {
                            if(p.getPaybatch()!=null && p.getPaybatch().compareTo(PlanEnum.PaymentDetailsPayBatch.PAY_LAST.getCode())==0 ) {
                                List<PaymentdetailsVo> first =  paymentdetails.stream().filter(
                                        x->x.getPaybatch()!=null
                                        && x.getPaybatch().compareTo(PlanEnum.PaymentDetailsPayBatch.PAY_FIRST.getCode())==0
                                        && x.getPlanid().equals(p.getPlanid())
                                        && x.getNodeid().equals(p.getNodeid())
                                        && x.getUsertypeid().equals(p.getUsertypeid())
                                        && x.getUserid().equals(p.getUserid())
                                ).collect(Collectors.toList());
                                if(first.stream().count()>0){
                                    if(first.get(0).getStatusDetail()> PlanEnum.PaymentDetailsStatusDetail.STATUS_203.getCode()
                                            && first.get(0).getStatusDetail() !=PlanEnum.PaymentDetailsStatusDetail.STATUS_205.getCode()){
                                        //可以选择
                                        p.setPayLastbatchEnable(1);
                                    }
                                    else {
                                        p.setPayLastbatchEnable(0);
                                        //不可以选择
                                    }
                                }
                                else{
                                    //可以选择
                                    p.setPayLastbatchEnable(1);
                                }
                            }
                            if(p.getIsChecked() == null || !p.getIsChecked().equals("1")){
                                p.setIsChecked("0");
                            }
                        });

                    }else {
                        for (PaymentdetailsVo paymentdetail : paymentdetails) {
                            paymentdetail.setIsChecked("0");
                        }
                    }
                    List<PaymentdetailsVo> paymentdetails1 = new ArrayList<>();
                    for (int i = 0; i < paymentdetails.size(); i++) {
                        if((paymentdetails.get(i).getPayable() != null && paymentdetails.get(i).getPayable().compareTo(new BigDecimal(0)) == -1) ||
                                paymentdetails.get(i).getPaytotal().compareTo(new BigDecimal(0)) == -1){
                            paymentdetails1.add(paymentdetails.get(i));
                        }
                        if(paymentdetails.get(i).getStatusDetail().equals(PlanEnum.PaymentDetailsStatusDetail.STATUS_104.getCode())){
                            paymentdetails.remove(i);
                            i--;
                        }
                    }
                    /** 自定义MD5，前端通过该MD5判断每个节点 的所有 类别、岗位、人员、方案比例 的组合是否相同 20210624 开始 **/
                    Map<String, String> md5Map = new HashMap<>();
                    Map<String, List<PaymentdetailsVo>> collect = paymentdetails.stream().collect(groupingBy(v -> v.getNodeid()+"_"+v.getPlantype()));
                    collect.entrySet().forEach(es -> {
                        StringBuffer sbf = new StringBuffer();
                        List<PaymentdetailsVo> value = es.getValue();
                        value.forEach(pm -> {
                            sbf.append(pm.getUsertypename());
                            sbf.append(pm.getJobname());
                            sbf.append(pm.getUser());
                            sbf.append(pm.getPayTotalRatio());
                        });
                        String customizeMd5 = DigestUtils.md5DigestAsHex(sbf.toString().getBytes());
                        md5Map.put(es.getKey(), customizeMd5);
                    });
                    paymentdetails.stream().forEach(pm -> {
                        pm.setCustomizeMd5(md5Map.get(pm.getNodeid()+"_"+pm.getPlantype()));
                    });
                    /** 自定义MD5，前端通过该MD5判断每个节点 的所有 类别、岗位、人员、方案比例 的组合是否相同 20210624 结束 **/
                    Map<Long, List<PaymentdetailsVo>> map = paymentdetails1.stream().collect(groupingBy(PaymentdetailsVo::getPlantype));
                    map.entrySet().forEach(m ->{
                        Map<String, List<PaymentdetailsVo>> map1 = m.getValue().stream().collect(groupingBy(PaymentdetailsVo::getNodeid));
                        map1.entrySet().forEach(f ->{
                            BigDecimal sum = new BigDecimal(0);
                            for (PaymentdetailsVo paymentdetailsVo : f.getValue()) {
                                sum = sum.add(paymentdetailsVo.getPayable() == null ? paymentdetailsVo.getPaytotal() : paymentdetailsVo.getPayable());
                            }
                            for (PaymentdetailsVo paymentdetailsVo : f.getValue()) {
                                paymentdetailsVo.setNodeTotalAmount(sum);
                            }

                        });
                    });

                }
            });
        }

        return planDetails;
    }

    /**
     * 修改核算单，核算交易关系表， 核算交易佣金明细关系表状态为无效
     * 伪删除
     *
     * @param examineBill
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Integer updateExamineBillStatus(ExamineBill examineBill) {
        //删除的操作==伪删除===置为无效
        //明细详情状态改为已生成
        ExamineBill examineBill1 = new ExamineBill();
        examineBill1.setExamineId(examineBill.getExamineId());
        examineBill1.setStatus(Integer.parseInt(PlanEnum.PaymentDetailsStatusDetail.STATUS_102.getCode().toString()));
        paymentdetailsMapper.updateStatus(examineBill1);
        ExaminebillPayment examinebillPayment = new ExaminebillPayment();
        examinebillPayment.setExamineid(examineBill.getExamineId());
        examinebillPayment.setStatus(ExamineEnum.PaymentStatus.STATUS_N.getCode());
        examinebillPayment.setUpdatedate(new Date());
        examinebillPayment.setUpdatereason("无效");
        examinebillPaymentMapper.updateExaminebillPayment(examinebillPayment);
        examinebillTradeMapper.deleteExaminebillTradeById(examineBill.getExamineId());
        return 1;
    }

    /**
     * 核算单交易展示
     *
     * @param trade
     * @return
     */
    @Override
    public List<TradeVo> examineTradeShow(TradeVo trade) {
        List<TradeVo> selectTradeAllList = tradeMapper.examineTradeShow(trade);
        return selectTradeAllList;
    }

    /**
     * 判断是否为可编辑（登陆人是否与创建人一致）
     *
     * @param examineid
     * @return
     */
    @Override
    public Integer isEditable(String examineid) {
        if (examineid != null && examineid != "") {
            ExamineBill examineBill = examinebillMapper.selectExaminebillById(examineid);
            CsmSUser csmSUser = iCsmSUserService.selectCsmSUserByUserName();
            if (csmSUser == null || !csmSUser.getUsername().equals(examineBill.getCreate())) {
                return 0;
            }
        }
        return 1;
    }

    /**
     * 核算单名称添加
     *
     * @param examineBill
     * @return
     */
    @Override
    public AjaxResult addExamineBillName(ExamineBill examineBill) {
        List<ExamineBill> examineBill1 = examinebillMapper.selectExaminebill(examineBill);
        if(examineBill1 != null && examineBill1.size() > 0){
            return AjaxResult.success("核算单名称已重复", 1);
        }
        CsmSUser csmSUser = iCsmSUserService.selectCsmSUserByUserName();
        examineBill.setCreate(csmSUser == null ? "错误" :csmSUser.getUsername());
        examineBill.setCreateId(csmSUser == null ? "错误" : csmSUser.getId());
        examineBill.setCreateDate(new Date());
        examineBill.setStatus(ExamineEnum.ExamineBillStatus.STATUS_CG.getCode());
        examineBill.setExamineId(UUID.randomUUID().toString().replace("-", ""));
        examinebillMapper.insertExaminebill(examineBill);
        return AjaxResult.success("核算单添加成功", examineBill.getExamineId());
    }

    /**
     * 删除交易
     *
     * @param examinebillPayment
     * @return
     */
    @Override
    public AjaxResult deleteTrade(ExaminebillPayment examinebillPayment) {
        if(examinebillPayment == null || examinebillPayment.equals("")){
            return AjaxResult.error(500, "核算单id不能为空且交易id不能为空");
        }
        if(examinebillPayment.getExamineid() == null || examinebillPayment.getExamineid().equals("")){
            return AjaxResult.error(500, "核算单id不能为空");
        }
        if(examinebillPayment.getTradeguid() == null || examinebillPayment.getTradeguid().equals("")){
            return AjaxResult.error(500, "交易id不能为空");
        }
        //明细详情状态改为已生成

        examinebillPayment.setStatus(PlanEnum.PaymentDetailsStatusDetail.STATUS_102.getCode());
        paymentdetailsMapper.updateStatusByExamineIdAndTradeguid(examinebillPayment);
        examinebillPayment.setStatus(ExamineEnum.PaymentStatus.STATUS_N.getCode());
        examinebillPaymentMapper.updateStatusByExamineIdAndTradeguid(examinebillPayment);
        examinebillTradeMapper.deleteByExamineIdAndTradeguid(examinebillPayment);
        return AjaxResult.success("删除交易成功");
    }

    /**
     * 根据核算单id查看核算单人员核发汇总
     * @param examineBillVo
     * @return
     */
    @Override
    public Map<String, Object> examineBillUserSummaryShow(ExamineBillVo examineBillVo) {
        Map<String, Object> map = new HashMap<>();
        if(null == examineBillVo || StrUtil.isBlank(examineBillVo.getExamineId())){
            throw new CustomException("核算单ID不能为空", Constants.ERROR);
        }
        List<ExcelExamineBillSummaryVo> excelExamineBillSummaryVos = examinebillMapper.selectUserSummaryShow(examineBillVo);
        // 合计金额
        BigDecimal sum = excelExamineBillSummaryVos == null ? null : excelExamineBillSummaryVos.stream()
                .map(n -> n.getGrantBusinessCommission()).reduce(BigDecimal.ZERO, BigDecimal::add);
        map.put("excelExamineBillSummaryVos",excelExamineBillSummaryVos);
        map.put("sum",sum);
        return map;
    }

    /**
     * 核算单核发汇总导出
     * @param examineBillVo
     * @return
     */
    @Override
    public void examineBillSummaryExport(ExamineBillVo examineBillVo, OutputStream out) {
        if(null == examineBillVo || StrUtil.isBlank(examineBillVo.getExamineId())){
            throw new CustomException("核算单ID不能为空", Constants.ERROR);
        }
        ExcelWriter writer = ExcelUtil.getWriter(true);
        try {
            ExamineBill examineBill = examinebillMapper.selectExaminebillById(examineBillVo.getExamineId());
            // 标题
            String title = examineBill == null ? "核发汇总表" : examineBill.getExamineName() + "核发汇总表";
            // 项目名
            String projectName = examineBill == null ? "项目：" : "项目：" + examineBill.getHxProjectName();
            // 合并单元格后的标题行，不用默认标题样式
            writer.merge(10, title, false);
            writer.merge(7, projectName, false);
            writer.merge(1, 1, 8, 9,
                    "离职人员须填写工资卡卡号和开户行，在职人员无需填写", false);

            // 设置标题
            setExcelTitle(writer);

            // 查询数据
            Map<String, Object> map = examineBillUserSummaryShow(examineBillVo);

            List<ExcelExamineBillSummaryVo> list = map == null ? null :
                    (List<ExcelExamineBillSummaryVo>) map.get("excelExamineBillSummaryVos");

            BigDecimal sum = map == null ? null : (BigDecimal) map.get("sum");

            if(list != null && list.size() > 0){
                writer.write(list, true);

                writer.merge(4, "合计", false);
                // 获取当前行
                int currentRow = writer.getCurrentRow();
                // 合计金额
                writer.writeCellValue("F" + currentRow, sum);
            }

            // 样式设计
            setExcelCellStyle(writer);

            writer.flush(out, true);
        } catch (Exception e) {
            throw e;
        }finally {
            // 关闭writer，释放内存
            writer.close();
            IoUtil.close(out);
        }
    }

    /**
     * Excel样式设计
     * @param writer
     */
    private void setExcelCellStyle(ExcelWriter writer){
        // 设置自动换行
        CellStyle cellStyle = writer.createCellStyle(8, 1);
        cellStyle.setWrapText(true);
        // 设置居中
        cellStyle.setAlignment(HorizontalAlignment.CENTER);
        // 水平居中
        cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);

        // 设置自动换行
        cellStyle = writer.createCellStyle(1, 2);
        cellStyle.setWrapText(true);
        // 设置背景色 灰
        cellStyle.setFillForegroundColor(IndexedColors.GREY_25_PERCENT.getIndex());
        cellStyle.setFillPattern(FillPatternType.SOLID_FOREGROUND);
        // 设置居中
        cellStyle.setAlignment(HorizontalAlignment.CENTER);
        // 水平居中
        cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);

        // 设置左对齐
        cellStyle = writer.createCellStyle(0, 1);
        cellStyle.setAlignment(HorizontalAlignment.LEFT);
        // 水平居中
        cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);

        // 设置字体加粗
        cellStyle = writer.createCellStyle(0, 0);
        Font font = writer.createFont();
        font.setBold(true);
        cellStyle.setFont(font);
        // 设置居中
        cellStyle.setAlignment(HorizontalAlignment.CENTER);
        // 水平居中
        cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);
        // 设置下边框
        cellStyle.setBorderBottom(BorderStyle.THIN);

        // 设置单元格颜色
        cellStyle = writer.createCellStyle(5, 2);
        // 设置背景色 灰
        cellStyle.setFillForegroundColor(IndexedColors.LIME.getIndex());
        cellStyle.setFillPattern(FillPatternType.SOLID_FOREGROUND);
        // 设置居中
        cellStyle.setAlignment(HorizontalAlignment.CENTER);
        // 水平居中
        cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);

        cellStyle = writer.createCellStyle(6, 2);
        // 设置背景色 灰
        cellStyle.setFillForegroundColor(IndexedColors.LIME.getIndex());
        cellStyle.setFillPattern(FillPatternType.SOLID_FOREGROUND);
        // 设置居中
        cellStyle.setAlignment(HorizontalAlignment.CENTER);
        // 水平居中
        cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);
        // 设置边框
        cellStyle.setBorderRight(BorderStyle.THIN);
        cellStyle.setBorderLeft(BorderStyle.THIN);

        cellStyle = writer.createCellStyle(7, 2);
        // 设置背景色 灰
        cellStyle.setFillForegroundColor(IndexedColors.LIME.getIndex());
        cellStyle.setFillPattern(FillPatternType.SOLID_FOREGROUND);
        // 设置居中
        cellStyle.setAlignment(HorizontalAlignment.CENTER);
        // 水平居中
        cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);

        cellStyle = writer.createCellStyle(8, 2);
        // 设置背景色 灰
        cellStyle.setFillForegroundColor(IndexedColors.YELLOW.getIndex());
        cellStyle.setFillPattern(FillPatternType.SOLID_FOREGROUND);
        // 设置居中
        cellStyle.setAlignment(HorizontalAlignment.CENTER);
        // 水平居中
        cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);
        // 设置边框
        cellStyle.setBorderRight(BorderStyle.THIN);
        cellStyle.setBorderLeft(BorderStyle.THIN);
        cellStyle.setBorderTop(BorderStyle.THIN);

        cellStyle = writer.createCellStyle(9, 2);
        // 设置背景色 灰
        cellStyle.setFillForegroundColor(IndexedColors.YELLOW.getIndex());
        cellStyle.setFillPattern(FillPatternType.SOLID_FOREGROUND);
        // 设置居中
        cellStyle.setAlignment(HorizontalAlignment.CENTER);
        // 水平居中
        cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);

        // 设置行高
        writer.setRowHeight(0, 30);
        writer.setRowHeight(1, 45);
        writer.setRowHeight(2, 30);

        // 设置列宽
        writer.setColumnWidth(0,6);
        writer.setColumnWidth(1,18);
        writer.setColumnWidth(2,16);
        writer.setColumnWidth(3,18);
        writer.setColumnWidth(4,19);
        writer.setColumnWidth(5,14);
        writer.setColumnWidth(6,14);
        writer.setColumnWidth(7,8);
        writer.setColumnWidth(8,20);
        writer.setColumnWidth(9,8);
        writer.setColumnWidth(10,8);

    }

    /**
     * Excel标题设置
     * @param writer
     */
    private void setExcelTitle(ExcelWriter writer){
        //自定义标题别名
        writer.addHeaderAlias("code", "序号");
        writer.addHeaderAlias("employeeCode", "员工ID（务必正确）");
        writer.addHeaderAlias("employeeName", "姓名");
        writer.addHeaderAlias("jobName", "岗位名称");
        writer.addHeaderAlias("idCard", "身份证号（务必正确）");
        writer.addHeaderAlias("grantBusinessCommission", "应发佣金");
        writer.addHeaderAlias("mobile", "手机号");
        writer.addHeaderAlias("dataStatus", "员工状态");
        writer.addHeaderAlias("bankCardNo", "工资卡号");
        writer.addHeaderAlias("bankName", "开户行");
        writer.addHeaderAlias("remark", "备注");
    }

    /**
     * 核算单统计视图报表导出
     *
     * @param examineBillVo
     * @return
     */
    @Override
    public AjaxResult examineBillShowSummary(ExamineBillVo examineBillVo, OutputStream out) {
        CsmSUser csmSUser = iCsmSUserService.selectCsmSUserByUserName();
        examineBillVo.setUserName(csmSUser == null ? "maowei" : csmSUser.getUsername());
        // 查询项目列表
        List<String> projectIds = csmSProjectMapper.getProject(csmSUser == null ? "maowei" : csmSUser.getUsername());
        examineBillVo.setProjectIds(projectIds);
        /*
        List<ExcelExamineBill> list = new ArrayList<>();

         */
        List<ExcelExamineBill> examineBillList = examineReportDetailsMapper.selectExamineReportDetailsListByWhere(examineBillVo);
        /*examineBillList.stream().forEach(p -> {
            list.add(JSON.parseObject(p.getData(),ExcelExamineBill.class));
        });
         */

        this.excelPort(examineBillVo,examineBillList, out);
        return AjaxResult.success();
        /*
        if (list == null || list.size() <= 0) {
            this.excelPort(examineBillVo,list, out);
            return AjaxResult.success();
        } else {
            this.excelPort(examineBillVo,list, out);
            return AjaxResult.success();
        }
         */
    }


    /**
     * 核算单核发视图报表导出
     *
     * @param examineBillVo
     * @return
     */
    @Override
    public AjaxResult examineBillShowUserSummary(ExamineBillVo examineBillVo, OutputStream out) {
        CsmSUser csmSUser = iCsmSUserService.selectCsmSUserByUserName();
        examineBillVo.setUserName(csmSUser == null ? "maowei" : csmSUser.getUsername());
        // 查询项目列表
        List<String> projectIds = csmSProjectMapper.getProject(csmSUser == null ? "maowei" : csmSUser.getUsername());
        examineBillVo.setProjectIds(projectIds);


        ExcelWriter writer = ExcelUtil.getWriter(true);
        try {

            // 标题
            String title = "核算单核发表" ;

            writer.merge(10, title, false);
            writer.merge(7, "", false);
            writer.merge(1, 1, 8, 9,
                    "离职人员须填写工资卡卡号和开户行，在职人员无需填写", false);

            // 设置标题
            setExcelTitle(writer);

            List<ExcelExamineBillSummaryVo> list = examinebillMapper.selectUserSummaryShowByWhere(examineBillVo);


            if(list==null||list.size()<=0){
                writer.writeCellValue(0,2,"序号");
                writer.writeCellValue(1,2,"员工ID（务必正确）");
                writer.writeCellValue(2,2,"姓名");
                writer.writeCellValue(3,2,"岗位名称");
                writer.writeCellValue(4,2,"身份证号（务必正确）");
                writer.writeCellValue(5,2,"应发佣金");
                writer.writeCellValue(6,2,"手机号");
                writer.writeCellValue(7,2,"员工状态");
                writer.writeCellValue(8,2,"工资卡号");
                writer.writeCellValue(9,2,"开户行");
                writer.writeCellValue(10,2,"备注");
            }
            if(list != null && list.size() > 0){
                writer.write(list, true);
            }
            // 样式设计
            setExcelCellStyle(writer);

            writer.flush(out, true);
        } catch (Exception e) {
            throw e;
        }finally {
            // 关闭writer，释放内存
            writer.close();
            IoUtil.close(out);
        }



        return AjaxResult.success();
        /*
        if (list == null || list.size() <= 0) {
            this.excelPort(examineBillVo,list, out);
            return AjaxResult.success();
        } else {
            this.excelPort(examineBillVo,list, out);
            return AjaxResult.success();
        }
         */
    }




    /**
     * 核算单统计试图报表导出-文件操作
     * @param examineBillVo
     * @param list
     * @param out
     */
    public void excelPort(ExamineBillVo examineBillVo, List<ExcelExamineBill> list, OutputStream out) {
        try {
            // Excel模板文件路径
            ClassPathResource classPathResource = new ClassPathResource("static/excel/examineBill.xlsx");
            InputStream stream = classPathResource.getStream();
            //读取模板文件创建Excel表格对象
            XSSFWorkbook workbook = new XSSFWorkbook(stream);

            // 获取模板文件第一个sheet，对应Excel文件中的sheet
            XSSFSheet sheet = workbook.getSheetAt(0);
            // 设置单元格格式居中
            XSSFCellStyle cellStyle = workbook.createCellStyle();
            cellStyle.setAlignment(HorizontalAlignment.CENTER);
            //新增单元格格式
            cellStyle.setBorderTop(BorderStyle.THIN);
            cellStyle.setBorderBottom(BorderStyle.THIN);
            cellStyle.setBorderLeft(BorderStyle.THIN);
            cellStyle.setBorderRight(BorderStyle.THIN);
            cellStyle.setTopBorderColor(HSSFColor.BLACK.index);
            cellStyle.setBottomBorderColor(HSSFColor.BLACK.index);
            cellStyle.setLeftBorderColor(HSSFColor.BLACK.index);
            cellStyle.setRightBorderColor(HSSFColor.BLACK.index);
            cellStyle.setWrapText(true);
            cellStyle.setDataFormat(workbook.createDataFormat().getFormat("@"));

            XSSFCellStyle cellStyle_date = workbook.createCellStyle();
            cellStyle_date.setAlignment(HorizontalAlignment.CENTER);
            cellStyle_date.setBorderTop(BorderStyle.THIN);
            cellStyle_date.setBorderBottom(BorderStyle.THIN);
            cellStyle_date.setBorderLeft(BorderStyle.THIN);
            cellStyle_date.setBorderRight(BorderStyle.THIN);
            cellStyle_date.setTopBorderColor(HSSFColor.BLACK.index);
            cellStyle_date.setBottomBorderColor(HSSFColor.BLACK.index);
            cellStyle_date.setLeftBorderColor(HSSFColor.BLACK.index);
            cellStyle_date.setRightBorderColor(HSSFColor.BLACK.index);
            cellStyle_date.setWrapText(true);
            cellStyle_date.setDataFormat(workbook.createDataFormat().getFormat("yyyy-MM-dd"));

            XSSFCellStyle cellStyle_double = workbook.createCellStyle();
            cellStyle_double.setAlignment(HorizontalAlignment.CENTER);
            cellStyle_double.setBorderTop(BorderStyle.THIN);
            cellStyle_double.setBorderBottom(BorderStyle.THIN);
            cellStyle_double.setBorderLeft(BorderStyle.THIN);
            cellStyle_double.setBorderRight(BorderStyle.THIN);
            cellStyle_double.setTopBorderColor(HSSFColor.BLACK.index);
            cellStyle_double.setBottomBorderColor(HSSFColor.BLACK.index);
            cellStyle_double.setLeftBorderColor(HSSFColor.BLACK.index);
            cellStyle_double.setRightBorderColor(HSSFColor.BLACK.index);
            cellStyle_double.setWrapText(true);
            cellStyle_double.setDataFormat(workbook.createDataFormat().getFormat("0.00"));

            // 获取对应行号
            XSSFRow row = sheet.getRow(0);
            XSSFRow row1 = sheet.getRow(0);
            XSSFCell cell1 = row.createCell(0);
            XSSFCellStyle cellStyle1 = workbook.createCellStyle();
            cellStyle1.setAlignment(HorizontalAlignment.CENTER);
            CellRangeAddress region1 = new CellRangeAddress(0, 1, 0, 64);
            cell1.setCellValue("核算单统计表");
            cell1.setCellStyle(cellStyle1);
            sheet.addMergedRegion(region1);
            int listSize = list.size();
            ExcelExamineBill excelExamineBill;
            XSSFCell cell;
            // 对应单元格填入数据
            for (int i = 0; i < listSize; i++) {
                row = sheet.createRow((int) i + 5);
                excelExamineBill = list.get(i);
                // 创建单元格，并设置值
                cell = row.createCell(0);
                //if (i == list.size() - 1) {
                  /*  cell.setCellValue("合计");
                    cell.setCellStyle(cellStyle);
                    CellRangeAddress region = new CellRangeAddress(i + 5, i + 5, 0, 5);
                    // 使用RegionUtil类为合并后的单元格添加边框
                    RegionUtil.setBorderBottom(1, region, sheet); // 下边框
                    RegionUtil.setBorderLeft(1, region, sheet); // 左边框
                    RegionUtil.setBorderRight(1, region, sheet); // 有边框
                    RegionUtil.setBorderTop(1, region, sheet); // 上边框
                    sheet.addMergedRegion(region);*/
                //} else {
                    cell.setCellValue(String.valueOf(i + 1));
                    cell.setCellStyle(cellStyle);
                    //sheet.autoSizeColumn(0, true);

                    cell = row.createCell(1);
                    cell.setCellValue(excelExamineBill.getOrgName());
                    cell.setCellStyle(cellStyle);
                    //sheet.autoSizeColumn(1, true);

                    cell = row.createCell(2);
                    cell.setCellValue(excelExamineBill.getProjname());
                    cell.setCellStyle(cellStyle);
                    //sheet.autoSizeColumn(2, true);

                    cell = row.createCell(3);
                    cell.setCellValue(excelExamineBill.getProductName());
                    cell.setCellStyle(cellStyle);
                    //sheet.autoSizeColumn(3, true);

                    cell = row.createCell(4);
                    cell.setCellValue(excelExamineBill.getCstname());
                    cell.setCellStyle(cellStyle);
                    //sheet.autoSizeColumn(4, true);

                    cell = row.createCell(5);
                    cell.setCellValue(excelExamineBill.getRoominfo());
                    cell.setCellStyle(cellStyle);
                    //sheet.autoSizeColumn(5, true);
                //}


                cell = row.createCell(6);
                cell.setCellValue(excelExamineBill.getOrderQsdate());
                cell.setCellStyle(cellStyle_date);
                //sheet.autoSizeColumn(6, true);

                cell = row.createCell(7);
                cell.setCellValue(excelExamineBill.getContractQsdate());
                cell.setCellStyle(cellStyle_date);
                //sheet.autoSizeColumn(7, true);

                cell = row.createCell(8);
//                cell.setCellValue(excelExamineBill.getRmbhttotal() == null ? null : excelExamineBill.getRmbhttotal().toString());
                if (excelExamineBill.getRmbhttotal() != null) {
                    cell.setCellValue(excelExamineBill.getRmbhttotal().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(8, true);

                cell = row.createCell(9);
//                cell.setCellValue(excelExamineBill.getOffsetMoney() == null ? null : excelExamineBill.getOffsetMoney().toString());
                if (excelExamineBill.getOffsetMoney() != null) {
                    cell.setCellValue(excelExamineBill.getOffsetMoney().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(9, true);

                cell = row.createCell(10);
                cell.setCellValue(excelExamineBill.getLastOffsetDate());
                cell.setCellStyle(cellStyle_date);
                //sheet.autoSizeColumn(10, true);

                cell = row.createCell(11);
                cell.setCellValue(excelExamineBill.getPayFormClass());
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(11, true);

                cell = row.createCell(12);
                cell.setCellValue(excelExamineBill.getReferagentname());
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(12, true);

                cell = row.createCell(13);
                cell.setCellValue(excelExamineBill.getServiceFeeSettlementStandard()); // 费用收入
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(13, true);

                cell = row.createCell(14);
                cell.setCellValue(excelExamineBill.getTokerfee() == null ? null : excelExamineBill.getTokerfee().toString());
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(14, true);

                cell = row.createCell(15);
                cell.setCellValue("");
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(15, true);

                cell = row.createCell(16);
                cell.setCellValue("");
                cell.setCellStyle(cellStyle_date);
                //sheet.autoSizeColumn(16, true);

                cell = row.createCell(17);
                if (excelExamineBill.getAgencyfeetype() != null && excelExamineBill.getAgencyfeetype() == 1) {
                    cell.setCellValue(excelExamineBill.getAgencyFee() == null ? null :
                            (excelExamineBill.getAgencyFee().toString() + "%"));
                    cell.setCellStyle(cellStyle);
                } else {
                    if (excelExamineBill.getAgencyFee() != null) {
                        cell.setCellValue(excelExamineBill.getAgencyFee().doubleValue());
                    }else {
                        cell.setCellValue("");
                    }
                    cell.setCellStyle(cellStyle_double);
                }
                //sheet.autoSizeColumn(17, true);

                cell = row.createCell(18);
                if (excelExamineBill.getAgencyFeeSum() != null) {
                    cell.setCellValue(excelExamineBill.getAgencyFeeSum().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(18, true);

                cell = row.createCell(19);
                if (excelExamineBill.getForesightMoney() != null) {
                    cell.setCellValue(excelExamineBill.getForesightMoney().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(19, true);

                cell = row.createCell(20);
                if (excelExamineBill.getJfbond() != null) {
                    cell.setCellValue(excelExamineBill.getJfbond().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(20, true);

                cell = row.createCell(21);
                cell.setCellValue("");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(21, true);

                cell = row.createCell(22);
                cell.setCellValue("");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(22, true);

                cell = row.createCell(23);
                cell.setCellValue("");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(23, true);

                cell = row.createCell(24);
                if (excelExamineBill.getTaxesMoney() != null) {
                    cell.setCellValue(excelExamineBill.getTaxesMoney().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(24, true);

                cell = row.createCell(25);
                if (excelExamineBill.getManageratioMoney() != null) {
                    cell.setCellValue(excelExamineBill.getManageratioMoney().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(25, true);

                cell = row.createCell(26);
                if (excelExamineBill.getControlratioMoney() != null) {
                    cell.setCellValue(excelExamineBill.getControlratioMoney().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(26, true);

                cell = row.createCell(27);
                cell.setCellValue(excelExamineBill.getPaymentpackAmount() == null ? null : excelExamineBill.getPaymentpackAmount().toString() + "%");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(27, true);

                cell = row.createCell(28);
                if (excelExamineBill.getNodeSumMoneyAll() != null) {
                    cell.setCellValue(excelExamineBill.getNodeSumMoneyAll().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(28, true);

                cell = row.createCell(29);
                cell.setCellValue(excelExamineBill.getCommissionRatio() == null ? null : excelExamineBill.getCommissionRatio().toString() + "%");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(29, true);

                cell = row.createCell(30);
                if (excelExamineBill.getNodeSumMoneyTotal() != null) {
                    cell.setCellValue(excelExamineBill.getNodeSumMoneyTotal().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(30, true);

                cell = row.createCell(31);
                if (excelExamineBill.getNodeSumMoney() != null) {
                    cell.setCellValue(excelExamineBill.getNodeSumMoney().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(31, true);

                cell = row.createCell(32);
                cell.setCellValue(excelExamineBill.getMarketer());
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(32, true);

                cell = row.createCell(33);
                cell.setCellValue(excelExamineBill.getExecutive());
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(33, true);

                cell = row.createCell(34);
                cell.setCellValue(excelExamineBill.getManager());
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(34, true);

                cell = row.createCell(35);
                cell.setCellValue(excelExamineBill.getStagehand());
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(35, true);

                cell = row.createCell(36);
                cell.setCellValue(excelExamineBill.getPlanner());
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(36, true);

                cell = row.createCell(37);
                cell.setCellValue(excelExamineBill.getPrincipal());
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(37, true);

                cell = row.createCell(38);
                if(excelExamineBill.getDlTgSumMoney() != null){
                    cell.setCellValue(excelExamineBill.getDlTgSumMoney().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(38, true);

                cell = row.createCell(39);
                cell.setCellValue(excelExamineBill.getMarketerRatio() == null ? null : excelExamineBill.getMarketerRatio().toString() + "%");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(39, true);

                cell = row.createCell(40);
                if (excelExamineBill.getMarketerSalary() != null) {
                    cell.setCellValue(excelExamineBill.getMarketerSalary().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(40, true);

                cell = row.createCell(41);
                if (excelExamineBill.getMarketerPayroll() != null) {
                    cell.setCellValue(excelExamineBill.getMarketerPayroll().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(41, true);

                cell = row.createCell(42);
                cell.setCellValue(excelExamineBill.getExecutiveRatio() == null ? null : excelExamineBill.getExecutiveRatio().toString() + "%");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(42, true);

                cell = row.createCell(43);
                if (excelExamineBill.getExecutiveSalary() != null) {
                    cell.setCellValue(excelExamineBill.getExecutiveSalary().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(43, true);

                cell = row.createCell(44);
                if (excelExamineBill.getExecutivePayroll() != null) {
                    cell.setCellValue(excelExamineBill.getExecutivePayroll().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(44, true);

                cell = row.createCell(45);
                cell.setCellValue(excelExamineBill.getManagerRatio() == null ? null : excelExamineBill.getManagerRatio().toString() + "%");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(45, true);

                cell = row.createCell(46);
                if (excelExamineBill.getManagerSalary() != null) {
                    cell.setCellValue(excelExamineBill.getManagerSalary().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(46, true);

                cell = row.createCell(47);
                cell.setCellValue(excelExamineBill.getManagerProportion() == null ? null : excelExamineBill.getManagerProportion().toString() + "%");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(47, true);

                cell = row.createCell(48);
                if (excelExamineBill.getManagerPayroll() != null) {
                    cell.setCellValue(excelExamineBill.getManagerPayroll().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(48, true);

                cell = row.createCell(49);
                cell.setCellValue(excelExamineBill.getStagehandRatio() == null ? null : excelExamineBill.getStagehandRatio().toString() + "%");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(49, true);

                cell = row.createCell(50);
                if (excelExamineBill.getStagehandSalary() != null) {
                    cell.setCellValue(excelExamineBill.getStagehandSalary().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(50, true);

                cell = row.createCell(51);
                cell.setCellValue(excelExamineBill.getStagehandProportion() == null ? null : excelExamineBill.getStagehandProportion().toString() + "%");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(51, true);

                cell = row.createCell(52);
                if (excelExamineBill.getStagehandPayroll() != null) {
                    cell.setCellValue(excelExamineBill.getStagehandPayroll().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(52, true);

                cell = row.createCell(53);
                cell.setCellValue(excelExamineBill.getPlannerRatio() == null ? null : excelExamineBill.getPlannerRatio().toString() + "%");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(53, true);

                cell = row.createCell(54);
                if (excelExamineBill.getPlannerSalary() != null) {
                    cell.setCellValue(excelExamineBill.getPlannerSalary().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(54, true);

                cell = row.createCell(55);
                cell.setCellValue(excelExamineBill.getPlannerProportion() == null ? null : excelExamineBill.getPlannerProportion().toString() + "%");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(55, true);

                cell = row.createCell(56);
                if (excelExamineBill.getPlannerPayroll() != null) {
                    cell.setCellValue(excelExamineBill.getPlannerPayroll().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(56, true);

                cell = row.createCell(57);
                cell.setCellValue(excelExamineBill.getPrincipalRatio() == null ? null : excelExamineBill.getPrincipalRatio().toString() + "%");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(57, true);

                cell = row.createCell(58);
                if (excelExamineBill.getPrincipalSalary() != null) {
                    cell.setCellValue(excelExamineBill.getPrincipalSalary().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(58, true);

                cell = row.createCell(59);
                cell.setCellValue(excelExamineBill.getPrincipalProportion() == null ? null : excelExamineBill.getPrincipalProportion().toString() + "%");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(59, true);

                cell = row.createCell(60);
                if (excelExamineBill.getPrincipalPayroll() != null) {
                    cell.setCellValue(excelExamineBill.getPrincipalPayroll().doubleValue());
                }else {
                    cell.setCellValue("");
                }
                cell.setCellStyle(cellStyle_double);
                //sheet.autoSizeColumn(60, true);

                cell = row.createCell(61);
                cell.setCellValue("");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(61, true);

                cell = row.createCell(62);
                cell.setCellValue("");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(62, true);

                cell = row.createCell(63);
                cell.setCellValue("");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(63, true);

                cell = row.createCell(64);
                cell.setCellValue("");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(64, true);

                cell = row.createCell(65);
                cell.setCellValue("");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(65, true);

                cell = row.createCell(66);
                cell.setCellValue("");
                cell.setCellStyle(cellStyle);
                //sheet.autoSizeColumn(66, true);
            }
            row = sheet.createRow((int) list.size() + 7);
            // 创建单元格，并设置值
            cell = row.createCell(0);
            cell = row.createCell(23);
            cell.setCellValue("制表人：");
            cell = row.createCell(43);
            cell.setCellValue("负责人：");

            try {
                workbook.write(out);
                out.close();
            } catch (Exception e) {
                e.printStackTrace();
            }

        } catch (IOException e) {
            e.printStackTrace();

        }

    }

}
