package com.huaxia.hx_sell_commission.service.impl;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.huaxia.hx_sell_commission.mapper.db1.PaymenttempFileMapper;
import com.huaxia.hx_sell_commission.domain.PaymenttempFile;
import com.huaxia.hx_sell_commission.service.IPaymenttempFileService;
import lombok.extern.slf4j.Slf4j;

/**
 * Service业务层处理
 * 
 * @author shilei
 * @date 2020-11-16
 */
@Service
@Slf4j
public class PaymenttempFileServiceImpl implements IPaymenttempFileService 
{
    @Autowired
    private PaymenttempFileMapper paymenttempFileMapper;

    /**
     * 查询
     * 
     * @param tempid ID
     * @return 
     */
    @Override
    public PaymenttempFile selectPaymenttempFileById(String tempid)
    {
        return paymenttempFileMapper.selectPaymenttempFileById(tempid);
    }

    /**
     * 查询列表
     * 
     * @param paymenttempFile 
     * @return 
     */
    @Override
    public List<PaymenttempFile> selectPaymenttempFileList(PaymenttempFile paymenttempFile)
    {
        return paymenttempFileMapper.selectPaymenttempFileList(paymenttempFile);
    }

    /**
     * 新增
     * 
     * @param paymenttempFile 
     * @return 结果
     */
    @Override
    public int insertPaymenttempFile(PaymenttempFile paymenttempFile)
    {
        return paymenttempFileMapper.insertPaymenttempFile(paymenttempFile);
    }

    /**
     * 修改
     * 
     * @param paymenttempFile 
     * @return 结果
     */
    @Override
    public int updatePaymenttempFile(PaymenttempFile paymenttempFile)
    {
        return paymenttempFileMapper.updatePaymenttempFile(paymenttempFile);
    }

    /**
     * 删除信息
     * 
     * @param fileId ID
     * @return 结果
     */
    @Override
    public int deletePaymenttempFileByFileId(String fileId)
    {
        return paymenttempFileMapper.deletePaymenttempFileByFileId(fileId);
    }
}
