package com.huaxia.hx_sell_commission.utils;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;

import java.util.List;

/**
 * Title:
 * 功能描述：
 * 分页
 *
 * @return
 * @Author: shilei
 * @date 2020/11/10
 */
public class PageUtil {

    /**
     * 初始化分页对象
     *
     * @param page 当前页码
     * @param size 每页记录数
     */
    public static void startPage(int page, int size) {
        PageHelper.startPage(page, size);
    }

    /**
     * 初始化分页对象 新增排序
     *
     * @param page 当前页码
     * @param size 每页记录数
     * @param sort 排序
     */
    public static void startPage(int page, int size, String sort) {
        PageHelper.startPage(page, size, sort);
    }


    /**
     * 创建分页对象
     *
     * @param list
     * @return
     */
    public static PageVO createPage(List list) {
//        Page page = new Page();
        PageVO page = new PageVO();
        PageInfo pageInfo = new PageInfo(list);
//        page.setTotal(pageInfo.getTotal());
        page.setTotalElements(pageInfo.getTotal());
        page.setNumber(pageInfo.getPageNum() - 1);
        page.setTotalPages(pageInfo.getPages());
        page.setSize(pageInfo.getPageSize());
        page.setContent(pageInfo.getList());
        return page;
    }
}
