package com.huaxia.hx_sell_commission.utils;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Sort;

import java.util.List;

/**
 * 带泛型的分页对象
 *
 * @project: bid-2
 * @since: v1.0
 * @author: shilei
 * @date: 2020/11/10
 */
public class PageVO<T> {

    private long totalElements;

    private int totalPages;

    private boolean first;

    private boolean last;

    private int number;

    private int size;

    private int numberOfElements;

    private Sort sort;

    private List<T> content;

    public PageVO() {

    }

    public PageVO(Page<T> page) {
        this.first = page.isFirst();
        this.last = page.isLast();

        this.number = page.getNumber();
        this.numberOfElements = page.getNumberOfElements();
        this.size = page.getSize();
        this.totalElements = page.getTotalElements();
        this.totalPages = page.getTotalPages();
        this.sort = page.getSort();
        this.content = page.getContent();
    }

    public long getTotalElements() {
        return totalElements;
    }

    public void setTotalElements(long totalElements) {
        this.totalElements = totalElements;
    }

    public int getTotalPages() {
        return totalPages;
    }

    public void setTotalPages(int totalPages) {
        this.totalPages = totalPages;
    }

    public boolean isFirst() {
        return first;
    }

    public void setFirst(boolean first) {
        this.first = first;
    }

    public boolean isLast() {
        return last;
    }

    public void setLast(boolean last) {
        this.last = last;
    }

    public int getNumber() {
        return number;
    }

    public void setNumber(int number) {
        this.number = number;
    }

    public int getSize() {
        return size;
    }

    public void setSize(int size) {
        this.size = size;
    }

    public int getNumberOfElements() {
        return numberOfElements;
    }

    public void setNumberOfElements(int numberOfElements) {
        this.numberOfElements = numberOfElements;
    }

    public Sort getSort() {
        return sort;
    }

    public void setSort(Sort sort) {
        this.sort = sort;
    }

    public List<T> getContent() {
        return content;
    }

    public void setContent(List<T> content) {
        this.content = content;
    }

    @Override
    public String toString() {
        return "PageVO{" +
                "totalElements=" + totalElements +
                ", totalPages=" + totalPages +
                ", first=" + first +
                ", last=" + last +
                ", number=" + number +
                ", size=" + size +
                ", numberOfElements=" + numberOfElements +
                ", sort=" + sort +
                ", content=" + content +
                '}';
    }
}
