package com.huaxia.hx_sell_commission.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class ExcelExamineBill {

    /** 交易ID */
    @ApiModelProperty(value = "交易ID")
    private String tradeguid;

    /** 分公司 */
    @Excel(name = "分公司")
    @ApiModelProperty(value = "分公司")
    private String orgName;

    /** 认购金额 */
    @Excel(name = "认购金额")
    @ApiModelProperty(value = "认购金额")
    private BigDecimal cjtotal;

    /** 签约金额 */
    @Excel(name = "签约金额")
    @ApiModelProperty(value = "签约金额")
    private BigDecimal rmbhttotal;

    /** 认购时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "认购时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "认购时间")
    private Date orderQsdate;

    /** 签约时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "签约时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "签约时间")
    private Date contractQsdate;


    /** 项目名称 */
    @Excel(name = "项目名称")
    @ApiModelProperty(value = "项目名称")
    private String projname;


    /** 房间名称 */
    @Excel(name = "房间名称")
    @ApiModelProperty(value = "房间名称")
    private String roominfo;


    /** 成交报备人 */
    @Excel(name = "成交报备人")
    @ApiModelProperty(value = "成交报备人")
    private String refer;

    /** 报备人公司 */
    @Excel(name = "报备人公司")
    @ApiModelProperty(value = "报备人公司")
    private String referagentname;

    /** 服务费结算标准 */
    @Excel(name = "服务费结算标准")
    @ApiModelProperty(value = "服务费结算标准")
    private String serviceFeeSettlementStandard;

    /** 成交接待人 */
    @Excel(name = "成交接待人")
    @ApiModelProperty(value = "成交接待人")
    private String ywy;

    /** 接待人公司 */
    @Excel(name = "接待人公司")
    @ApiModelProperty(value = "接待人公司")
    private String ywyagentname;

    /** 已冲抵金额 */
    @Excel(name = "到账金额")
    @ApiModelProperty(value = "到账金额")
    private BigDecimal offsetMoney;

    /** 全款到账日期 如果所有应收款项都已冲抵，取最后一笔应收完全冲抵的日期；未冲抵完，则为空 */
    @Excel(name = "全款到账日期")
    @ApiModelProperty(value = "全款到账日期")
    private Date lastOffsetDate;

    /** 是否完全冲抵 1是 0否 */
    @Excel(name = "是否完全冲抵 1是 0否")
    @ApiModelProperty(value = "是否完全冲抵 1是 0否")
    private Integer isFullOffset;

    /** 付款方式 */
    @Excel(name = "付款方式")
    @ApiModelProperty(value = "付款方式")
    private String payFormClass;

    /** 业态 */
    @Excel(name = "业态")
    @ApiModelProperty(value = "业态")
    private String ProductName;

    @ApiModelProperty(value = "成交报备人岗位名称")
    @Excel(name = "成交报备人岗位名称")
    private String referJobName;

    @ApiModelProperty(value = "成交接待人岗位名称")
    @Excel(name = "成交接待人岗位名称")
    private String ywyJobName;

    @ApiModelProperty(value = "项目ID")
    @Excel(name = "项目ID")
    private String hxProjectId;

    @ApiModelProperty(value = "团购费佣金手动")
    @Excel(name = "团购费佣金")
    private BigDecimal tgfee;

    @ApiModelProperty(value = "团购费服务费第三方拓客费用")
    @Excel(name = "团购费服务费第三方拓客费用")
    private BigDecimal tokerfee;

    @ApiModelProperty(value = "代理费佣金手动")
    @Excel(name = "代理费佣金")
    private BigDecimal agentfee;

    @ApiModelProperty(value = "客户姓名")
    @Excel(name = "客户姓名")
    private String cstname;

    @Excel(name = "交房保证金数值")
    @ApiModelProperty(value = "交房保证金数值")
    private BigDecimal jfbond;

    @Excel(name = "税金")
    @ApiModelProperty(value = "税金")
    private BigDecimal taxesMoney;

    /** 代理费结算标准 */
    @Excel(name = "代理费结算标准")
    @ApiModelProperty(value = "代理费结算标准")
    private BigDecimal agencyFee;

    @ApiModelProperty(value = "接待费总金额")
    private BigDecimal agencyFeeSum;

    @ApiModelProperty(value = "1 比例 2 固定金额")
    private Long agencyfeetype;

    @Excel(name = "佣金包占比")
    @ApiModelProperty(value = "佣金包占比")
    private BigDecimal paymentpackAmount;

    @ApiModelProperty(value = "佣金自销管理费")
    @Excel(name = "佣金自销管理费")
    private BigDecimal manageratioMoney;

    @ApiModelProperty(value = "项目可支配收入")
    @Excel(name = "佣金支配收入")
    private BigDecimal controlratioMoney;

    private BigDecimal controlratioMoneyTg;
    private BigDecimal controlratioMoneyDl;

    @ApiModelProperty(value = "手动调整后的代理费佣金-交房节点的钱")
    @Excel(name = "先行结算金额")
    private BigDecimal foresightMoney;

    @ApiModelProperty(value = "代理费划拨比例==----本核算单所涉及的节点的代理费金额除以全部代理费金额")
    @Excel(name = "代理费划拨比例")
    private BigDecimal transferRatio;

    //=========usertypename user不同，展示不同=============
    /** 类别名称 */
    @Excel(name = "销售代表")
    @ApiModelProperty(value = "销售代表")
    private String marketer;

    @Excel(name = "销售主管")
    @ApiModelProperty(value = "销售主管")
    private String executive;

    @Excel(name = "销售经理")
    @ApiModelProperty(value = "销售经理")
    private String manager;

    @Excel(name = "后台人员")
    @ApiModelProperty(value = "后台人员")
    private String stagehand;

    @Excel(name = "策划人员")
    @ApiModelProperty(value = "策划人员")
    private String planner;

    @Excel(name = "自销负责人")
    @ApiModelProperty(value = "自销负责人")
    private String principal;

    //========各类人员的佣金占比===========================
    @Excel(name = "销售代表佣金占比")
    @ApiModelProperty(value = "销售代表佣金占比")
    private BigDecimal marketerRatio;

    @Excel(name = "销售主管佣金占比")
    @ApiModelProperty(value = "销售主管佣金占比")
    private BigDecimal executiveRatio;

    @Excel(name = "销售经理佣金占比")
    @ApiModelProperty(value = "销售经理佣金占比")
    private BigDecimal managerRatio;

    @Excel(name = "后台人员佣金占比")
    @ApiModelProperty(value = "后台人员佣金占比")
    private BigDecimal stagehandRatio;

    @Excel(name = "策划人员佣金占比")
    @ApiModelProperty(value = "策划人员佣金占比")
    private BigDecimal plannerRatio;

    @Excel(name = "自销负责人佣金占比")
    @ApiModelProperty(value = "自销负责人佣金占比")
    private BigDecimal principalRatio;

    @Excel(name = "本次计发比例")
    @ApiModelProperty(value = "本次计发比例====本核算单中选中条目所在节点总额与全部佣金总额的比值")
    private BigDecimal commissionRatio;

    @Excel(name = "本次佣金包金额")
    @ApiModelProperty(value = "本次佣金包金额")
    private BigDecimal nodeSumMoney;

    @Excel(name = "佣金包金额（不含收楼控存）")
    @ApiModelProperty(value = "佣金包金额（不含收楼控存）====本核算单中选中条目所在节点总额")
    private BigDecimal nodeSumMoneyAll;

    @Excel(name = "本次佣金实发计发金额")
    @ApiModelProperty(value = "本次佣金实发计发金额(代理费佣金+团购费佣金)")
    private BigDecimal DlTgSumMoney;

    //========各类人员的佣金占比===========================
    @Excel(name = "销售代表佣金应发金额")
    @ApiModelProperty(value = "销售代表佣金应发金额")
    private BigDecimal marketerSalary;

    @Excel(name = "销售主管佣金应发金额")
    @ApiModelProperty(value = "销售主管佣金应发金额")
    private BigDecimal executiveSalary;

    @Excel(name = "销售经理佣金应发金额")
    @ApiModelProperty(value = "销售经理佣金应发金额")
    private BigDecimal managerSalary;

    @Excel(name = "后台人员佣金应发金额")
    @ApiModelProperty(value = "后台人员佣金应发金额")
    private BigDecimal stagehandSalary;

    @Excel(name = "策划人员佣金应发金额")
    @ApiModelProperty(value = "策划人员佣金应发金额")
    private BigDecimal plannerSalary;

    @Excel(name = "自销负责人佣金应发金额")
    @ApiModelProperty(value = "自销负责人佣金应发金额")
    private BigDecimal principalSalary;

    //========各类人员的佣金占比===========================
    @Excel(name = "销售代表佣金实发金额")
    @ApiModelProperty(value = "销售代表佣金实发金额")
    private BigDecimal marketerPayroll;

    @Excel(name = "销售主管佣金实发金额")
    @ApiModelProperty(value = "销售主管佣金实发金额")
    private BigDecimal executivePayroll;

    @Excel(name = "销售经理佣金实发金额")
    @ApiModelProperty(value = "销售经理佣金实发金额")
    private BigDecimal managerPayroll;

    @Excel(name = "后台人员佣金实发金额")
    @ApiModelProperty(value = "后台人员佣金实发金额")
    private BigDecimal stagehandPayroll;

    @Excel(name = "策划人员佣金实发金额")
    @ApiModelProperty(value = "策划人员佣金实发金额")
    private BigDecimal plannerPayroll;

    @Excel(name = "自销负责人佣金实发金额")
    @ApiModelProperty(value = "自销负责人佣金实发金额")
    private BigDecimal principalPayroll;

    //========各类人员的月度佣金计发比例===========================
    @Excel(name = "销售经理月度佣金计发比例")
    @ApiModelProperty(value = "销售经理月度佣金计发比例")
    private BigDecimal managerProportion;

    @Excel(name = "后台人员月度佣金计发比例")
    @ApiModelProperty(value = "后台人员月度佣金计发比例")
    private BigDecimal stagehandProportion;

    @Excel(name = "策划人员月度佣金计发比例")
    @ApiModelProperty(value = "策划人员月度佣金计发比例")
    private BigDecimal plannerProportion;

    @Excel(name = "自销负责人月度佣金计发比例")
    @ApiModelProperty(value = "自销负责人月度佣金计发比例")
    private BigDecimal principalProportion;

    //=========核算单名称===========================
    @Excel(name = "核算单名称")
    @ApiModelProperty(value = "核算单名称")
    private String examineName;

    @ApiModelProperty(value = "本次发放佣金包金额")
    private BigDecimal nodeSumMoneyTotal;
}
