package com.huaxia.hx_sell_commission.vo;

import com.huaxia.hx_sell_commission.domain.*;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;


/**
 * 佣金方案详情对象 plan
 * 
 * @author shilei
 * @date 2020-11-18
 */
@Data
public class PlanVo extends Plan {

    @ApiModelProperty(value = "佣金方案费用信息对象")
    private Planfee planfee;

    @ApiModelProperty(value = "佣金方案_支付节点对象集合")
    private List<PlanPaynodeVo> planPaynodeVos;

    @ApiModelProperty(value = "是否进入核算：Y是，N否")
    private String examStatus;

    @ApiModelProperty(value = "团购费已结算金额")
    private BigDecimal tSettled;

    @ApiModelProperty(value = "代理费已结算金额")
    private BigDecimal dSettled;

    @ApiModelProperty(value = "佣金明细集合")
    private List<PaymentdetailsVo> paymentdetails;

    /** 核算单名称 */
    @ApiModelProperty(value = "核算单名称")
    private String examineName;

    @ApiModelProperty(value = "追加状态")
    private int appendStatus;

    @ApiModelProperty(value = "追加的模板类型")
    private int appendType;
    @ApiModelProperty(value = "服务费扣减金额")
    private BigDecimal tgdeuctval;

    @ApiModelProperty(value = "接待费扣减金额")
    private BigDecimal dlfdeuctval;

    @ApiModelProperty(value = "服务费扣减说明")
    private String tgdeuctexplan;

    @ApiModelProperty(value = "接待费扣减说明")
    private String dlfdeuctexplan;
}
