package com.huaxia.hx_sell_commission.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.huaxia.hx_sell_commission.domain.ExamineBill;
import com.huaxia.hx_sell_commission.domain.Settlebill;
import com.huaxia.hx_sell_commission.domain.SettlebillPaydetails;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.checkerframework.checker.formatter.qual.Format;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * 描述:
 * 结算单Vo
 * @author: zcj
 * @Date: 2020/11/30 15:21
 */
@Data
public class SettleBillVo extends Settlebill {

    /** 起始时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty(value = "起始时间")
    private Date startTime;

    /** 结束时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty(value = "结束时间")
    private Date endTime;

    /** 结算总金额 */
    @ApiModelProperty(value = "结算总金额")
    private BigDecimal pay;

    /** 核算单金额 */
    @ApiModelProperty(value = "核算单金额")
    private BigDecimal Total;

    /** 核算单ID*/
    @ApiModelProperty(value = "核算单ID")
    private  String examineid;

    /** 核算单ids*/
    private List<String> examineids;

    /** 核算单名称 */
    @ApiModelProperty(value = "核算单名称")
    private  String examinename;

    /** 楼栋 */
    @ApiModelProperty(value = "楼栋")
    private String BldName;

    /** 房号 */
    @ApiModelProperty(value = "房号")
    private String RoomGUID;

    /** 客户姓名 */
    @ApiModelProperty(value = "客户姓名")
    private String CstName;

    /** 产品类型 */
    @ApiModelProperty(value = "产品类型")
    private String ProductName;

    /** 业务类型 */
    @ApiModelProperty(value = "业务类型")
    private String BusinessType;

    /** 交易ID */
    @ApiModelProperty(value = "交易ID")
    private String Tradeguid;

    /** 交易状态 */
    @ApiModelProperty(value = "交易状态")
    private String TradeStatus;

    /** 认购金额 */
    @ApiModelProperty(value = "认购金额")
    private BigDecimal CjTotal;

    /** 签约金额 */
    @ApiModelProperty(value = "签约金额")
    private BigDecimal RmbHtTotal;

    /** 成交报备人 */
    @ApiModelProperty(value = "成交报备人")
    private String Refer;

    /** 所属公司（报备） */
    @ApiModelProperty(value = "所属公司（报备）")
    private String ReferAgentName;

    /** 成交接待人 */
    @ApiModelProperty(value = "成交接待人")
    private String Ywy;

    /** 所属公司（接待） */
    @ApiModelProperty(value = "所属公司（接待）")
    private String YwyAgentName;

    /** 团购费佣金手动 */
    @ApiModelProperty(value = "团购费佣金手动")
    private BigDecimal TGFee;

    /** 代理费佣金手动 */
    @ApiModelProperty(value = "代理费佣金手动")
    private BigDecimal AgentFee;

    /** 交易类型 */
    @ApiModelProperty(value = "交易类型")
    private String CjType;

    /** 状态（是否退房） */
    @ApiModelProperty(value = "状态（是否退房）")
    private Long planstatus;

    /** 佣金方案(1 团购费 2 代理费) */
    @ApiModelProperty(value = "佣金方案(1 团购费 2 代理费)")
    private Long planType;

    /** 节点 */
    @ApiModelProperty(value = "节点")
    private String NodeName;

    /** 支付节点ID */
    @ApiModelProperty(value = "支付节点ID")
    private String NodeID;

    /** 首批/末批 */
    @ApiModelProperty(value = "首批/末批 ")
    private Long PayBatch;

    /** 支付金额 */
    @ApiModelProperty(value = "支付金额")
    private BigDecimal Payable;

    /** 佣金明细ID */
    @ApiModelProperty(value = "佣金明细ID")
    private String PayID;

    /** 扣支付总金额 */
    @ApiModelProperty(value = "扣支付总金额")
    private BigDecimal PayTotal;

    /** 不予结算部分 */
    @ApiModelProperty(value = "不予结算部分")
    private Long NoPay;

    /** 人员ID */
    @ApiModelProperty(value = "人员ID")
    private String userID;

    /** 人员 */
    @ApiModelProperty(value = "人员")
    private String user;

    /** 类别ID */
    @ApiModelProperty(value = "类别ID")
    private String Usertypeid;

    /** 类别 */
    @ApiModelProperty(value = "类别")
    private String UserTypeName;

    /** 岗位 */
    @ApiModelProperty(value = "岗位")
    private String JobName;

    /** 扣款金额 */
    @ApiModelProperty(value = "扣款金额")
    private BigDecimal TakeOff;

    /** 银行卡号 */
    @ApiModelProperty(value = "银行卡号")
    private String BankNo;

    /** 银行名 */
    @ApiModelProperty(value = "银行名")
    private String BankName;

    /** 佣金金额 */
    @ApiModelProperty(value = "佣金金额")
    private BigDecimal Total2;

    /** 支付金额 */
    @ApiModelProperty(value = "支付金额")
    private BigDecimal money;

    /** 佣金合计 */
    @ApiModelProperty(value = "佣金合计")
    private BigDecimal sum1;

    /** 扣除金额合计 */
    @ApiModelProperty(value = "扣除金额合计")
    private BigDecimal sum2;

    /** 支付金额合计 */
    @ApiModelProperty(value = "支付金额合计")
    private BigDecimal sum3;

    /** 结算单提交日期 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty(value = "结算单提交日期 ")
    private Date comitdata;

    /** 结算单作废日期*/
    @JsonFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty(value = "结算单作废日期 ")
    private Date zfDate;

    /** 审批通过时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty(value = "审批通过时间")
    private Date ApprovalDate;

    /** 工作流程参数 */
    @ApiModelProperty(value = "工作流程参数")
    private String businesskey;

    /** 是否选中 */
    @ApiModelProperty(value = "是否选中")
    private Long ischecked;

    private TradeVo tradeguidList;

    /** payID */
    @ApiModelProperty(value = "payID")
    private List<String> payids;

    /** 核算单集合 */
    @ApiModelProperty(value = "核算单集合")
    private List<ExamineBillVo> examineBillList;

    /** 明细集合 */
    @ApiModelProperty(value = "明细集合")
    List<SettlebillPaydetailsVo> settleBillVo;

    /* 按钮权限 */
    @ApiModelProperty(value = "按钮权限列表")
    private List<String> button;

    /* 修改原因 */
    @ApiModelProperty(value = "修改原因")
    private String updateReason;

    @ApiModelProperty(value = "项目ID集合")
    private List<String> projectIds;

}
