package com.huaxia.hx_sell_commission.vo;

import com.huaxia.hx_sell_commission.domain.*;
import com.huaxia.hx_sell_commission.utils.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;


/**
 * 对象 trade
 * 
 * @author shilei
 * @date 2020-11-18
 */
@Data
public class TradeVo extends Trade {

    @ApiModelProperty(value = "佣金方案详情对象")
    private PlanVo planVo;

    @ApiModelProperty(value = "佣金方案费用信息对象")
    private Planfee planfee;

    @ApiModelProperty(value = "客户信息")
    private TradeCustomer tradeCustomer;

    @ApiModelProperty(value = "是否退房")
    private String ishouse;

    @ApiModelProperty(value = "佣金方案生成状态集合")
    private List<Integer> statusList;

    @ApiModelProperty(value = "筛选条件状态为退房时传：关闭")
    private String isTradeStatus;

    @ApiModelProperty(value = "创建开始时间")
    private Date startDate;

    @ApiModelProperty(value = "创建结束时间")
    private Date endDate;

    @ApiModelProperty(value = "筛选条件公司ID")
    private String buguId;

    @ApiModelProperty(value = "筛选条件项目ID")
    private String projectId;

    @ApiModelProperty(value = "筛选条件项目分期ID")
    private String projGUId;

    @ApiModelProperty(value = "交易ID集合")
    private List<String> tradeguidList;

    @ApiModelProperty(value = "方案模板集合")
    private List<Paymenttemp> paymenttemps;

    @ApiModelProperty(value = "佣金方案明细")
    private List<Paymentdetails> paymentdetails;

    @ApiModelProperty(value = "佣金方案明细")
    private List<Paymentdetails> paymentdetailsList;

    @ApiModelProperty(value = "团购费佣金手动")
    private BigDecimal tgfee;

    @ApiModelProperty(value = "代理费佣金手动")
    private BigDecimal agentfee;

    /* 按钮权限 */
    @ApiModelProperty(value = "按钮权限列表")
    private List<String> button;

    @ApiModelProperty(value = "方案状态")
    private Integer planStatus;

    /* 核算单类 */
    @ApiModelProperty(value = "核算单类")
    private ExaminebillTrade examinebillTrade;

    /* 核算单类 */
    @ApiModelProperty(value = "核算单类")
    private ExamineBillVo examineBillVo;

    /* 是否勾选 */
    @ApiModelProperty(value = "是否勾选,0未勾选， 1已勾选")
    private String isChecked;

    /* 客户姓名 */
    @ApiModelProperty(value = "客户姓名")
    private String cstname;

    @ApiModelProperty(value = "编辑页")
    private Integer editPageNum;

    /** 核算单ID */
    @ApiModelProperty(value = "核算单修改时传参带的核算单id")
    private String examineid;


    /** 核算单名称 */
    @ApiModelProperty(value = "核算单名称")
    private String examineName;

    /** 已结算金额 */
    @ApiModelProperty(value = "已结算金额")
    private BigDecimal jsMoney;

    @ApiModelProperty(value = "核算单状态")
    private BigDecimal examineBillStatus;

    @ApiModelProperty(value = "核算单ID")
    private String examineID;


    @ApiModelProperty(value = "佣金明细id")
    private String payId;

    //==================================================
    /** 佣金包占可支配收入比例 */
    @Excel(name = "佣金包占可支配收入比例")
    @ApiModelProperty(value = "佣金包占可支配收入比例")
    private Long paymentpack;

    /** 税金比例：
     */
    @Excel(name = "税金比例")
    @ApiModelProperty(value = "税金比例：")
    private Long taxes;

    /** 1 系统抓取 2 固定金额 */
    @Excel(name = "1 系统抓取 2 固定金额")
    @ApiModelProperty(value = "1 系统抓取 2 固定金额")
    private Long tokerfeetype;

    @ApiModelProperty(value = "佣金_拓客费用金额")
    private BigDecimal tokerfee;

    @ApiModelProperty(value = "佣金_自销管理费比例")
    private Long manageratio;

    @ApiModelProperty(value = "佣金_支配收入比例")
    private Long controlratio;

    /** 1 比例 2 固定金额 */
    @Excel(name = "1 比例 2 固定金额")
    @ApiModelProperty(value = "1 比例 2 固定金额")
    private Long agencyfeetype;

    @ApiModelProperty(value = "代理费用金额")
    private BigDecimal agencyFee;

    @ApiModelProperty(value = "1 比例 2 固定金额")
    private Long jfbondtype;

    /** 交房保证金数值 */
    @Excel(name = "交房保证金数值")
    @ApiModelProperty(value = "交房保证金数值")
    private BigDecimal jfbond;

    /** 已冲抵金额 */
    @Excel(name = "已冲抵金额")
    @ApiModelProperty(value = "已冲抵金额")
    private BigDecimal offsetMoney;

    /** 最后一笔冲抵日期 */
    @Excel(name = "最后一笔冲抵日期")
    @ApiModelProperty(value = "最后一笔冲抵日期")
    private Date lastOffsetDate;

    /** 是否完全冲抵 1是 0否 */
    @Excel(name = "是否完全冲抵 1是 0否")
    @ApiModelProperty(value = "是否完全冲抵 1是 0否")
    private Integer isFullOffset;

    /** 付款方式 */
    @Excel(name = "付款方式")
    @ApiModelProperty(value = "付款方式")
    private String payFormClass;

    /** 业态 */
    @Excel(name = "业态")
    @ApiModelProperty(value = "业态")
    private String ProductName;

    /** 分公司 */
    @Excel(name = "分公司")
    @ApiModelProperty(value = "分公司")
    private String orgName;

}
